####################################################################################
# File: 			defs.tcl
# Purpose:			Useful definitions
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 20/Nov/2017	First version
# 1.01 19/Aug/2019	Bugfixes and additions
####################################################################################
# Notes:	Useful definitions
#			Will [undef] before setting so the file can be re-included
####################################################################################

unset CHAR_MIN -const -nocomplain
unset CHAR_MAX -const -nocomplain
unset UCHAR_MIN -const -nocomplain
unset UCHAR_MAX -const -nocomplain
unset SHORT_MIN -const -nocomplain
unset SHORT_MAX -const -nocomplain
unset USHORT_MIN -const -nocomplain
unset USHORT_MAX -const -nocomplain
unset LONG_MIN -const -nocomplain
unset LONG_MAX -const -nocomplain
unset ULONG_MIN -const -nocomplain
unset ULONG_MAX -const -nocomplain
unset INT_MIN -const -nocomplain
unset INT_MAX -const -nocomplain
unset UINT_MIN -const -nocomplain
unset UINT_MAX -const -nocomplain

####################################################################################

const CHAR_MIN -128
const CHAR_MAX 127

const UCHAR_MIN 0
const UCHAR_MAX 255

const SHORT_MIN -32768
const SHORT_MAX 32767

const USHORT_MIN 0
const USHORT_MAX 65535

const LONG_MIN -2147483648
const LONG_MAX 2147483647

const ULONG_MIN 0
const ULONG_MAX 4294967295

#const INT_MIN [+ -9223372036854775808 1]		# FIX
const INT_MIN -9223372036854775808
const INT_MAX 9223372036854775807

const UINT_MIN 0
const UINT_MAX 18446744073709551615

# BITS ###################################

unset CHAR_BITS -const -nocomplain
const CHAR_BITS 8
unset UCHAR_BITS -const -nocomplain
const UCHAR_BITS 8

unset SHORT_BITS -const -nocomplain
const SHORT_BITS 16
unset USHORT_BITS -const -nocomplain
const USHORT_BITS 16

unset LONG_BITS -const -nocomplain
const LONG_BITS 32
unset ULONG_BITS -const -nocomplain
const ULONG_BITS 32

unset INT_BITS -const -nocomplain
const INT_BITS 64
unset UINT_BITS -const -nocomplain
const UINT_BITS 64

unset DOUBLE_BITS -const -nocomplain
const DOUBLE_BITS 64 # 8

# EOF #