######################################################################################
# File: 			test_arp.tcl
# Purpose:			Test for lib ticol_arp
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.00 22/Oct/2017	First version
# 1.01 18/Jul/2018	Added a few more tests
######################################################################################
# Notes: 
######################################################################################

option expression off

lib ticol_ping -nocomplain
lib ticol_arp -nocomplain

ping 127.0.0.1
catch {
	if {<= [* [info winver -vernum] 10] 5.0} {		# Currently all running on VMs
		puts "\[arp 10.0.2.2 -list\] == [arp 127.0.0.1 -list] @"#__LINE__
	}
	puts "\[arp 127.0.0.1 -list\] == [arp 127.0.0.1 -list] @"#__LINE__
	assert [arp 127.0.0.1] {ne $_ ""} -v -line #__LINE__
}
puts "\[arp {} -list\]=[arp {} -list]"
assert [lindex [arp {} -list] 1] {== $_ 0} -v -line #__LINE__
newline

textcolor cyan
puts "\[rarp 52-54-00-12-35-02\] == [rarp 52-54-00-12-35-02]"	# Lenovo
puts "\[rarp pqrs -list\] == [rarp pqrs -list]"					# BAD MAC address
assert [lindex [rarp pqrs -list] 1] {== $_ 3} -v -line #__LINE__
puts "\[rarp {} -list\] == [rarp pqrs -list]"					# NULL MAC address
assert [lindex [rarp {} -list] 1] {== $_ 4} -v -line #__LINE__

newline
textcolor yellow
puts "Print ARP table..."
textcolor magenta
newline
set t [arp table]
foreach l $t {					# foreach list item
	foreach {i m s} $l {		# IP, MAC, Status
		puts "$i\t$m\t$s"
	}
}


lib ticol_ping -unload
lib ticol_arp -unload


######################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #