#################################################################################
# File: 			test_array_set.tcl
# Purpose:			Tests for complex [array set]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Jan/2018	First version
# 1.01 06/Oct/2019	Added space-delimited subscript test
#################################################################################
# Notes:
#################################################################################

option expression off
option echo on

/*		# Check list
puts "Line "#__LINE__
puts "list='[list \
        a  1   b  2   c  3   d  4   e  5 \
        f  6   g  7   h  8   i  9   j 10 \
        k 11   l 12   m 13   n 14   o 15 \
        p 16   q 17   r 18   s 19   t 20 \
        u 21   v 22   w 23   x 24   y 25 \
        z 26                             \
                         \
         1 a    2 b    3 c    4 d    5 e \
         6 f    7 g    8 h    9 i   10 j \
        11 k   12 l   13 m   14 n   15 o \
        16 p   17 q   18 r   19 s   20 t \
        21 u   22 v   23 w   24 x   25 y \
        26 z]'"
*/

puts "Line "#__LINE__
array set map [list \
        a  1   b  2   c  3   d  4   e  5 \
        f  6   g  7   h  8   i  9   j 10 \
        k 11   l 12   m 13   n 14   o 15 \
        p 16   q 17   r 18   s 19   t 20 \
        u 21   v 22   w 23   x 24   y 25 \
        z 26                             \
                         \
         1 a    2 b    3 c    4 d    5 e \
         6 f    7 g    8 h    9 i   10 j \
        11 k   12 l   13 m   14 n   15 o \
        16 p   17 q   18 r   19 s   20 t \
        21 u   22 v   23 w   24 x   25 y \
        26 z]

puts "Line "#__LINE__
for {set i 1} {< $i 27} {++ i} {
	#puts "Test '[chr $i 96]' == $i"
	assert $map([chr $i 96]) {== $_ $i} -v -line #__LINE__
}

newline
textcolor yellow
puts "Phase 2 (inverse) @"#__LINE__
textcolor

for {set i 1} {< $i 27} {++ i} {
	#puts "Test '$i' == [chr $i 96]"
	assert $map($i) {== $_ [chr $i 96]} -v -line #__LINE__
}

puts "Line "#__LINE__
array unset map -nocomplain
if {array exists map} {
	die "Array map still exists"
}

array set map {
        a  1   b  2   c  3   d  4   e  5 \
        f  6   g  7   h  8   i  9   j 10 \
        k 11   l 12   m 13   n 14   o 15 \
        p 16   q 17   r 18   s 19   t 20 \
        u 21   v 22   w 23   x 24   y 25 \
        z 26                             \
                         \
         1 a    2 b    3 c    4 d    5 e \
         6 f    7 g    8 h    9 i   10 j \
        11 k   12 l   13 m   14 n   15 o \
        16 p   17 q   18 r   19 s   20 t \
        21 u   22 v   23 w   24 x   25 y \
        26 z
		}

array walk map

newline
textcolor yellow
puts "Phase 3 - Assigned without \[list\] @"#__LINE__
textcolor

for {set i 1} {< $i 27} {++ i} {
	#puts "Test '[chr $i 96]' == $i"
	assert $map([chr $i 96]) {== $_ $i} -v -line #__LINE__
}

newline
textcolor yellow
puts "Phase 2 (inverse) @"#__LINE__
textcolor

for {set i 1} {< $i 27} {++ i} {
	#puts "Test '$i' == [chr $i 96]"
	assert $map($i) {== $_ [chr $i 96]} -v -line #__LINE__
}

array unset map -nocomplain
unset i -nocomplain

#################################################################################
# Space-delimited subscript
puts "Line: "#__LINE__
array unset array -nocomplain

set array(sub\ script) Hello
puts "Line: "#__LINE__
array walk array

# FIX quoted string doesn't unescape escaped spaces '\ '
# Valid only 'naked'
# evalResolveArray
# picolGetVarExNF
puts "Line: "#__LINE__
puts "Embedded string: array(sub\ script) is '" -nonewline
puts $array(sub\ script) -nonewline
puts "' @"#__LINE__

puts "Line: "#__LINE__
assert $array(sub\ script) {eq $_ Hello} -v -line #__LINE__

puts "Line: "#__LINE__
assert [format %s $array(sub\ script)] {eq $_ Hello} -v -line #__LINE__
array unset array -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #