###############################################################
# File: 			test_array_size.tcl
# Purpose:			Testing [array size]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 20/Aug/2016	First version
# 1.01 20/Dec/2016	Rewritten as a test
# 1.02 21/Jun/2017	Replace [checkex] with [assert]
###############################################################
# Notes: 
###############################################################

textcolor yellow
puts "Testing \[array size\] ..."
textcolor
newline

set expression_state [option expression]
option expression off
set echostate [option echo]
option echo on
unset a -nocomplain
unset b -nocomplain
unset c -nocomplain
unset d -nocomplain

# a				# Not declared at all
set b {}		# Not an array
dim c 1			# Empty array
set d(1) 0		# Assigned

puts "Undeclared a  '[array size a]'"
assert [array size a] {eq $_ {}} -v -line #__LINE__

puts "Non-array b   '[array size b]'"
assert [array size b] {eq $_ {}} -v -line #__LINE__

puts "Empty-array c '[array size c]'"
assert [array size c] {== $_ 0} -v -line #__LINE__

puts "Declared d    '[array size d]'"
assert [array size d] {== $_ 1} -v -line #__LINE__

puts "const env array size    '[array size env]'"
assert [array size env] {> $_ 1} -v -line #__LINE__

array unset b -nocomplain
array unset c -nocomplain
array unset d -nocomplain

##########################################
option echo $echostate
option expression $expression_state

unset echostate expression_state -nocomplain
vars

newline
textcolor green
puts "Done"
textcolor

# EOF #