###########################################################################
# Name:				test_array_swap.tcl
# Purpose:			Test file for [array swap]
# Author:       	M Shaw
# Language:			Ticol Tcl v1.27
#
# Versions:
# 1.00 04/Jan/2023	First version (first implemented)
###########################################################################
# Notes:
# Unit test via tests.tcl
###########################################################################

set a(0) Hello
set a(1) world

assert $a(0) {eq $_ Hello} -v line #__LINE__
assert $a(1) {eq $_ world} -v line #__LINE__

puts "Line "#__LINE__
array walk a
newline

puts "Line "#__LINE__
array swap a 0 1
newline

puts "Line "#__LINE__
puts "$a(0) $a(1) (reversed)"
array walk a

assert $a(0) {eq $_ world} -v line #__LINE__
assert $a(1) {eq $_ Hello} -v line #__LINE__

/*
# leak test
# 04/Jan/2023 (no leaks)
loop 1000000 {
	array swap a 0 1
}
# */
array unset a
###########################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor
# EOF #
