############################################################################################
# File:				test_array_to_list.tcl
# Author:			M Shaw
# Purpose:			Test file for [array_to_list]
#
# Versions:
# 1.00 30/Jun/2018 First version
###########################################################################################
# Notes:
###########################################################################################

array set a {
	0 Hello
	1 from
	2 Ticol
	3 Tcl
}

set l [array_to_list a]

puts $l

assert $a(0) {eq $_ Hello} -v -line #__LINE__

puts [lsearch $l "0 Hello"]
set ix [lsearch $l "0 Hello"]
puts [lindex $l $ix]

assert [lindex $l $ix] {eq $_ "0 Hello"} -v -line #__LINE__
assert [lindex $l $ix 1] {eq $_ "Hello"} -v -line #__LINE__
assert [lcount $l] {== $_ 4} -v -line #__LINE__

set l [array_to_list a -values]
puts $l
#assert $l {eq $_ "0 Hello"} -v -line #__LINE__

puts [lsearch $l Ticol]
set ix [lsearch $l Ticol]
assert [lindex $l $ix] {eq $_ Ticol} -v -line #__LINE__

array unset a -nocomplain
unset l ix -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #