###############################################################
# File: 			test_arrayforeach.tcl
# Purpose:			Testing [array foreach]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 19/Aug/2016	First version
###############################################################
# Notes: Various tests
###############################################################

set expression_state [option expression]
option expression off
set echostate [option echo]
###############################################################

set line #__LINE__
puts "Line: $line"
unset x -nocomplain
set size [array size env]
set i 0
array foreach env x {
	incr i
}
if {!= $i $size} {
	die "Mismatch calculating array size"
}
puts "i is $i, size is $size"
newline

set line #__LINE__
puts "Line: $line"
unset x -nocomplain
unset y -nocomplain

set found $false
array foreach env x y {
	#puts "x: '$x', y: '$y'"
	if {eq $y "path" -nocase} {set found $true}
}
if {! $found} {
	die "Failed to locate PATH in ENV"
}
newline

option echo $echostate
option expression $expression_state

unset echostate expression_state found i line size -nocomplain

vars

###############################################################

newline
textcolor green
puts "\[array foreach\] tests done"
textcolor

# EOF #