########################################################################
# File: 			test_asc_chr.tcl
# Purpose:			Tests for [asc] and [chr]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 09/Oct/2018	More tests added
########################################################################
# Notes:
# New command with provisional name
########################################################################
option expression off

textcolor yellow
puts "Testing \[asc\] ..."
textcolor
newline

puts "Line: "#__LINE__
# puts [asc "]"] - FIX eval: Command or proc '0"]' was not found (autoexec is OFF)
#puts [asc "]"]	# FAIL 91
assert [asc "\["] {== $_ 91} -v -line #__LINE__
assert [asc "\\"] {== $_ 92} -v -line #__LINE__
#assert [asc "\"] {== $_ 92} -v -line #__LINE__	# Correctly trapped by MPP
assert [asc "\]"] {== $_ 93} -v -line #__LINE__
assert [asc "\{"] {== $_ 123} -v -line #__LINE__
assert [asc "\}"] {== $_ 125} -v -line #__LINE__
assert [asc "\$"] {== $_ 36} -v -line #__LINE__
puts "[chr 34]"
assert [asc "\""] {== $_ 34} -v -line #__LINE__
puts "[chr 40]"
assert [asc "("] {== $_ 40} -v -line #__LINE__
assert [asc "\("] {== $_ 40} -v -line #__LINE__
puts "[chr 41]"
assert [asc ")"] {== $_ 41} -v -line #__LINE__
assert [asc "\)"] {== $_ 41} -v -line #__LINE__

########################################################################

textcolor yellow
puts "Testing \[chr\] ..."
textcolor
newline

puts "Line: "#__LINE__
#assert [chr 34] {== $_ "\""} -v -line #__LINE__			# FAILS (can't compare in braces)
assert [chr 0] {== $_ ""} -v -line #__LINE__				# Will return a null string, which is ok
assert [chr 65] {== $_ "A"} -v -line #__LINE__
assert [chr 40] {== $_ "("} -v -line #__LINE__
assert [chr 41] {== $_ ")"} -v -line #__LINE__
#assert [chr 91] {== $_ [escape "\["]} -v -line #__LINE__	# FAILS compare step

vars

########################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #