######################################################################################
# File: 			test_at_exit.tcl
# Purpose:			Test [at_exit]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 16/Oct/2019	First version
######################################################################################
# Notes:
# Test to ensure that we can't redefine at_exit
######################################################################################

textcolor yellow
puts "Test test_at_exit.tcl-> \[at_exit\] redefinition block ..."
textcolor
newline

undef at_exit -nocomplain 		# Allow 1st definition
proc at_exit {} {
	puts "proc \[at_exit\] was called in script test_at_exit.tcl @ line: "#__LINE__

}

set i 0
try {
	proc at_exit {} {
		puts "It should not be possible to re-define \[at_exit\]"
		puts "If you can see this, something went wrong in test_at_exit.tcl"
	}
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #