###################################################################################
# File: 			test_bitandor.tcl
# Purpose:			Test some bitwise ops
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 23/Sep/2019	First version
###################################################################################
# Notes:
###################################################################################

assert [& 7 0] {== $_ 0} -v -line #__LINE__
assert [& 7 1] {== $_ 1} -v -line #__LINE__
assert [& 7 2] {== $_ 2} -v -line #__LINE__
assert [& 7 3] {== $_ 3} -v -line #__LINE__
assert [& 7 4] {== $_ 4} -v -line #__LINE__
assert [& 7 5] {== $_ 5} -v -line #__LINE__
assert [& 7 6] {== $_ 6} -v -line #__LINE__
assert [& 7 7] {== $_ 7} -v -line #__LINE__

assert [& 7 0] {== $_ 0} -v -line #__LINE__
assert [& 7 -1] {== $_ 7} -v -line #__LINE__
assert [& 7 -2] {== $_ 6} -v -line #__LINE__
assert [& 7 -3] {== $_ 5} -v -line #__LINE__
assert [& 7 -4] {== $_ 4} -v -line #__LINE__
assert [& 7 -5] {== $_ 3} -v -line #__LINE__
assert [& 7 -6] {== $_ 2} -v -line #__LINE__
assert [& 7 -7] {== $_ 1} -v -line #__LINE__

###################################################################################
/* # Implemented as [sbool]
proc vbbool x {
	if {$x} {
		return -1
	}
	return 0
} #*/

###################################################################################
# BASIC/VB5 signed booleans
# This is behaviour which is silent under VB and could cause errors
#
# ? 7 and -8 < -5	== 7
# ? 7 and (-8 < -5)	== 7		# Relationship has priority over bitops
# ? 7 and int(-8 < -5)	== 1
# ? 7 and abs(-8 < -5)	== 7
# ? 7 and true 		== 7		# Because in BASIC, TRUE is -1 (0xffff...)
# ? 7 and 1 		== 1
# BASIC (7 AND -8 < -5) == 
assert [sbool 1] {== $_ -1} -v -line #__LINE__		# 0xffff...
assert [sbool 0] {== $_ 0} -v -line #__LINE__		# 0xffff...

#assert [& 7 [< -8 -5]] {== $_ 0} -v -line #__LINE__	# 0, BASIC is -7
assert [& [sbool [< -8 -5]] 7] {== $_ 7} -v -line #__LINE__		# 1, BASIC is 7
assert [& [funct abs [sbool [< -8 -5]]] 7] {== $_ 1} -v -line #__LINE__		# 1, BASIC is 7


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #\a
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #