#################################################################################
# File: 			test_bitops.tcl
# Purpose:			Tests for [bit] command
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 11/Feb/2018	First version (separate stores implemented)
#################################################################################
# Notes:
# These values are deliberately unsigned
#################################################################################

option expression off

if {defined bit} {

	# Control 0

	puts "invert 0x1(8) [bit invert 0x0 -8] [inttobin [bit invert 0x0 -8]]"			# FIX
	assert [bit invert 0x0 -8] {eq $_ 0} -v -line #__LINE__

	puts "invert 0x1(16) [inttobin [bit invert 0x1 -16]]"			# FIX
	assert [bit invert 0x0 -16] {eq $_ 0} -v -line #__LINE__

	puts "invert 0x1(32) [inttobin [bit invert 0x1 -32]]"			# FIX
	assert [bit invert 0x0 -32] {eq $_ 0} -v -line #__LINE__

	puts "invert 0x1(64) [inttobin [bit invert 0x1]]"			# FIX
	assert [bit invert 0x0] {eq $_ 0} -v -line #__LINE__
	newline
	
	# 0x1
	puts "invert 0x1(8) [bit invert 0x1 -8] [inttobin [bit invert 0x1 -8]]"			# FIX
	assert [bit invert 0x1 -8] {eq $_ 128} -v -line #__LINE__

	puts "invert 0x1(16) [inttobin [bit invert 0x1 -16]]"			# FIX
	assert [bit invert 0x1 -16] {eq $_ 32768} -v -line #__LINE__

	puts "invert 0x1(32) [inttobin [bit invert 0x1 -32]]"			# FIX
	assert [bit invert 0x1 -32] {eq $_ 2147483648} -v -line #__LINE__

	puts "invert 0x1(64) [inttobin [bit invert 0x1]]"			# FIX
	assert [bit invert 0x1] {eq $_ 9223372036854775808} -v -line #__LINE__
	newline

	# Invert
	puts "invert 0x80(8) [bit invert 0x80 -8] [inttobin [bit invert 0x80 -8]]"			# FIX
	assert [bit invert 0x80 -8] {eq $_ 1} -v -line #__LINE__

	puts "invert 0x8000(16) [inttobin [bit invert 0x8000 -16]]"			# FIX
	assert [bit invert 0x8000 -16] {eq $_ 1} -v -line #__LINE__

	puts "invert 0x80000000(32) [inttobin [bit invert 0x80000000 -32]]"			# FIX
	assert [bit invert 0x80000000 -32] {eq $_ 1} -v -line #__LINE__

	puts "invert 0x8000000000000000(64) [inttobin [bit invert 0x8000000000000000]]"			# FIX
	assert [bit invert 0x8000000000000000] {eq $_ 1} -v -line #__LINE__
	newline	

	# Invert
	puts "invert 0x18(8) [bit invert 0x80 -8] [inttobin [bit invert 0x18 -8]]"			# FIX
	assert [bit invert 0x18 -8] {eq $_ 24} -v -line #__LINE__

	puts "invert 0x0180(16) [inttobin [bit invert 0x0180 -16]]"			# FIX
	assert [bit invert 0x0180 -16] {eq $_ 384} -v -line #__LINE__

	puts "invert 0x18000(32) [inttobin [bit invert 0x00018000 -32]]"			# FIX
	assert [bit invert 0x00018000 -32] {eq $_ 98304} -v -line #__LINE__

	puts "invert 0x1800000000(64) [inttobin [bit invert 0x1800000000]]"			# FIX
	assert [bit invert 0x1800000000] {eq $_ 206158430208} -v -line #__LINE__

} else {
	die "Command \[bit\] not defined - check version"
}



# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #