#####################################################################################
# File: 			test_bool.tcl
# Purpose:			Tests for booleans
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 22/Sep/2019	First version
#####################################################################################
# Notes:
# Introduction of non-var booleans via the MPP
#####################################################################################

# MPP translated 'free' bools were implemented but have been rolled back
# Mods to [assert] re: lvalue subst will cause hang near
#	source test_append.tcl
#	Testing string append using [store] [randomstr 1000]
# Mods required in [assert] to handle braced vars including bools will break randomstr
# Assert does not currently [subst] its Lvalues

assert [bool 1] {eq $_ "true"} -v -line #__LINE__
assert [bool $true] {eq $_ "true"} -v -line #__LINE__

assert [bool 0] {eq $_ "false"} -v -line #__LINE__
assert [bool $false] {eq $_ "false"} -v -line #__LINE__

# /*
assert $::true {== $_ 1} -v -line #__LINE__
assert [subst {$::true}] {== $_ 1} -v -line #__LINE__
#assert {$::true} {== $_ 1} -v -line #__LINE__
#assert { $::true} {== $_ 1} -v -line #__LINE__
#assert {$::true } {== $_ 1} -v -line #__LINE__
#assert { $::true } {== $_ 1} -v -line #__LINE__

assert $::false {== $_ 0} -v -line #__LINE__
#assert {$::false} {== $_ 0} -v -line #__LINE__
#assert { $::false} {== $_ 0} -v -line #__LINE__
#assert {$::false } {== $_ 0} -v -line #__LINE__
#assert { $::false } {== $_ 0} -v -line #__LINE__

# Experimental 'free' boolean vars (NYI)
/*
assert true {== $_ 1} -v -line #__LINE__
assert {true} {== $_ 1} -v -line #__LINE__
#assert { true} {== $_ 1} -v -line #__LINE__
#assert {true } {== $_ 1} -v -line #__LINE__
#assert { true } {== $_ 1} -v -line #__LINE__

assert false {== $_ 0} -v -line #__LINE__
assert {false} {== $_ 0} -v -line #__LINE__
#assert { false} {== $_ 0} -v -line #__LINE__
#assert {false } {== $_ 0} -v -line #__LINE__
#assert { false } {== $_ 0} -v -line #__LINE__
# */

##############################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #