###############################################################
# File: 			test_calc.tcl
# Purpose:			Test file for [calc]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 23/Aug/2016	First version
# 1.01 05/Aug/2018	Added another test expression
###############################################################
# Notes:
# ADD More tests
###############################################################

option expression off
#option breakpoint on
#halt

textcolor yellow
puts "Testing [info script]"
textcolor
newline

/*
if {! [defined checkex] } {
	proc checkex {x expr} {
		#puts "DEBUG: checkex \$x='$x' \$expr='$expr'"
		upvar i					# Pass-through reference integer 
		upvar line
		set NAN "-1.[calc [chr 35]]IND00000000000"
		set q {$x}			# This swaps x
		puts "Line $line: " -nonewline
		puts "'$q'=='$x' \[expr $expr\]: "	# fails here at EOF - poss (due to bug in callproc()?) - July 2016
		if { [eval $expr] } {
		} else {
			textcolor red
			puts "checkex assertion failed: '$q' -> '$x' after line $line"
			textcolor
			stop
		}
	}
}
*/

option expression push on
set q 23
set r {[calc "(1+3*2.5)/($q*$pi)+22/7.0"]}	# Will be optimised even if braced, but not evaluated
puts "Calc result q is '$r'"

assert $r {ne $_ [+ [/ [8.5] [* $q $pi]] [3.142857142857143]]} -v -line #__LINE__

/*
if {ne {$r} {[+ [/ [8.5] [* $q $pi]] [3.142857142857143]]} } {
	die "Calc failed"
} else {
	puts "calc result is: '{$r}'"	
}
newline
################################################################################ */
# (1+3*2.5)/(23*3.14159265358979323)+22/7.0
# Hand calculated
# 	8.5/72.2566310325652+3.14285714285714
#	0.117636262285314 + 3.14285714285714
#	3.26049340514245  (manual result)
# Expanded: (manual)
# [+ [/ [+ 1 [* 3 2.5]] [* 23 3.14159265358979323]] [/ 22 7.0]]
################################################################################ */
set q 23
# pi 3.14159265358979323
puts "Testing calc result against hand-coded reduction result"
puts "Check against: '"(1+3*2.5)/($q*$pi)+22/7.0"'"
set s [calc "(1+3*2.5)/($q*$pi)+22/7.0"]	# puts [+ [/ 8.500000000000000 [* $q $pi]] 3.142857142857143]
set t [expr "(1+3*2.5)/($q*$pi)+22/7.0"]
puts "VB5 result:    3.26049340514246"
puts "calc result s '$s'"		# 3.260493405142457
puts "expr result s '$t'"
assert [explain "(1+3*2.5)/($q*$pi)+22/7.0"] {eq $_ {[+ [/ [+ 1 [* 3 2.5]] [* 23 3.14159265358979323]] [/ 22 7.0]]}} -v -line #__LINE__
assert $s {== [round $_ 14] 3.26049340514246} -v -line #__LINE__
puts [explain "(1+3*2.5)/($q*$pi)+22/7.0"]
assert $t {== [round $_ 14] 3.26049340514246} -v -line #__LINE__
assert $s {== $_ $::t} -v -line #__LINE__

puts "q * pi is     '[* $q $pi]'"	# 72.256631032565238
puts "Manual calc:  '[+ [/ 8.500000000000000 72.256631032565238] 3.142857142857143]'"
puts "Check         '[+ [/ [8.5] [* $q $pi]] [3.142857142857143]]'"
puts "Calc result s '$s'"
assert $s {eq $_ [+ [/ [8.5] [* $q $pi]] [3.142857142857143]]} -v -line #__LINE__

/*
if {ne $s "[+ [/ [8.5] [* $q $pi]] [3.142857142857143]]" } {
	die "Calc failed"
} else {
	textcolor green
	puts "* PASS *"
	textcolor
}
*/

#option preprocessor off
puts [calc 2+2+2+2+2+2+2+2+2+2+2+2*0+2 -explain]
#option preprocessor on
assert [calc 2+2+2+2+2+2+2+2+2+2+2+2*0+2] {== $_ 24} -v -line #__LINE__

set f 3
assert [calc {$f+2-($f==3)}] {== $_ 4} -v -line #__LINE__
set f 3
assert [calc {$f+2-($f==1)}] {== $_ 5} -v -line #__LINE__

unset q r s t f u -nocomplain

option expression pop

###############################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor


# IN: "(1+(3*2.5))/($q*$pi)+(22/7.0)"
# [+ [/ [+ 1 [3 * 2.5]] [* $q $pi]]  [/ 22 7.0]]
# [+ [/ [+ 1 [7.5]] [* $q $pi]]  [3.142857142857143]]
# [+ [/ [8.5] [* $q $pi]]  [3.142857142857143]]

# EOF #