###########################################################################
# Name:				test_calc_bugs.tcl
# Purpose:			Dev checks on [calc] - Not a Unit test yet
# Author:       	M Shaw
# Language:			Ticol Tcl v1.19+, v1.26+
#
# Versions:
# 1.00 09/Sep/2016 First version
# 1.01 22/Jan/2022 Updated and current failure cases resolved
###########################################################################
# Notes:
###########################################################################
#/*
# FAILURE CASES
puts "Line: "#__LINE__

# FIXED Poss AOPM
# expr: Missing operand(s) at '-' (arity 2)
# expr: Missing operand(s) at '+' (arity 2)
assert [expr -7 + -7/7] {== $_ -8} -v -line #__LINE__		# PASS (VB -8)

#expr: Missing operand(s) at '-' (arity 2)
#expr: Missing operand(s) at '-' (arity 2)
assert [expr -7 - -7/-7] {== $_ -8} -v -line #__LINE__		# (VB -8)

assert [+ -7 [/ 7 7]] {== $_ -6} -v -line #__LINE__
puts "Line: "#__LINE__
puts [+ -7 -[/ 7 7]] # Correct (-8) (in situ string subtitution)
puts "Line: "#__LINE__

#*/

assert [expr -7 + (-7/7)] {== $_ -8} -v -line #__LINE__		# PASS (VB -8)
assert [calc -7 + -7/7] {== $_ -8} -v -line #__LINE__		# FAIL (VB -8) -7

puts "Line "#__LINE__
assert [expr -7 + +7/+7] {== $_ -6} -v -line #__LINE__		# FAIL (VB -8) -7
##exit

# expr bugs
puts "Line "#__LINE__
assert [expr (+7/+7)] {== $_ 1} -v -line #__LINE__	# 14
assert [expr +7/+7] {== $_ 1} -v -line #__LINE__  # 14

#/* FIXED
puts "Line "#__LINE__
# WRONG apply_operator_precedence_muldiv returning '7 + (7/7 + 7*7 - 7)'
# puts [+ 7 [- [- [* [+ [/ 7 7] 7] 7] 7]]]
puts "\[expr 7 + 7/7 + 7*7 - 7\] is [calc 7 + 7/7 + 7*7 - 7]"
puts "\[calc 7 + 7/7 + 7*7 - 7\] is [calc 7 + 7/7 + 7*7 - 7]"
assert [expr 7 + 7/7 + 7*7 - 7] {== $_ 50} -v -line #__LINE__
assert [calc 7 + 7/7 + 7*7 - 7] {== $_ 50} -v -line #__LINE__
#*/

# PASS
puts "Line: "#__LINE__
assert [calc +7 + +7/+7] {== $_ 8} -v -line #__LINE__		# PASS (VB==8)
assert [expr +7 + +7/+7] {== $_ 8} -v -line #__LINE__		# DONE FAIL -6 (VB==8)
assert [calc +7 + +7/+7] {== $_ 8} -v -line #__LINE__		# DONE FIX MPP fatal error


assert [calc -7 + -7/+7] {== $_ -8} -v -line #__LINE__		# PASS (VB -8) -7
assert [expr -7 + -7/+7] {== $_ -8} -v -line #__LINE__		# PASS (VB -8) -6
assert [calc -7 + +7/+7] {== $_ -6} -v -line #__LINE__		# PASS (VB -8) -7
assert [expr -7 + +7/+7] {== $_ -6} -v -line #__LINE__		# DONE FAIL (VB -8) -7
assert [calc -7 - -7/-7] {== $_ -8} -v -line #__LINE__		# (VB -8)


assert [expr +1+2+3+4+5] {== $_ 15} -v -line #__LINE__		# (VB 15) FAIL
assert [expr +1+2+3+4+5] {== $_ 15} -v -line #__LINE__		# (VB 15) PASS


/*
# Actually, this is correct
# [- [+ 1 [/ 2 3]] [* 4 4]] # Correct? VB5==-14.3333333333333
puts [calc 1+2/3-4*4 -explain]
assert [calc 1+2/3-4*4 -explain] {ne $_ ""} -v -line #__LINE__	 					# [- [+ 1 [/ 2 3]] [* 4 4]] WRONG
*/


###########################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor
# EOF #