#################################################################################
# File:				test_call.tcl
# Author:			M Shaw
# Purpose:			Test for [call]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 18/Sep/2018	First version
# 1.01 02/Jan/2020	Changes re: combined math op precision uprated to %.15f
#################################################################################
# Notes:
#################################################################################

option expression off

textcolor yellow
puts "Testing call ... @"#__LINE__
textcolor
newline

assert [defined call] {== $_ 1} -v -line #__LINE__

assert [call + 2 2] {== $_ 4} -v -line #__LINE__

undef foo -nocomplain
proc foo x {
	puts "Enter proc \[foo '$x'\] set? [is_set x] empty? [eq $x ""]"
	if {eq $x ""} {
		puts "foo x is empty"
		return 23
	} else {
		puts "foo x is NOT empty"
		return $x
	}
}

puts "Line: "#__LINE__
assert [call foo] {== $_ 23} -v -line #__LINE__
puts "Line: "#__LINE__
assert [call foo 21] {== $_ 21} -v -line #__LINE__
puts "Line: "#__LINE__
newline

undef foo -nocomplain
sub foo {
	return 11
}
assert [call foo] {== $_ 11} -v -line #__LINE__

undef foo -nocomplain

# Test call scriplet
# Check it!
set a 0
set b 0

++ a 10
+= b $pi
set a [/ $a $b]
puts {a is $a}
puts {b is $b}

# Test call {scriplet}
# Do it!
set a 0
set b 0
call {++ a 10;+= b $pi;set a [/ $a $b]; puts "a is $a"; puts "b is $b"}
#	3.183098510851024	Dec 2019 (with %f)
#	3.183098861837907	Jan 2020 (with %.15f)
assert $a {== $_ 3.183098861837907} -v -line #__LINE__

unset a b -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #