#######################################################################
# File:				test_charcount.tcl
# Author:			M Shaw
# Purpose:			Tests for [charcount]
# Language:			Ticol Tcl v1.20c+
#
# Versions:
# 1.00 26/Nov/2016	First version
# 1.01 22/Jul/2017	Replaced [checkex] with [assert]
#######################################################################
# Notes:
#######################################################################
puts "Turning preprocessor OFF"
option PreProcessor push off

assert [charcount $qbf a]                           {== $_ 1} -v -line #__LINE__
assert [charcount $qbf r]                           {== $_ 2} -v -line #__LINE__
assert [charcount $qbf t]                           {== $_ 1} -v -line #__LINE__
assert [charcount $qbf tT]                          {== $_ 2} -v -line #__LINE__
assert [charcount $qbf t -nocase]                   {== $_ 2} -v -line #__LINE__
assert [charcount $qbf tT -nocase]                  {== $_ 2} -v -line #__LINE__
assert [charcount $qbf aeiou]                       {== $_ 11} -v -line #__LINE__
assert [charcount $qbf fox]                         {== $_ 6} -v -line #__LINE__
assert [charcount "\[puts \"hello\"\]" "\\"]        {== $_ 4} -v -line #__LINE__
assert [charcount "c:\\windows\\system32\\" "\\"]   {== $_ 3} -v -line #__LINE__
assert [charcount "c:\\windows\\system32\\" "ws\\"] {== $_ 8} -v -line #__LINE__

option preprocessor pop

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars
newline
textcolor green
puts "* Done *"
textcolor
	
# EOF #