###############################################################
# File: 			test_chartok.tcl
# Purpose:			Test file for [chartok]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.27+
#
# Versions:
# 1.00 07/Dec/2017	First version
# 1.01 17/Jan/2023	Added -nocase
###############################################################
# Notes: 
###############################################################

option expression off

array unset a -nocomplain
unset count -nocomplain

set count [chartok $qbf " " a]

assert $count {== $_ 9} -v -line #__LINE__
assert $a(0) {eq $_ The} -v -line #__LINE__
assert $a(1) {eq $_ quick} -v -line #__LINE__
assert $a(2) {eq $_ brown} -v -line #__LINE__
assert $a(3) {eq $_ fox} -v -line #__LINE__
assert $a(4) {eq $_ jumps} -v -line #__LINE__
assert $a(5) {eq $_ over} -v -line #__LINE__
assert $a(6) {eq $_ the} -v -line #__LINE__
assert $a(7) {eq $_ lazy} -v -line #__LINE__
assert $a(8) {eq $_ dog} -v -line #__LINE__

array unset a -nocomplain
unset count -nocomplain

set s "Live-long and+prosper"
set count [chartok $s "+- " a]
# for {set i 0} {< $i $count} {++ i} {puts $a($i)}
assert $a(0) {eq $_ Live} -v -line #__LINE__
assert $a(1) {eq $_ long} -v -line #__LINE__
assert $a(2) {eq $_ and} -v -line #__LINE__
assert $a(3) {eq $_ prosper} -v -line #__LINE__

array unset a -nocomplain
unset count s -nocomplain

###############################################################
# -nocase
set s "Helloathere"
set count [chartok $s A a]
for {set i 0} {< $i $count} {++ i} {puts $a($i)}
assert $count {== $_ 1} -v -line #__LINE__

set count [chartok $s a a]
for {set i 0} {< $i $count} {++ i} {puts $a($i)}
assert $count {== $_ 2} -v -line #__LINE__

set count [chartok $s A a -nocase]
for {set i 0} {< $i $count} {++ i} {puts $a($i)}
assert $count {== $_ 2} -v -line #__LINE__
###############################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #