##############################################################################
# File:				test_chomp.tcl
# Author:			M Shaw
# Purpose:			Test the [chomp] command
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 07/Nov/2017	First version
##############################################################################
# Notes:
# Chomp is designed to efficiently and quickly slice up large strings
##############################################################################
# FIX handling leading and trailing spaces for [chomp var]
##############################################################################


option expression off

set s $qbf

# test -leave
set r [chomp s -leave]
assert $r {eq $_ The} -v -line #__LINE__
assert $s {eq $_ "The quick brown fox jumps over the lazy dog"} -v -line #__LINE__

# Test remove
set r [chomp s]
assert $r {eq $_ The} -v -line #__LINE__
assert $s {eq $_ " quick brown fox jumps over the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ quick} -v -line #__LINE__
assert $s {eq $_ " brown fox jumps over the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ brown} -v -line #__LINE__
assert $s {eq $_ " fox jumps over the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ fox} -v -line #__LINE__
assert $s {eq $_ " jumps over the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ jumps} -v -line #__LINE__
assert $s {eq $_ " over the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ over} -v -line #__LINE__
assert $s {eq $_ " the lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ the} -v -line #__LINE__
assert $s {eq $_ " lazy dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ lazy} -v -line #__LINE__
assert $s {eq $_ " dog"} -v -line #__LINE__
set r [chomp s]
assert $r {eq $_ dog} -v -line #__LINE__
assert $s {eq $_ ""} -v -line #__LINE__

newline
set s $qbf
set r [chomp s 9]
assert $r {eq $_ "The quick"} -v -line #__LINE__
assert $s {eq $_ " brown fox jumps over the lazy dog"} -v -line #__LINE__
set r [chomp s 10]
assert $r {eq $_ " brown fox"} -v -line #__LINE__
assert $s {eq $_ " jumps over the lazy dog"} -v -line #__LINE__
#FIX handling leading and trailing spaces for [chomp var N] above

# test -leave
set s $qbf
set r [chomp s 9 -leave]
assert $r {eq $_ "The quick"} -v -line #__LINE__
assert $s {eq $_ "The quick brown fox jumps over the lazy dog"} -v -line #__LINE__


unset r s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars
textcolor green
newline
puts "* Done *"
textcolor

# EOF #