######################################################################################
# File: 			test_clearconst.tcl
# Purpose:			Tests for method of clearing consts vars
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 15/Jul/2018	First version
######################################################################################
# Notes:
# We will use argc, argv
######################################################################################

option expression off

textcolor yellow
puts "Test clearing of a constant and reusing it..."
textcolor
newline

# Verify we start with const versions #

puts "argc is a const? [is_const argc]"
puts "argv is a const? [is_const argv]"
assert [is_const argc] {== $_ $::true} -v  -line #__LINE__
assert [is_const argv] {== $_ $::true} -v  -line #__LINE__

# Set argc #

unset argc -const -nocomplain
set argc 2
assert $argc {== $_ 2} -v -line #__LINE__

# Set argv #

unset argv -const -nocomplain
set argv(0) ""
set argv(1) Hello
assert $argv(0) {eq $_ ""} -v -line #__LINE__
assert $argv(1) {eq $_ "Hello"} -v -line #__LINE__

# Verify we end with non-const versions #

assert [is_const argc] {== $_ $::false} -v  -line #__LINE__
assert [is_const argv] {== $_ $::false} -v  -line #__LINE__

unset argc -nocomplain
array unset argv -nocomplain

# Verify that we unset #

assert [is_set argc] {== $_ $::false} -v  -line #__LINE__
assert [is_set argv] {== $_ $::false} -v  -line #__LINE__

vars

#############################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #