############################################################################################
# File: 			test_clipboard.tcl
# Purpose:			Test file for [clipboard]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 07/Dec/2017	First version
# 1.01 10/Jan/2022	Temp disabled as timing dependent
#					
############################################################################################
# Notes: 
# Clipboard appears timing-sensitive and might fail (moot fixes). Is ok on single tests
############################################################################################

option expression off

# clipboard_set clipboard_get
# clipboard_isempty
puts "[info script] Testing clipboard commands ..."
set line #__LINE__
if {! [clipboard isempty] } {
	clipboard clear
}
set line #__LINE__
puts "Line: $line"
clipboard clear
clipboard set "Hello"	# BUG not always setting for some reason. A delay improves. May need a post message
sleep 300
printf "Note: clipboard appears timing-sensitive and might fail (moot fixes)\n"
try {
	assert [clipboard get] {eq $_ "Hello"} -v -line #__LINE__
} catch {
	puts "Clipboard timing tests failed. This needs looking at but it timing-dependent"
}
clipboard clear

unset line -nocomplain

#####################################################
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #