######################################################################################
# File:				test_cmdcount.tcl
# Author:			M Shaw
# Purpose:			Testing [cmdcount] with a var large number of loops
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Aug/2019	First version
######################################################################################
# Notes:
# Not part of the main test routine
######################################################################################
# Memory (Kb):
# Loops				Start			End				Recorded as using 
# 10,000,000		2003			2392 (stable)	0Kb
# 10,000,000,000	2003			2396 (stable)	0Kb
######################################################################################

set loop::limit 10000000000					# 10,000,000,000

set start_cmd_count [cmdcount]
set start_mem [mem_used -ws]

loop i 0 $loop::limit {		# 0..$limit-1 ($limit)
	if {is_mod $i 10000} {
		console set_title "$_script_name - (Test loop [comma $loop::i] of [comma $loop::limit]) - Used: [comma [- [mem_used -ws] $start_mem]] Kb"
	}

	empty One "Two Three Four" 56 78.9
}

puts "Finish time [time]@[date]"
puts "It looks like we used (or lost) [- [mem_used -ws] $start_mem] Kb during the run"
# Assert that we used (lost) no more than 2048Kb (Units in Kb)
assert [- [mem_used -ws] $start_mem] {< $_ 2048} -v -line #__LINE__

textcolor green
puts "* Done *"
puts "Command count is '[cmdcount]'"
puts "Total command run: [- [cmdcount] $start_cmd_count]"
textcolor

beep 1000 700; beep 800 1000; beep 1000 500
pause 

