#############################################################################
# File:				test_concat.tcl
# Author:			M Shaw
# Purpose:			Test concat
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 14/Apr/2015	New file
# 1.01 21/Jan/2022	Updated as a very basic test
#############################################################################
# Notes:
# Add more tests....
#############################################################################

textcolor yellow
puts "Testing basic \[concat\] operations..."
textcolor
newline

puts "Test 1"
set a ""
set b "   Hello    "
puts -$b-
puts -[concat $a $b]-

puts "Test 2"
set a ""
set b ""
puts "Result:\t\t'[concat a b {c d e} {f {g h}}]'"
puts "Should be:\t'a b c d e f {g h}'"
assert [concat a b {c d e} {f {g h}}] {eq $_ "a b c d e f {g h}"} -v -line #__LINE__
newline

puts "Test 3"
set a ""
puts "Result:\t\t'[concat a b {{c} d e} {f {g {h}}}]'"
puts "Should be:\t'a b {c} d e f {g {h}}'"
assert [concat a b {{c} d e} {f {g {h}}}] {eq $_ "a b {c} d e f {g {h}}"} -v -line #__LINE__
newline

set a ""
puts "Not well-formed"
puts { a b {c " d " e} f}
puts "Result:\t\t'[concat " a b {c " d " e} f"]'"
puts "Should be:\t'a b {c*d*e} f'"
assert [concat " a b {c " d " e} f"] {eq $_ "a b {c d e} f"} -v -line #__LINE__
newline
puts "Done."

#############################################################################
unset a b -nocomplain
newline
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #