#############################################################################################
# File:				test_console.tcl
# Purpose:			Test console functions
# Author:			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 25/Oct/2018	Test cases
# 1.01 29/Jul/2019	Moved get/set title to test_console_title.tcl
#############################################################################################
# Notes:
# Doesn't test much. Just that the features don't crash the interpreter
#############################################################################################
# cls
# gotoxy
# console ...
# console close
# console hide
# console show
# console hidecursor
# console hidden
# #console get_title
# console move x y ?w? ?h?
# console scroll x y w h ?lines?
# console setfocus
# console showcursor
# #console set_title string
# integer [screen width | height | attribute | curx | cury]
#############################################################################################

textcolor yellow
puts "Testing \[console\]  and \[screen\] ..."
textcolor

puts "Line :"#__LINE__
#puts "[console attribute] @"#__LINE__
#assert [console attribute] {> $_ 0} -v -line #__LINE__
puts "[console curx] @"#__LINE__
assert [console curx] {> $_ 0} -v -line #__LINE__
puts "[console cury] @"#__LINE__
assert [console cury] {> $_ 0} -v -line #__LINE__
puts "[console width] @"#__LINE__
assert [console width] {> $_ 0} -v -line #__LINE__
puts "[console height] @"#__LINE__
assert [console height] {> $_ 0} -v -line #__LINE__

# integer [console width | height | attribute | curx | cury]
puts "Line :"#__LINE__
assert [screen width] {> $_ 0} -v -line #__LINE__
assert [screen height] {> $_ 0} -v -line #__LINE__

puts "Line :"#__LINE__
cls;cls;cls;cls;cls;cls;cls;cls;cls;cls;cls;cls;cls;

puts "Line :"#__LINE__
loop i 0 10 cls		# FIX GPF - 0..9 inclusive (10)


puts "Line :"#__LINE__
cls 176
loop i 0 20 {		# 0..19 inclusive (20)
	cls [chr 176] $i
	cls
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing \[gotoxy\] ..."
textcolor
gotoxy 1 1
loop i 0 5000 {		# 0..4999 inclusive (5000)
	gotoxy [rnd 1 78] [rnd 1 24]
	textcolor [+ [% $i 14] 1]
	puts "x" -nonewline
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing \[textcolor\] ..."
textcolor
gotoxy 1 1
loop i 0 100 {		# 0..99 inclusive (100)
	textcolor
	puts "x" -nonewline
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing console hide/show ..."
textcolor

puts "Line :"#__LINE__
loop i 0 10 {					# Annoying, but required (0..9 inclusive (10))
	console hide
	sleep 20
	console show
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing console hidecursor/showcursor ..."
textcolor
loop i 0 100 {					# 0..99 inclusive (100)
	console hidecursor
	sleep 20
	console showcursor
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing console move (console will resize) ..."
textcolor
loop i 0 100 {					# 0..99 inclusive (100)
	console move 10 10 1024 600		# Values are in px
}

puts "Line :"#__LINE__
textcolor yellow
puts "Testing console scroll ..."
textcolor
loop i 0 10 {					# 0..9 inclusive (10)
	console scroll 12 3 100 60 1
	sleep 20

}
sleep 100
loop i 0 10 {					# 0..9 inclusive (10)
	console scroll 12 3 200 200 -1
	sleep 30
}
textcolor yellow
puts "Console should have scrolled an area ..."
textcolor

console center

textcolor yellow
puts "Done. Console should have been restored ..."
textcolor

unset i temp_title -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #