###########################################################################################
# File:				test_console_title.tcl
# Author:			M Shaw
# Purpose:			Tests for [console]
#
# Versions:
# 1.00 29/Jul/2019	First version
###########################################################################################
# Notes:
# Will ALWAYS be reset by the CLI
# Don't forget to [escape] the console title as it may contain backslashes
###########################################################################################
option echo on

puts "Line :"#__LINE__
set temp_title [escape [console get_title]]
#puts "\[console get_title\]='[console get_title]'"
puts "temp_title='$temp_title' @"#__LINE__
assert $temp_title {ne $_ ""} -v -line #__LINE__

newline
puts "Setting to $temp_title"
assert [console set_title $temp_title] {== $_ 1} -v -line #__LINE__
puts "::temp_title='$temp_title' @"#__LINE__

puts "\[console get_title\]='[console get_title]' \$::temp_title=$::temp_title"

assert [console get_title] {eq $_ $::temp_title} -v -line #__LINE__


puts "Line :"#__LINE__
textcolor yellow
puts "Testing console get_title ..."
textcolor
loop i 0 100 {		# 0..99 inclusive (99)
	console set_title "tcl-test"
}
assert [console get_title] {eq $_ "tcl-test"} -v -line #__LINE__




puts "Line :"#__LINE__
textcolor yellow
puts "Testing console get_title for 100 loops ..."
textcolor
loop i 0 100 {		# 0..99 inclusive (99)
	console get_title
}

set old_title [console get_title]

assert [console set_title $qbf] {== $_ 1} -v -line #__LINE__
sleep 20
set t [console get_title]
assert $t {eq $_ $::qbf}  -v -line #__LINE__

console set_title $old_title

unset old_title t temp_title -nocomplain

###########################################################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #