#################################################################################
# File:				test_const.tcl
# Author:			M Shaw
# Purpose:			Test cases for [const]
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 16/Jul/2017	First version
#################################################################################
# Notes:
# ADD const arrays ?
#################################################################################
option expression off

textcolor yellow
puts "Testing \[const\] ...."
textcolor
newline

unset ONE_GIGABYTE -const -nocomplain

const ONE_GIGABYTE 1073741824.0
puts "const ONE_GIGABYTE is: $ONE_GIGABYTE"
assert $ONE_GIGABYTE {== $_ 1073741824.0} -v -line #__LINE__

# Try deleting the const ...
# Should refuse
set q 0
try {
	unset ONE_GIGABYTE
} catch {
	set q 1
}
assert $q {== $_ 1} -v -line #__LINE__
assert [is_set ONE_GIGABYTE] {== $_ $true} -v -line #__LINE__

# Try deleting the const ...
# Should do it if given -const
set q 0
try {
	unset ONE_GIGABYTE -const
} catch {
	set q 1
}
assert $q {== $_ 0} -v -line #__LINE__
assert [is_set ONE_GIGABYTE] {== $_ $false} -v -line #__LINE__

unset q -nocomplain
unset ONE_GIGABYTE -nocomplain

########################################################################################
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #