########################################################################
# File: 			test_content.tcl
# Purpose:			Tests for [content]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 25/Jun/2018	First version
# 1.01 09/Oct/2018	More tests added
# 1.02 01/Feb/2022	Updated
########################################################################
# Notes:
# New command with provisional name
# Extracts bounded substring contents from a larger string
########################################################################
option expression off

textcolor yellow
puts "Testing \[content\] ..."
textcolor
newline

# FIX create test case file
# FIX new command, provision name [content]
puts [content "abcd \[eax\]def" "\[" "\]"]
assert [content "abcd \[eax\]def" "\[" "\]"] {eq $_ "eax"} -v -line #__LINE__

puts [content "ab{cde}fg" "{" "}"]
assert [content "ab{cde}fg" "{" "}"] {eq $_ "cde"} -v -line #__LINE__

puts [content "abcd *eax*def" "*" "*"]
assert [content "abcd *eax*def" "*" "*"] {eq $_ "eax"} -v -line #__LINE__

# NULL case
puts [content "abcd **def" "*" "*"]
assert [content "abcd **def" "*" "*"] {eq $_ ""} -v -line #__LINE__


catch {
	assert [content "abcd **def" "+" "+"] {eq $_ "abcd **def"} -v -line #__LINE__		# Should we err?
}

########################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #