#####################################################################
# File:				test_define.tcl
# Author:			M Shaw
# Purpose:			Test various macro #define issues
# Language:			Ticol Tcl v1.19+
# 
# Versions:
# 1.0030/Dec/2015	First version
# 1.01 21/Jan/2022 Updated. Not a unit test yet
#####################################################################

textcolor yellow
puts "Testing macro MPP \#defines"
textcolor
newline

#define COLOR_HEX 0xE

set q COLOR_HEX
puts "COLOR_HEX '" -nonewline
puts COLOR_HEX -nonewline
puts "'"
puts "COLOR_HEX '[tohex $q]' '$q'"
assert $q {== $_ 0xe} -v -line #__LINE__

#define TICK_EXPR "[+ 1 [% [/ [ticks] 1000] COLOR_HEX]]"
#define EXPR2 "COLOR_HEX"

puts "TICK EXPR '"TICK_EXPR'	# Replacement char will vary randomly
set q TICK_EXPR
puts "q TICK_EXPR='[tohex $q]'"

set q EXPR2
puts "q EXPR2='$q'"
assert $q {== $_ 0xe} -v -line #__LINE__
#define EOL 12345 

#####################################################################
unset q -nocomplain
newline 
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #