#################################################################################
# File: 			test_defined.tcl
# Purpose:			Tests [defined]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 01/Aug/2019	First version
#################################################################################
# Notes:
#################################################################################

option expression off

textcolor yellow
puts "Testing test_defined.tcl ..."
textcolor

puts "Line :"#__LINE__

# Test <default>
assert [defined ""] {== $_ 0} -v -line #__LINE__
assert [defined puts] {== $_ 1} -v -line #__LINE__
assert [defined quux] {== $_ 0} -v -line #__LINE__

# Test -command
assert [defined puts -command] {== $_ 1} -v -line #__LINE__
assert [defined foo -command] {== $_ 0} -v -line #__LINE__
assert [defined "" -command] {== $_ 0} -v -line #__LINE__

# Test -proc
undef foo -nocomplain
assert [defined "" -proc] {== $_ 0} -v -line #__LINE__
assert [defined foo -proc] {== $_ 0} -v -line #__LINE__
proc foo {} {} # Empty proc shell
assert [defined foo -proc] {== $_ 1} -v -line #__LINE__
undef foo -nocomplain
assert [defined foo -proc] {== $_ 0} -v -line #__LINE__

# Test -funct
assert [defined "" -funct] {== $_ 0} -v -line #__LINE__
assert [defined foo -funct] {== $_ 0} -v -line #__LINE__
assert [defined quux -funct] {== $_ 0} -v -line #__LINE__
assert [defined abs -funct] {== $_ 1} -v -line #__LINE__
assert [defined wide -funct] {== $_ 1} -v -line #__LINE__
assert [defined error -funct] {== $_ 0} -v -line #__LINE__


puts "Line :"#__LINE__
###########################################################################################
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #