############################################################################################
# File:				test_defs.tcl
# Author:			M Shaw
# Purpose:			Test standard definitions
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 19/Aug/2019 First version
###########################################################################################
# Notes:
# Use WORD or SHORT ?
###########################################################################################
option echo on
option expression off

textcolor yellow
puts "Testing numeric range macro defines ..."
textcolor

# Refer within source without a $ prefix e.g. CHAR_MIN
# The MPP will detect within substrings e.g. MYCHAR_MIN
#define CHAR_MIN  -128
#define CHAR_MAX   127
#define UCHAR_MIN  0
#define UCHAR_MAX  255
#define SHORT_MIN  -32768
#define SHORT_MAX   32767
#define USHORT_MIN  0
#define USHORT_MAX  65535
#define LONG_MIN  -2147483648
#define LONG_MAX   2147483647
#define ULONG_MIN  0
#define ULONG_MAX  4294967295
#define INT_MIN   -9223372036854775808
#define INT_MAX    9223372036854775807
#define UINT_MIN 0
#define UINT_MAX 18446744073709551615

#define CHAR_BITS 8
#define UCHAR_BITS 8
#define SHORT_BITS 16
#define USHORT_BITS 16
#define LONG_BITS 32
#define ULONG_BITS 32
#define INT_BITS 64
#define UINT_BITS 64
#define DOUBLE_BITS 64		# 8


assert CHAR_MIN {== $_ -128} -v -line #__LINE__
assert CHAR_MAX {== $_ 127} -v -line #__LINE__
assert UCHAR_MIN {== $_ 0} -v -line #__LINE__
assert UCHAR_MAX {== $_ 255} -v -line #__LINE__
assert SHORT_MIN {== $_ -32768} -v -line #__LINE__
assert SHORT_MAX {== $_ 32767} -v -line #__LINE__
assert USHORT_MIN {== $_ 0} -v -line #__LINE__
assert USHORT_MAX {== $_ 65535} -v -line #__LINE__
assert LONG_MIN {== $_ -2147483648} -v -line #__LINE__
assert LONG_MAX {== $_ LONG_MAX} -v -line #__LINE__
assert ULONG_MIN {== $_ 0} -v -line #__LINE__
assert ULONG_MAX {== $_ 4294967295} -v -line #__LINE__
assert INT_MIN {== $_ -9223372036854775808} -v -line #__LINE__
assert INT_MAX {== $_ 9223372036854775807} -v -line #__LINE__
assert UINT_MIN {== $_ 0} -v -line #__LINE__
assert UINT_MAX {== $_ 18446744073709551615} -v -line #__LINE__

assert CHAR_BITS {== $_ 8} -v -line #__LINE__
assert UCHAR_BITS {== $_ 8} -v -line #__LINE__
assert SHORT_BITS {== $_ 16} -v -line #__LINE__
assert USHORT_BITS {== $_ 16} -v -line #__LINE__
assert LONG_BITS {== $_ 32} -v -line #__LINE__
assert ULONG_BITS {== $_ 32} -v -line #__LINE__
assert INT_BITS {== $_ 64} -v -line #__LINE__
assert UINT_BITS {== $_ 64} -v -line #__LINE__
assert DOUBLE_BITS {== $_ 64} -v -line #__LINE__

#undef CHAR_MIN
#undef CHAR_MAX
#undef UCHAR_MIN
#undef UCHAR_MAX
#undef SHORT_MIN
#undef SHORT_MAX
#undef USHORT_MIN
#undef USHORT_MAX
#undef LONG_MIN
#undef LONG_MAX
#undef ULONG_MIN
#undef ULONG_MAX
#undef INT_MIN
#undef INT_MAX
#undef UINT_MIN
#undef UINT_MAX

#undef CHAR_BITS
#undef UCHAR_BITS
#undef SHORT_BITS
#undef USHORT_BITS
#undef LONG_BITS
#undef ULONG_BITS
#undef INT_BITS
#undef UINT_BITS
#undef DOUBLE_BITS

newline
textcolor yellow
puts "Testing numeric range const defines held in external file: defs.tcl ..."
textcolor

puts "Line: "#__LINE__
source defs.tcl
vars -const
newline

assert $CHAR_MIN {== $_ -128} -v -line #__LINE__
assert $CHAR_MAX {== $_ 127} -v -line #__LINE__
assert $UCHAR_MIN {== $_ 0} -v -line #__LINE__
assert $UCHAR_MAX {== $_ 255} -v -line #__LINE__
assert $SHORT_MIN {== $_ -32768} -v -line #__LINE__
assert $SHORT_MAX {== $_ 32767} -v -line #__LINE__
assert $USHORT_MIN {== $_ 0} -v -line #__LINE__
assert $USHORT_MAX {== $_ 65535} -v -line #__LINE__
assert $LONG_MIN {== $_ -2147483648} -v -line #__LINE__
assert $LONG_MAX {== $_ 2147483647} -v -line #__LINE__
assert $ULONG_MIN {== $_ 0} -v -line #__LINE__
assert $ULONG_MAX {== $_ 4294967295} -v -line #__LINE__

assert $INT_MIN {== $_ -9223372036854775808} -v -line #__LINE__

assert $INT_MAX {== $_ 9223372036854775807} -v -line #__LINE__
assert $UINT_MIN {== $_ 0} -v -line #__LINE__
assert $UINT_MAX {== $_ 18446744073709551615} -v -line #__LINE__

assert $CHAR_BITS  {== $_ 8} -v -line #__LINE__
assert $UCHAR_BITS  {== $_ 8} -v -line #__LINE__
assert $SHORT_BITS  {== $_ 16} -v -line #__LINE__
assert $USHORT_BITS  {== $_ 16} -v -line #__LINE__
assert $LONG_BITS  {== $_ 32} -v -line #__LINE__
assert $ULONG_BITS  {== $_ 32} -v -line #__LINE__
assert $INT_BITS  {== $_ 64} -v -line #__LINE__
assert $UINT_BITS  {== $_ 64} -v -line #__LINE__
assert $DOUBLE_BITS  {== $_ 64} -v -line #__LINE__

unset CHAR_MIN CHAR_MAX -const
unset UCHAR_MIN UCHAR_MAX -const
unset SHORT_MIN SHORT_MAX -const
unset USHORT_MIN USHORT_MAX -const
unset ULONG_MIN ULONG_MAX -const
unset INT_MIN INT_MAX -const
unset UINT_MIN UINT_MAX -const

unset CHAR_BITS -const
unset UCHAR_BITS -const
unset SHORT_BITS -const
unset USHORT_BITS -const
unset LONG_BITS -const
unset ULONG_BITS -const
unset INT_BITS -const
unset UINT_BITS -const
unset DOUBLE_BITS -const

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars -const

newline
textcolor green
puts "* Done *"
textcolor

# EOF #