############################################################################################
# File: 			test_dict_clear.tcl
# Purpose:			Test [dict clear]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 07/Oct/2019	First version
############################################################################################
# Notes:
# https://stackoverflow.com/questions/21147578/tcl-dict-filter-on-a-nested-dictionnary
############################################################################################

option expression off

unset mydict -nocomplain

/*
puts "Line: "#__LINE__
set mydict [dict create a b c d]
dict clear mydict
dict debug mydict 12
inspect mydict
dump mydict
dict walk mydict
stop
# */

puts "Line: "#__LINE__
unset mydict -nocomplain
set mydict [dict create a b c d]
assert $mydict {eq $_ {c d a b}} -v -line #__LINE__		# A/S 8.6
puts "[dict clear mydict] @"#__LINE__
assert [type mydict] {eq $_ dictionary} -v -line #__LINE__
assert $mydict {eq $_ {}} -v -line #__LINE__
unset mydict 

puts "Line: "#__LINE__

set dict1 [dict create a b c d]
set dict2 [dict create a b c d]
set dict3 [dict create a b c d]
set dict4 [dict create a b c d]

assert [dict size $dict1] {== $_ 2} -v -line #__LINE__
assert [dict size $dict2] {== $_ 2} -v -line #__LINE__
assert [dict size $dict3] {== $_ 2} -v -line #__LINE__
assert [dict size $dict4] {== $_ 2} -v -line #__LINE__

assert [type dict1] {eq $_ dictionary} -v -line #__LINE__
assert [type dict2] {eq $_ dictionary} -v -line #__LINE__
assert [type dict3] {eq $_ dictionary} -v -line #__LINE__
assert [type dict4] {eq $_ dictionary} -v -line #__LINE__

set r [dict clear dict1 dict2 dict3 dict4 -nocomplain]
puts "r=$r"
assert $r {== $_ 5} -v -line #__LINE__

assert [dict size $dict1] {== $_ 0} -v -line #__LINE__
assert [dict size $dict2] {== $_ 0} -v -line #__LINE__
assert [dict size $dict3] {== $_ 0} -v -line #__LINE__
assert [dict size $dict4] {== $_ 0} -v -line #__LINE__

assert [type dict1] {eq $_ dictionary} -v -line #__LINE__
assert [type dict2] {eq $_ dictionary} -v -line #__LINE__
assert [type dict3] {eq $_ dictionary} -v -line #__LINE__
assert [type dict4] {eq $_ dictionary} -v -line #__LINE__

puts "Line: "#__LINE__
unset dict1 dict2 dict3 dict4 r -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #