############################################################################################
# File: 			test_dict_create.tcl
# Purpose:			Test [dict create]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
############################################################################################

option expression off

############################################################################################
# DICT CREATE
# Return literal string as Tcl formatted list
# ActiveState 
# list [dict create args...] -> return a dictionary string
# dict create foo a -> literal string 'foo a'
# dict create foo a b
#		wrong # args: should be "dict create ?key value ...?"
# dict create foo a b c -> OK (no var)
#
set i 0
try {
	dict create
} catch {
	set i 1
}
assert $i {== $_ 0} -v -line #__LINE__
assert [dict create] {eq $_ {}} -v -line #__LINE__

set i 0
try {
	dict create a
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

set i 0
try {
	dict create {}
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

set i 0
try {
	dict create {} {}
} catch {
	set i 1
}
assert $i {== $_ 0} -v -line #__LINE__							# Valid but empty
puts "'[dict create {} {}]'"
assert [dict create {} {}] {eq $_ {{} {}}} -v -line #__LINE__		# A/S 8.6

set i 0
try {
	dict create a b
} catch {
	set i 1
}
assert $i {== $_ 0} -v -line #__LINE__
assert [dict create a b] {eq $_ {a b}} -v -line #__LINE__		# A/S 8.6
vars

set i 0
try {
	dict create a b c
} catch {
	set i 1
}
puts "result is $i at @"#__LINE__
assert $i {== $_ 1} -v -line #__LINE__

unset i

assert [dict create a b c d] {eq $_ {a b c d}} -v -line #__LINE__		# A/S 8.6
assert [dict create a "hello world" c d] {eq $_ {a {hello world} c d}} -v -line #__LINE__

# Nesting ...
assert [dict create a [dict create b c]] {eq $_ {a {b c}}} -v -line #__LINE__
assert [dict create [dict create a b] [dict create c d]] {eq $_ {{a b} {c d}}} -v -line #__LINE__

puts "Line: "#__LINE__
unset mydic -nocomplain
set mydic [dict create a b c d e f]
puts "my dick '$mydic'"

# ************** GPF ****************
puts "Line: "#__LINE__
puts "\[dict keys mydic\] -> '[dict keys $mydic]'"
# FIX ordering!!
#assert [dict keys $mydic] {eq $_ {a c e}} -v -line #__LINE__
unset mydic

puts "Line: "#__LINE__
set mydic [dict create The quick brown fox jumps over the lazy]
puts "type mydic -> '[type mydic]'"
puts "\[dict keys mydic\] -> '[dict keys $mydic]'"
puts "\[dict keys mydic *e\] -> '[dict keys $mydic *e]'"
unset mydic

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #