############################################################################################
# File: 			test_dict_exists.tcl
# Purpose:			Test [dict exists]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
# TODO
# ADD nested search capability
############################################################################################

option expression off

############################################################################################
# DICT EXISTS
# dict exists dictionaryValue key ?key ...? 

textcolor yellow
puts "Calling \[dict exists\] ... @"#__LINE__
textcolor

dict set mydic foo bar spong poo
assert [dict exists mydic] {== $_ 1} -v -line #__LINE__

puts "Line: "#__LINE__
puts "Ignore catch errors..."
catch {
	dict set mydic {}		# exits!
}

puts "Line: "#__LINE__
puts "Ignore catch errors..."
set i 0
try {
	dict set mydic {}		# exits!
} catch {
	set i 1
}
puts "Line: "#__LINE__
assert $i {== $_ 1} -v -line #__LINE__		# A/S 8.6

unset i mydic -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #