############################################################################################
# File: 			test_dict_keys.tcl
# Purpose:			Test [dict keys]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
# FIX Requires ordred <dict>
# ADD more tests, check if nested is required
############################################################################################

option expression off

textcolor yellow
puts "Calling \[dict keys\] ... @"#__LINE__
puts "\[dict keys\] requires ordred <dict>"
textcolor
newline

puts "Line: "#__LINE__
unset mydict -nocomplain
set mydict [dict create 4470 {Great Northern} 4471 "Sir Frederic Banbury"]
puts "mydict -> '$mydict' @"#__LINE__
assert $mydict {eq $_ "4470 {Great Northern} 4471 {Sir Frederic Banbury}"} -v -line #__LINE__

puts "Line: "#__LINE__
dict lappend mydict 4472 "Flying Scotsman"
dict walk mydict

# FIX Requires ordred <dict>
puts "Line: "#__LINE__
#assert $mydict {eq $_ "4470 {Great Northern} 4471 {Sir Frederic Banbury}"} -v -line #__LINE__
dict lappend mydict 4473 "Solario"
dict lappend mydict 4474 "Victor Wild"
dict walk mydict
dict lappend mydict 4475 "Flying Fox"
dict lappend mydict 4476 "Royal Lancer"
dict walk mydict

puts "Line: "#__LINE__
assert [dict size $mydict] {== $_ 7} -v -line #__LINE__

puts "Line: "#__LINE__
textcolor darkyellow
puts "mydict -> '$mydict'"
textcolor
newline

puts "Line: "#__LINE__
textcolor magenta
puts "\[set mydict\] (set echo <dict>) -> '[set mydict]' @"#__LINE__
textcolor
newline

option echo on
puts "Line: "#__LINE__
dict keys $mydict
puts "Line: "#__LINE__
set k [dict keys $mydict]
puts "Line: "#__LINE__
textcolor darkyellow
puts "keys-> '$k'"
textcolor
newline

# FIX Requires ordred <dict>
assert $k {eq $_ {4475 4476 4470 4472 4474 4473 4471}} -v -line #__LINE__

unset k mydict

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #