############################################################################################
# File: 			test_dict_map.tcl
# Purpose:			Test [dict map]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 04/Oct/2019	First version
############################################################################################
# Notes:
# dict map {keyVariable valueVariable} dictionaryValue body
# What happens to the dict entry if we set key to {} ?
############################################################################################

# 1 #
# START Commented out...
::set - {
# Not a bug!
set dict [dict map {key val} {a 1 b 2 c 3} {
	puts "key=$key, val=$val"
	*= val $val
}]
puts "dict is now '$dict'"
assert [dict get $dict a] {== $_ 1} -v -line #__LINE__
assert [dict get $dict b] {== $_ 4} -v -line #__LINE__
assert [dict get $dict c] {== $_ 9} -v -line #__LINE__
unset dict key val
}
# END Commented out...

# 2 #
# FIX double bracing found in dict var assignment
# [dict map] return is correct
# Double bracing is occurring in [set <dict> <return>]
puts "Line: "#__LINE__
set i 1
set dict [dict map {key val} {123 {Blink Bonny} 456 {Sir Nigel Gresley} 789 {Book Law} 001 Solario 002 {Flying Scotsman} 003 Amadis} {
	puts "$i: \$key=$key, \$val=$val"
	#set key "$i"
	if {[expr $key == 123]} {
		#set val "Sir Visto"
		#set key foo		;# Allows the key to be changed
		puts "\tkey is now: '$key'"
	}
	#set key {}		# FIX this can break the list by duplicating an entry
	incr i
}]
puts "Line: "#__LINE__
puts "A dict is now '$dict' @"#__LINE__
dict walk dict

puts "Line: "#__LINE__
set dict [dict map {key val} $dict {
	puts "key=$key, val=$val"
	if {[expr $key == 123]} {
		set val "Sir Visto"
		#set key foo		;# Allows the key to be changed
		puts "key is now: '$key'"
	}
}]
puts "Line: "#__LINE__
textcolor darkyellow
puts "\$dict is now '$dict'"
dict walk dict
textcolor
# exit
puts "Line: "#__LINE__
assert [dict get $dict 123] {eq $_ {Sir Visto}} -v -line #__LINE__
unset dict key val



# 3 #
set i 1
set dict [dict map {key val} {1 {Blink Bonny} 2 {Sir Nigel Gresley}\
 3 {Flying Scotsman}} {
	if {[expr $key == 1]} {
		set val "Sir Visto"
	}
}]
puts "The dict is now: '$dict'"


puts "Line: "#__LINE__
unset dict i key val

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #