############################################################################################
# File: 			test_dict_remove.tcl
# Purpose:			Test [dict remove]
# Language:			Ticol Tcl v1.26+
# See also:			dict_eg_employee.tcl
#
# Versions:
# 1.00 08/Oct/2019	First version
# 1.01 07/Jun/2022	Revised for changes to [loop] bounds
# 1.02 28/Dec/2022	Revised again for reversion to [loop] bounds
############################################################################################
# Notes:
# dict remove dictionaryValue ?key ...?
# FIX Test with nested dictionaries
############################################################################################

option expression off

unset mydict -nocomplain

puts "Line: "#__LINE__

dict set a4 1818 name Silver Link 
dict set a4 1818 br 60014 
dict set a4 1818 lner 2509

puts "Line: "#__LINE__

dict set a4 1819 name Quicksilver
dict set a4 1819 br 60015
dict set a4 1819 lner 2510

puts "Line: "#__LINE__

dict set a4 1821 name Silver King 
dict set a4 1821 br 60016
dict set a4 1821 lner 2511

dict set a4 1823 name Silver Fox
dict set a4 1823 br 60017
dict set a4 1823 lner 2512 

puts "Line: "#__LINE__

/*
dict set a4 1847 name Golden Eagle
dict set a4 1847 br 60023
dict set a4 1847 lner 4482 

puts "Line: "#__LINE__

dict set a4 1848 name Kingfisher
dict set a4 1848 br 60024
dict set a4 1848 lner 4483 

puts "Line: "#__LINE__

dict set a4 1849 name Falcon
dict set a4 1849 br 60025
dict set a4 1849 lner 4484

puts "Line: "#__LINE__

dict set a4 1850 name Kestrel
dict set a4 1850 br 60026
dict set a4 1850 lner 4485 

puts "Line: "#__LINE__

dict set a4 1851 name Merlin
dict set a4 1851 br 60027
dict set a4 1851 lner 4486 

puts "Line: "#__LINE__

dict set a4 1852 name Sea Eagle
dict set a4 1852 br 60028
dict set a4 1852 lner 4487 		# */

# FIX exists should be value not varname
puts "Line: "#__LINE__

/*
puts [dict get $a4 1819 name]
assert [dict get $a4 1819 name] {eq $_ Quicksilver} -v -line #__LINE__
assert [dict exists a4 1819] {eq $_ $true} -v -line #__LINE__
set newdict [dict remove $a4 1819]
puts "item 2? '[dict item newdict 1819 {not found}]'"
#puts $newdict
dict walk newdict -bare
assert [dict exists newdict 9 name] {eq $_ 0} -v -line #__LINE__
unset newdict # */

puts "Line: "#__LINE__

# FIX newdict should be dictionary, is string
puts "type \$a4 '[type $a4]'"
dump a4
# FIX newdict should be dictionary, is string
#set newdict $a4
# FIX can't do this... as need 2 args
set newdict [dict create {*}$a4]
puts "type newdict=[type newdict] @"#__LINE__
assert [type newdict] {eq $_ dictionary} -v -line #__LINE__
puts "script post create/set a4 '[string left $a4 50]...'"

puts "Line: "#__LINE__

# fix check [set dict] return
set size [dict size newdict]
++ size
assert [dict size newdict]  {> $_ 1} -v -line #__LINE__
set keys [dict keys $newdict]		# Set here so the keys are static and unchanging

puts "Line: "#__LINE__

loop i 1 $size {			# Change 28/Dec/2022
# loop i 1 [- $size 1] {
	textcolor white
	puts "\nLOOP START Iter $i: size=[dict size $newdict] @"#__LINE__
	dict walk newdict -bare
	textcolor
	assert [type newdict] {eq $_ dictionary} -v -line #__LINE__

	set key  [lindex $keys [- $i 1]]
	puts "Removing dict with key='$key'"	
	set newdict [dict remove $newdict $key]			# FIX [set] {} case
	
	assert [type newdict] {eq $_ dictionary} -v -line #__LINE__
	textcolor white
	puts "LOOP END Iter $i: type=[type newdict] size=[dict size $newdict] @"#__LINE__
	if {== [dict size newdict] 0} {puts "\n *** DICT EMPTY ***"}
	textcolor
}

newline
puts "Line: "#__LINE__
assert [dict size newdict]  {eq $_ 0} -v -line #__LINE__
textcolor magenta
dict walk newdict
textcolor

puts "Line: "#__LINE__

unset a4 i key keys newdict size -nocomplain

############################################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #