#################################################################################
# File: 			test_dict_set.tcl
# Purpose:			Tests for [dict set]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 05/Oct/2019	First version
#################################################################################
# Notes:
# DESIGN DEF [dict] will store rvalues unbraced
# Reason: the purpose of dict is to rapidly reference rvalues and this is the
# most frequent use. Return of the whole or part dictionaries is less frequent
# if rvalues are braced then removing the braces will be less efficient
# Thus, anything which returns the whole dict must brace the dict rvalues
#################################################################################
# FIX should stored rvalue in dict be braced if it contains spaces?
#################################################################################

textcolor darkyellow
puts "Testing \[dict lappend\] ..."
textcolor
newline

unset foo -nocomplain
assert [dict set foo Tcl {Programming 3} 1 2] {eq $_ {Tcl {{Programming 3} {1 2}}}} -v -line #__LINE__		# A/S 8.6 BUG!
puts "\$foo is '$foo' @"#__LINE__
assert $foo {eq $_ {Tcl {{Programming 3} {1 2}}}} -v -line #__LINE__
newline
dict info foo

unset foo

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #