############################################################################################
# File: 			test_dict_size.tcl
# Purpose:			Test [dict size]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
############################################################################################

option expression off

############################################################################################
# DICT SIZE
# Return the size of a dictionary string literal
# integer [dict size <literal>]

assert [dict size {}] {== $_ 0} -v -line #__LINE__		# A/S 8.6
puts "Line: "#__LINE__
set i 0
try {
	dict size {a}		# mismatched pair
} catch {
	set i 1
}
puts "Line: "#__LINE__
assert $i {== $_ 1} -v -line #__LINE__		# A/S 8.6

puts "Line: "#__LINE__
set i 0
try {
	dict size {{}}		# mismatched pair
} catch {
	set i 1
}
puts "Line: "#__LINE__
assert $i {== $_ 1} -v -line #__LINE__		# A/S 8.6

puts "Line: "#__LINE__
assert [dict size {{} {}}] {== $_ 1} -v -line #__LINE__		# A/S 8.6

puts "Line: "#__LINE__
assert [dict size {{} {} {} {}}] {== $_ 2} -v -line #__LINE__		# A/S 8.6

assert [dict size {a b}] {== $_ 1} -v -line #__LINE__		# A/S 8.6
assert [dict size {a b c d}] {== $_ 2} -v -line #__LINE__		# A/S 8.6

unset i


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #