#################################################################################
# File: 			test_dict_unset.tcl
# Purpose:			Tests for [dict unset]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 07/Oct/2019	First version
#################################################################################
# Notes:
# dict unset dictionaryVariable key ?key ...?
#################################################################################
# TODO
# DONE ADD unset dictionary keys in 'flat' dictionaries
# ADD [dict unset] nested dictionary support
#	Currently only supports flat dictionaries
#	Where multiple keys are present, this describes a path through nested 
#	dictionaries to the mapping to remove. At least one key must be specified, 
#	but the last key on the key-path need not exist. All other components on the
#	 path must exist. The updated dictionary value is returned. 
#################################################################################
option expression off
option echo on

unset mydict -nocomplain
assert [is_set mydict] {== $_ $false} -v -line #__LINE__

set mydict [dict create 4470 {Flying Fox} 4472 {Flying Scotsman} \
 2553 Manna 2555 Centenary]
assert [dict size mydict] {== $_ 4} -v -line #__LINE__
dict walk mydict

dict unset mydict 2550 2553 2555
assert [dict size mydict] {== $_ 2} -v -line #__LINE__
dict walk mydict

assert [dict item $mydict 2553] {eq $_ {}} -v -line #__LINE__
assert [dict item $mydict 2555] {eq $_ {}} -v -line #__LINE__
assert [dict item $mydict 4470] {eq $_ {Flying Fox}} -v -line #__LINE__
assert [dict item $mydict 4472] {eq $_ {Flying Scotsman}} -v -line #__LINE__
puts [dict get $mydict]


unset mydict
assert [is_set mydict] {== $_ $false} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #