#############################################################################################
# File: 			test_dict_with.tcl
# Purpose:			Test [dict with]
# Language:			Ticol Tcl v1.26+
# See also:			dict_eg_employee.tcl
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
# <result> [dict with dictionaryVariable ?key ...? body -unset]
############################################################################################

option expression off

unset mydict -nocomplain

puts "Line: "#__LINE__

dict set a4 1 name Silver Link 
dict set a4 1 br 60014 
dict set a4 1 lner 2509

dict set a4 2 name Quicksilver
dict set a4 2 br 60015
dict set a4 2 lner 2510

dict set a4 3 name Silver King 
dict set a4 3 br 60016
dict set a4 3 lner 2511

dict set a4 4 name Silver Fox
dict set a4 4 br 60017
dict set a4 4 lner 2512 

dict set a4 5 name Golden Eagle
dict set a4 5 br 60023
dict set a4 5 lner 4482 

dict set a4 6 name Kingfisher
dict set a4 6 br 60024
dict set a4 6 lner 4483 

dict set a4 7 name Falcon
dict set a4 7 br 60025
dict set a4 7 lner 4484

dict set a4 8 name Kestrel
dict set a4 8 br 60026
dict set a4 8 lner 4485 

dict set a4 9 name Merlin
dict set a4 9 br 60027
dict set a4 9 lner 4486 

dict set a4 10 name Sea Eagle
dict set a4 10 br 60028
dict set a4 10 lner 4487 

textcolor yellow
dict for {key val} $a4 {
	dict with val {
		printf "%-3s-> Name: %-15s\tBR Number: %5s\t LNER Number: %4i\n" $key $name $br $lner	
	} #-unset DO NOT CLEAR!!
}
textcolor
newline
vars
assert [info exists key] {== $_ 1} -v -line #__LINE__
assert [info exists val] {== $_ 1} -v -line #__LINE__
assert [info exists name] {== $_ 1} -v -line #__LINE__
assert [info exists br] {== $_ 1} -v -line #__LINE__
assert [info exists lner] {== $_ 1} -v -line #__LINE__
newline

dict for {key val} $a4 {
	#vars
	#pause
	dict with val {
		if {== $key 1} {
			assert $name {eq $_ {Silver Link}} -v -line #__LINE__
			assert $br {== $_ 60014} -v -line #__LINE__
			assert $lner {== $_ 2509} -v -line #__LINE__
		} elseif {== $key 10} {
			assert $name {eq $_ {Sea Eagle}} -v -line #__LINE__
			assert $br {== $_ 60028} -v -line #__LINE__
			assert $lner {== $_ 4487} -v -line #__LINE__
		}
	} -unset
}
assert [info exists key] {== $_ 1} -v -line #__LINE__
assert [info exists val] {== $_ 1} -v -line #__LINE__

# -unset should have removed these variables
assert [info exists name] {== $_ 0} -v -line #__LINE__
assert [info exists br] {== $_ 0} -v -line #__LINE__
assert [info exists lner] {== $_ 0} -v -line #__LINE__
newline

unset a4 key val

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #