######################################################################################
# File:			test_dynamic_tcx.tcl
# Author:		M Shaw
# Purpose:		Test the stability of plugins
# Language:		Ticol Tcl v1.26+
#
# Versions:
# 1.00 05/Aug/2019	First version
######################################################################################
# Notes:
######################################################################################
# FAILS Won't work because TCX files are encrypted with a header ID and fields
# Document the structure
######################################################################################
/*
ADD Test: source->tcx
	Create a TCX file on the fly?
	Just to calculate and return some value
	set password foobar
	set s [/ 22 7.0]
	#set s [???? ticol encrypt as per /c] # Requires binary encryption not b64 return
	#set s [base64 s]
	set s [encrypt s $password]
	writefile encoded.t64 $s
*/
######################################################################################

puts "Line: "#__LINE__
textcolor cyan
lib ticol_tcx -verbose
textcolor

set filename encoded.t64
set password foobar

puts "Line: "#__LINE__
set s [/ 22 7.0]										# Create a short script
set s [encrypt s $password]								# Encrypt it
puts "Line: "#__LINE__
writefile $filename $s									# Write the encrypted file
unset s


# Won't work
puts "Line: "#__LINE__
set s [readfile $filename]
puts "Read-in [string length $s] byte(s)"
puts "Read-in: '$s'"
puts "Line: "#__LINE__
set q [tcx $s -password $password -run]

puts "Line: "#__LINE__
puts $q
assert $q {== $_ 0} -v -line #__LINE__

lib ticol_tcx -unload 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #