############################################## #############################################
# File:				test_elevate.tcl
# Author:			M Shaw
# Purpose:			Test file for [elevate] command
#
# Versions:
# 1.00 30/Jun/2016 First version
###########################################################################################
# Notes:
# Not for inclusion in main tests (tests.tcl)
# Call with some arguments or other
# New, elevated copy should be spawned, with args
###########################################################################################
# Mod to picolParseBrace almost works, we elevate correctly and pass args
# but elevated case exits for no apparent reason
# Other elevate tests fail
# DONE FIX Wart bug! binds to [if]
###########################################################################################
option expression off

#puts "Debug; Enter [escape [info script]]"
# FIX Ticol: File 'test_elevate.tcl 1 2 3 /PAUSE ' not found

#define OPT_ARGS

if {! [is_elevated] } {
#ifdef OPT_ARGS
	set cmdline ""
	if { [array is_set argv] } {						# It is fatal to address a non-existent array var
		for {set i 0} {< $i $argc} {++ i} {				# We will supply _scriptname internally
			append cmdline "$argv($i) "
		}
	}
	#pause "Command line: '$cmdline' \[is_elevated\]? [is_elevated]"
	#option breakpoint on
	#halt
	# MAJOR BUG: Breaks [if] but requires separate commands
	#elevate [expand $cmdline]
#	puts "Elevating..."
	elevate {*}$cmdline
	#call [elevate {*}$cmdline]
	# This non-elevated instance will exit and the console (if any) will remain active
#else
	if { [array is_set argv] } {
		elevate $argv(0) [array item argv 1 ""] [array item argv 2 ""] [array item argv 3 ""] [array item argv 4 ""]
	} else {
		elevate 
	}
#endif

} else {
	newline
	textcolor green
	puts "* [escape [info script]] is now elevated!\r\n"
	textcolor
	# Start processing arguments ###############################################
	if { [array is_set argv] } {					# It is fatal to address a non-existent array var

		vars * -const
		array walk argv

		for {set i 0} {< $i $argc} {++ i} {
			set arg_v [array item argv $i {}]		# Using [for] to index associative array is dangerous since there is no guarantee, by numeric index, an element will exist

			puts "* argv $i: '$arg_v'"				# So we must use [array item] which while non-standard, can safely return a default value and handle no-element cases safely

			if {[eq $arg_v "-?"] || [eq $arg_v "-h"] -nocase} {
				die "Syntax is: ticol.exe $argv0 directory"
			}
		}
	}
	newline
	textcolor red
	puts "* We will exit this elevated session and the elevated console will close"
	textcolor
	newline
	pause
	# This elevated instance will now close and vanish
}

# EOF #