#################################################################################
# File:				test_encrypt.tcl
# Author:			M Shaw
# Purpose:			General test stuff for [encrypt]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 26/Nov/2016	First version
# 1.01 21/Jul/2017	Replace [checkex] with [assert]
# 1.02 05/Mar/2021	Updated for new -var argument
#################################################################################
# Notes:
#################################################################################

# string literal
assert [decrypt [encrypt "Hello world!" secret] secret] {eq $_ "Hello world!"} -v -line #__LINE__
assert [decrypt [encrypt $qbf secret] secret] {eq $_ $::qbf} -v -line #__LINE__

# -var arg
set s "Hello world!"
assert [encrypt s secret -var] {eq $_ N4w8n7XnePSvob9G} -v -line #__LINE__
assert [decrypt [encrypt s secret -var] secret] {eq $_ $s} -v -line #__LINE__

# x16 random types defined
# type 5 is binary and may beep so is filtered out
for {set i 0} {< $i 17} {++ i} {
	if {!= $i 5} {
		set s [randomstr 1000 $i]
		puts "Random string type $i"
		assert [decrypt [encrypt $s secret] secret] {eq $_ $::s} -v -line #__LINE__
	}
}

#set i 1; set s [randomstr 1000 $i]; 	puts [decrypt [encrypt $s secret] secret]

unset i s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #