###############################################################################################
# File:				test_environ.tcl
# Author:			M Shaw
# Purpose:			Test file the current environment
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 05/Mar/2017	Migrated from tests.tcl
# 1.01 21/Jul/2017	Replace [checkex] with [assert]
###############################################################################################
# Notes
###############################################################################################

option expression off
textcolor yellow
puts "Testing Environment Commands ...."
textcolor
newline

# getcwd #
textcolor yellow
puts "Checking \[getcwd\]"
textcolor
assert [getcwd] {ne $_ ""} -v -line #__LINE__

# getenv #
# DOS PROMPT=$P$G
textcolor yellow

/*
array foreach env q p {
	puts "$p=$q"
} */

# PROMPT appears not to be set. Use SYSTEMDRIVE
#puts "Line $line: Checking \[getenv\] PROMPT=\$P\$G"
puts "Checking \[getenv\] SYSTEMDRIVE=c:"
textcolor
puts "'\[getenv SYSTEMDrIvE\]=[getenv SYSTEMDrIvE]'"
puts "'\[string left \[getenv SYSTEMDRIVE\] 2\]=[string left [getenv SYSTEMDRIVE] 2]'"
#assert [string left [getenv SYSTEMDRIVE] 2]  {eqi $_ {C:}} -v -line #__LINE__

# info username #
textcolor yellow
puts "Checking \[info username\] is NOT NULL ([info username])"
textcolor
assert [info username] {ne $_ ""} -v -line #__LINE__

# hostname #
textcolor yellow
puts "Checking \[hostname\] ([hostname])"
textcolor
assert [hostname] {ne $_ ""} -v -line #__LINE__

# pid #
textcolor yellow
puts "Testing \[pid\] ([pid])"
textcolor
assert [pid] {> $_ 4} -v -line #__LINE__

# tid #
textcolor yellow
puts "Testing \[tid\] ([tid])"
textcolor
assert [tid] {> $_ 4} -v -line #__LINE__

###############################################################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #