#################################################################################
# File: 			test_error.tcl
# Purpose:			Tests for $err* vars
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 19/Feb/2018	First version
#################################################################################
# Notes:
# See [try..catch] and [catch] quiet mode
#################################################################################
option expression off
option echo on
option 
vars

textcolor yellow
puts "Testing test_error.tcl ..."
textcolor
newline

option echo on
puts "Line: "#__LINE__
#http http://nosuchwebsite.com
puts "Line: "#__LINE__

/*
puts "Line: "#__LINE__
puts "Ignore catch error ..."
catch {
	try {
		textcolor yellow
		puts "Connecting to invalid or imaginary website to test timeout..."
		textcolor
		puts "Line: "#__LINE__
		puts [http http://nosuchwebsite.com ]
		puts "Line: "#__LINE__
		#puts [http http://example.com]
	} catch {
		puts "Line: "#__LINE__
		textcolor red
		puts "CATCH Failed '[item errorMsg "errorMsg not found"]'"				# Good var
		textcolor
	}
} # */

puts "Line: "#__LINE__
# exit
vars

/*
puts "Line: "#__LINE__
# Check that the error does not persist into $errorMsg
puts "Line: "#__LINE__
catch {
	puts "Line: "#__LINE__
	try {
		puts "Line: "#__LINE__	
		puts [http http://nosuchwebsite.com]
		puts "Line: "#__LINE__
		#puts [http http://example.com]
	} catch {
		puts "Line: "#__LINE__
		assert [item $errorMsg] [eq $_ ""] -v -line #__LINE__
		puts "Line: "#__LINE__
		textcolor red
		puts "CATCH Failed '[item errorMsg "errorMsg not found"]'"				# Good var
		textcolor
	}
	puts "Line: "#__LINE__
}
puts "Line: "#__LINE__

# Test [error]



vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

newline
textcolor green
puts "* Pass *"
textcolor

# EOF #