###############################################################
# File: 			tsst_escape.tcl
# Purpose:			Test cases for escapes
# Author: 			M Shaw
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 19/Aug/2016	First version
# 1.01 21/Jul/2017	Replace [checkex] with [assert]
###############################################################
# Notes: 
# ADD [escape] tests
###############################################################

set expression_state [option expression]
option expression off
set echostate [option echo]

textcolor
puts "Testing escape sequences ..."
textcolor
newline

#   \#  # Borks The MPP

puts "\#"
newline

assert "#" {eq $_ "#"} -v -line #__LINE__
assert "\#" {eq $_ "\#"} -v -line #__LINE__

puts "\\*...*\\"
newline

/*
# FATAL mitsake #
set line #__LINE__
if {! [catch {puts "[\bad escape\]"}] } {		# FATAL. Destroys the [catch]-handler
	die "Bad escape test failed at line $line"
}
*/

/*
# Another FATAL mitsake #
set line #__LINE__
if {! [catch {puts "{\bad escape\}"}] } {
	die "Bad escape test failed at line $line"
}
*/

textcolor
puts "Testing \[esc\] handling of escape sequences ..."
textcolor
newline

puts "Line: "#__LINE__
assert [asc "\["] {== $_ 91} -v -line #__LINE__
#assert [asc {\[}] {== $_ 91} -v -line #__LINE__	# FIX
assert [asc "\\"] {== $_ 92} -v -line #__LINE__
#assert [asc "\"] {== $_ 92} -v -line #__LINE__		# Correctly trapped by MPP
assert [asc "\]"] {== $_ 93} -v -line #__LINE__
assert [asc "\{"] {== $_ 123} -v -line #__LINE__
assert [asc "\}"] {== $_ 125} -v -line #__LINE__
assert [asc "\$"] {== $_ 36} -v -line #__LINE__
puts "[chr 34]"
assert [asc "\""] {== $_ 34} -v -line #__LINE__
puts "[chr 40]"
assert [asc "("] {== $_ 40} -v -line #__LINE__
assert [asc "\("] {== $_ 40} -v -line #__LINE__
puts "[chr 41]"
assert [asc ")"] {== $_ 41} -v -line #__LINE__
assert [asc "\)"] {== $_ 41} -v -line #__LINE__


##########################################
option echo $echostate
option expression $expression_state

unset echostate expression_state -nocomplain
vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #