#################################################################################
# File: 			test_escaped_hash.tcl
# Purpose:			Tests for escaped hash characters 
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 07/Feb/2022	First version
#################################################################################
# Notes:
# Note that escaped HASH chars must be wrapped in double-quotes
# This is not allowed:  set a \# 
#################################################################################


puts "\#";         # Prints a literal # character

# Single
set a "\#"         # Sets a literal # character
puts "a is '$a'"
assert $a {eq $_ "\#"} -v -line #__LINE__
newline

# Multiple
set a "\#\#\#\#\#"         # Sets a literal # character
puts "a is '$a'"
assert $a {eq $_ "\#\#\#\#\#"} -v -line #__LINE__
newline

# Chars embedded
set a "\#\#Hello\#\#\#"         # Sets a literal # character
puts "a is '$a'"
assert $a {eq $_ "\#\#Hello\#\#\#"} -v -line #__LINE__
newline

unset a -nocomplain
vars

#################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #