##############################################################################
# File: 			test_expr.tcl
# Purpose:			Test file for [expr]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Aug/2018	First version
##############################################################################
# Notes: 
##############################################################################

textcolor yellow
puts "Testing \[expr\] ..."
textcolor
newline

assert [expr 0 + 0] {== $_ 0} -v -line #__LINE__
assert [expr 0 + .0] {== $_ 0.0} -v -line #__LINE__
assert [expr 0 + 0.1] {== $_ 0.1} -v -line #__LINE__
assert [expr 0 + .1] {== $_ 0.1} -v -line #__LINE__
assert [expr .0 + .1] {== $_ 0.1} -v -line #__LINE__

assert [expr 0.0 + .1] {== $_ 0.1} -v -line #__LINE__
assert [expr 0.1 + .0] {== $_ 0.1} -v -line #__LINE__
assert [expr 0.1 + 0] {== $_ 0.1} -v -line #__LINE__
assert [expr 0.1 + 0.0] {== $_ 0.1} -v -line #__LINE__
assert [expr 0.1 + .1] {== $_ 0.2} -v -line #__LINE__

assert [expr .1 + .0] {== $_ 0.1} -v -line #__LINE__
assert [expr .1 + 0] {== $_ 0.1} -v -line #__LINE__
assert [expr .1 + 0.0] {== $_ 0.1} -v -line #__LINE__
assert [expr .1 + .1] {== $_ 0.2} -v -line #__LINE__

assert [expr 2*-1*-5.6/7.2*119.8] {== [round $_ 6]  [round 186.35555555555 6]} -v -line #__LINE__ Validated by VB5 (WinCalc is wrong) 186.355555555556 

##############################################################################
# Bracketed && and || (Added 06/Nov/2019)
unset a -nocomplain
set a 3
assert [ expr $a < 1 || $a > 2] -v -line #__LINE__
set a 2
assert [! [ expr $a < 1 || $a > 2]] -v -line #__LINE__

set a 3
assert [ expr $a < 4 && $a > 2] -v -line #__LINE__		# Can only be 3
set a 4
assert [! [ expr $a < 4 && $a > 2]] -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #