#################################################################################
# File: 			test_extract.tcl
# Purpose:			Tests for [extract]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 01/Oct/2018	First version
#################################################################################
# Notes:
#################################################################################
option expression off
option echo on

textcolor yellow
puts "Test \[extract\]..."
textcolor
newline

unset s -nocomplain
puts "Line: "#__LINE__
set s "123.45Hello World"

puts [extract s "0123456789." "0" -var]
assert [extract s "0123456789." "0" -var] {eq $_ "123.45"} -v -line #__LINE__

set s "Hello World123.45"
puts "'[extract s "[range a-z] " "" -var -nocase]'"
assert [extract s "[range a-z] " "" -var -nocase] {eq $_ {Hello World}} -v -line #__LINE__

puts "'[extract s "[range 0-9][range a-z]. " "" -var -nocase]'"
assert [extract s "[range 0-9][range a-z]. " "" -var -nocase] {eq $_ {Hello World123.45}} -v -line #__LINE__
#stop

# QBF length is 43
puts "Line: "#__LINE__
puts [extract qbf "[range a-z] " hi -var -nocase -offset 245]
assert [extract qbf "" -var -offset 0] {eq $_ ""} -v -line #__LINE__
assert [extract qbf "" hi -var -offset 0] {eq $_ hi} -v -line #__LINE__		# i.e. not found -> hi
assert [extract qbf "hTe" hi -var -offset 0] {eq $_ The} -v -line #__LINE__
assert [extract qbf "hTe" hi -var -offset 1] {eq $_ he} -v -line #__LINE__
assert [extract qbf "[range a-z] " hi -var -nocase -offset 245] {eq $_ hi} -v -line #__LINE__
assert [extract qbf "[range a-z] " hi -var -nocase -offset 42] {eq $_ g} -v -line #__LINE__
assert [extract qbf "[range a-z] " hi -var -nocase -offset 43] {eq $_ hi} -v -line #__LINE__
assert [extract qbf "[range a-z] " -var -nocase -offset 43] {eq $_ ""} -v -line #__LINE__
assert [extract qbf [range a-z] -var -nocase -offset 34] {eq $_ ""} -v -line #__LINE__	# No space
assert [extract qbf "iukcq" -var -nocase -offset 4] {eq $_ quick} -v -line #__LINE__

# No -var
puts "Line: "#__LINE__
assert [extract $qbf "hTe" hi -offset 0] {eq $_ The} -v -line #__LINE__
assert [extract $qbf "hTe" hi -offset 1] {eq $_ he} -v -line #__LINE__
assert [extract $qbf "[range a-z] " hi -nocase -offset 245] {eq $_ hi} -v -line #__LINE__
assert [extract $qbf "[range a-z] " hi -nocase -offset 42] {eq $_ g} -v -line #__LINE__
assert [extract $qbf "[range a-z] " hi -nocase -offset 43] {eq $_ hi} -v -line #__LINE__
assert [extract $qbf "[range a-z] " -nocase -offset 43] {eq $_ ""} -v -line #__LINE__
assert [extract $qbf [range a-z] -nocase -offset 34] {eq $_ ""} -v -line #__LINE__	# No space
assert [extract $qbf "iukcq" -nocase -offset 4] {eq $_ quick} -v -line #__LINE__


puts "Line: "#__LINE__
unset s -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #