#################################################################################
# File:				test_fileio.tcl
# Author:			M Shaw
# Purpose:			Test [file] IO
# Language:			Ticol Tcl v1.26+
# Dependencies:		lorem.txt
#
# Versions:
# 1.00 28/Nov/2019	First version
# 1.01 27/May/2020	Add trap for missing file
#################################################################################
# Notes:
# Test values are hard coded to match lorem.txt
#################################################################################

if {! [file exists "lorem.txt"]} {
	die "Lorem.txt not found in script test_fileio"
}

set fp [open "lorem.txt" r]			# 128 lines

assert $fp -v -line #__LINE__
if {$fp} {
	assert [file seek $fp 200] {== $_ 1} -v -line #__LINE__
	assert [file tell $fp] {== $_ 200} -v -line #__LINE__
	set i 0
	while {! [file eof $fp]} {
		set r [file gets $fp s -length 20]					# Read with restricted buffer/line length
		# puts "Returned line length $r"
		assert $r {<= $_ 20} -v -line #__LINE__ 			# FAIL
		#puts "'$s'"
		++ i
	}
	file close $fp
	assert $i {== $_ 261} -v -line #__LINE__				# Count of lines
}

unset fp i r s -nocomplain

###########################################################################################
newline
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #
