#################################################################################
# File: 			test_filter.tcl
# Purpose:			Tests for [filter]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 01/Oct/2018	First version
#################################################################################
# Notes:
# 	string [filter string charmask ?-exclude? ?-nocase?]
#	string [filter varname charmask ?-exclude? ?-var? ?-nocase?]
#################################################################################
option expression off
option echo on

textcolor yellow
puts "Test \[filter\]..."
textcolor
newline

# NULL cases
assert [filter "axbxcxdxe" ""] {eq $_ ""} -v -line #__LINE__
assert [filter "" "abcde"] {eq $_ ""} -v -line #__LINE__

assert [filter "axbxcxdxe" "abcde"] {eq $_ "abcde"} -v -line #__LINE__
assert [filter "AxBxCxDxE" "abcde" -nocase] {eq $_ "ABCDE"} -v -line #__LINE__

# -exclude
assert [filter "axbxcxdxe" "x" -exclude] {eq $_ "abcde"} -v -line #__LINE__
assert [filter "aXbXcXdXe" "x" -exclude -nocase] {eq $_ "abcde"} -v -line #__LINE__
assert [filter "axbxcxdxe" "X" -exclude -nocase] {eq $_ "abcde"} -v -line #__LINE__


vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #