#################################################################################
# File:				test_float.tcl
# Author:			M Shaw
# Purpose:			Tests floating point math etc.
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 27/Nov/2019	First version. A member of tests
#################################################################################
# Notes:
# ADD more test cases and put any interesting FB test cases in here
#################################################################################
option expression off

# Perfectly normal FB rounding problems. Common to both Javacript and Java etc.
assert [+ 10 5.99] {== $_ 15.990000000000000} -v -line #__LINE__
assert [+ 10 6.99] {== $_ 16.990000000000002} -v -line #__LINE__		# Whoops!  (.000000000000002)

# Good PI
puts "Good PI @"#__LINE__
assert [* [funct atan 1] 4] {== $_ 3.141592653589792} -v -line #__LINE__
assert [expr atan(1)*4] {== $_ 3.141592653589792} -v -line #__LINE__
assert [expr atan(1) * 4] {== $_ 3.141592653589792} -v -line #__LINE__			# SPACE
assert [expr atan(1)	*	4] {== $_ 3.141592653589792} -v -line #__LINE__		# TAB

# BAD PI
puts "Bad PI @"#__LINE__
assert [/ 22 7.0] {== $_ 3.142857142857143} -v -line #__LINE__
assert [expr 22/7.0] {== $_ 3.142857142857143} -v -line #__LINE__



# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #