######################################################################################
# File: 			test_floop.tcl
# Purpose:			Test for [floop]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 05/Nov/2019	New command added
# 1.01 07/Jun/2022	Revised for changes to [floop] bounds
# 1.02 28/Dec/2022	Reverted to loop bounds which are compatible with TclX->[loop]
######################################################################################
# Notes:
# ADD more tests
# Silly-sounding name. Consider renaming as [loopf] or merge with [loop -float]
# For this reason, tests are short
######################################################################################


floop i 0.0 1 0.1 {
	puts "i is $i"
}
assert $i {== $_ 1.0} -v -line #__LINE__		# Postcondition is 1.0


floop i 0.23 1 0.045 {		# 0.995 + 0.045 = 1.04
	puts "i is $i"
}
assert $i {== $_ 1.04} -v -line #__LINE__

floop i 0.001 0.999 0.002 {		# 0.997 + 0.002 = 0.999
	# puts "DEBUG: i is $i"
}
assert $i {== $_ 0.999} -v -line #__LINE__

unset i


######################################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #