#############################################################################################
# File:				test_for_multi.tcl
# Purpose:			Test [for] with multiple initiators
# Author:			M Shaw
# Language:			Ticol Tcl v1.22+
#
# Versions:
# 1.00 17/Jan/2017	Ported from tests.tcl
#############################################################################################
# Notes:
# http://wiki.tcl.tk/963
#############################################################################################

set line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
/* # Deprecated
if {! [defined checkex] } {
	proc checkex {x expr} {
		#puts "DEBUG: checkex \$x=$x \$expr=$expr"
		upvar i					# Pass-through reference integer 
		upvar line
		#	puts "Trace $line"
		#	upvar NAN NAN		# Global const is N/A (FIX)
		#set line 0
		#set NAN "-1.[chr 35]IND00000000000"
		# fix puts "\$x==$x: $expr"
		#set q {$x}
		set q \$x
		puts "Line: $line " -nonewline
		puts "'$q'=='$x': expr '$expr'"	# fails here at EOF - poss (due to bug in callproc()?) - July 2016
		#puts "eval expr: [eval $expr]"
		if { [eval $expr] } {
			#puts "Expr true"
		} else {
			textcolor red
			puts "checkex assertion failed: $q -> $x after line $line"
			textcolor
			stop
		}
	}
} # */
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

/* # Deprecated
if {! [defined check] } {
	proc check {x y} {
		upvar line
		if {!= $x $y} {
			puts "Error in tests at after line $line"
			puts "'$x' != '$y'"
			stop
		}
	}
} # */
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

textcolor yellow
puts "Testing \[for\] with multiple initiators ..."
textcolor
newline

set line #__LINE__


option expression on
for {[set i 0; set j 0]} {$i < 6} { ++ i; ++ j 2} {
	puts "i=$i; j=$j"
}

assert $i {== $_ 6} -v -line #__LINE__
assert $j {== $_ 12} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

newline
textcolor green
puts "* PASS *"
textcolor

# EOF #