###################################################################################
# File: 			test_for_multi_arg.tcl
# Purpose:			Check [for] with multiple args
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 14/Jul/2018	Test for example in link below
###################################################################################
# Notes:
# Source: http://www.invece.org/tclwise/control_constructs.html
###################################################################################
option expression on

textcolor yellow
puts "Testing \[for\] with multi args"
textcolor
newline

puts "Line: "#__LINE__
set z 0
for {set x 0; set y 0} {$x+$y != 50} {incr x 2; incr y 3} {
	puts "x $x, y $y, z $z"
	set z [+ $x $y]
}
puts "z is $z"
assert $z {== $_ 45} -v -line #__LINE__

unset x y z -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
vars

newline
textcolor green
puts "* test_for_multi_arg - Done *"
textcolor

# EOF #