###############################################################################
# File: 			test_foreach.tcl
# Purpose:			Test file for [foreach]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 15/Aug/2016	First version
# 1.01 21/Jul/2017	Replaced [checkex] with [assert]
# 1.02 26/Sep/2019	Updated
###############################################################################
# Notes: 
###############################################################################

#set i 0

###############################################################################

/* # # # # # 
puts "Line: "#__LINE__
foreach f [ls "c:\windows\*.*" -af -list] {
	puts "File: $f"
} # */

puts "Line: "#__LINE__
foreach {f g} {one {two three} four five six {seven eight} nine ten} {
	puts "Items f g: $f, $g"
}

/*
array unset a -nocomplain
puts "Line: "#__LINE__
ls test_*.tcl -array a -la -list
#puts "a is '[item a {}]'"
puts "Line: "#__LINE__
foreach {i j k l} $a {
	puts "$i, $j, $k, $l"
} # */

puts "Line: "#__LINE__
foreach f {one two three} { puts "$f,"}

puts "Line: "#__LINE__
set args {one two three four}
set arg [foreach {a b c} $args break]

#puts "Line: "#__LINE__
#foreach s [commands] { puts $s }
# # # # # */
###############################################################################

#/* # # # # # 

puts "Line: "#__LINE__
option echo on
option expression off

# foreach
textcolor yellow 
puts "\nChecking \[foreach\] \"0 1 2 3 4 5 6 7 8 9\""
textcolor
set x 0
set y 0
set z 0
foreach f "0 1 2 3 4 5 6 7 8 9" {
	#puts "Adding $f"
	set x [+ $x $f] # ADD: add x 10	
	+= y $f									# Also test += command
	-= z $f									# Also test -= command
	#puts "x is $x"	
	puts "z is $z"
}
puts "Line: "#__LINE__
assert $x {== $_ 45} -v -line #__LINE__
assert $y {== $_ 45} -v -line #__LINE__
assert $z {== $_ -45} -v -line #__LINE__
unset x y z -nocomplain


puts "Line: "#__LINE__
set i 0
#foreach varlist list body
#foreach var|{var...} list|{vars...} {body}

textcolor yellow
puts "Testing \[foreach\] ..."
textcolor

puts "Line: "#__LINE__
set s {}
foreach {f g} {one {two three} four five six {seven eight} nine ten} {
	#puts "Items f g: $f, $g"
	append s "$f $g "
}
#puts "$s"
assert $s {eq $_ "one two three four five six seven eight nine ten "} -v -line #__LINE__
unset s


## single-var, single-line ##
puts "Line: "#__LINE__
set line #__LINE__
set r {}
foreach f {one two three} {append r "$f "}
#puts "r is '$r'"
assert $r {eq $_ "one two three "} -v -line #__LINE__

## single-var, single-line ##
puts "Line: "#__LINE__
set r {}
foreach f [list one two three] {append r "$f "}
#puts "r is '$r'"
assert $r {eq $_ "one two three "} -v -line #__LINE__

## single-var, multi-line ##
puts "Line: "#__LINE__
set r {}
set x [list 1 2 3 4 5]
#puts "x='$x'"
foreach y $x {
#foreach y {$x} {		# FIX should eval arg if braced
	#puts $y, -nonewline
	append r "$y "
}
assert $r {eq $_ "1 2 3 4 5 "} -v -line #__LINE__

# args: should be "foreach varList list ?varList list ...? command"

## Single-line + two vars/two lists ##
puts "Line: "#__LINE__
set r {}
set x [list 1 2 3 4 5];foreach y $x z $x {append r "$y $z "}
#set x [list 1 2 3 4 5];foreach y $x z $x {puts $y, -nonewline}
#puts "$r"
assert $r {eq $_ "1 1 2 2 3 3 4 4 5 5 "} -v -line #__LINE__


## Multi-line + two vars/two lists ##
puts "Line: "#__LINE__
set r {}
set x [list 1 2 3 4 5]
#puts "x='$x'"
foreach y $x z $x {			# Check in ActiveState
#foreach y {$x} {		# FIX should eval arg if braced
	#puts "$y,$z" -nonewline
	append r "$y $z "
}
assert $r {eq $_ "1 1 2 2 3 3 4 4 5 5 "} -v -line #__LINE__

unset r x y -nocomplain

## foreach N in list ##
puts "Line: "#__LINE__
set sum 0
foreach i {1 2 3 4 5 6 7 8} {
	+= sum $i
}
assert $sum {== $_ 36} -v -line #__LINE__

# */

unset a arg args b c f g i j k l line sum z -nocomplain

###############################################################################
newline
vars
newline
textcolor green
puts "* \[foreach\] Done *"
textcolor

# EOF #