########################################################################
# File:			test_funct.tcl
# Author:		M Shaw
# Purpose:		Test bed for funct/functions stuff
# Versions:
#
# 25/Apr/2015	First version (implemented)
# 09/Dec/2016	Enhanced with [arity]
# 21/Jan/2022	Added try/catch. Not a unit test
########################################################################
# Notes:
########################################################################

textcolor yellow
puts "Testing function calls by arity ..."
textcolor
newline

# Call functions and funct
#foreach f [functions] { puts "$f->[chr 9][funct $f 1 ]"}
foreach f [functions] { 
	set a [arity $f]		# Returns -1 on error
	puts "Testing function '$f' (arity $a)"	
	try {	
		if {[== $a 0]} {
			puts "\[$f\] ->\t\t[funct $f]"
		} elseif {[== $a 1]} {
			set v1 [rnd 1 9]
			puts "\[$f $v1\] ->\t\t[funct $f $v1]"
		} elseif {[== $a 2]} {
			set v1 [rnd 1 9]
			set v2 [rnd 1 9]
			puts "\[$f $v1 $v2\] ->\t\t[funct $f $v1 $v2]"
		} else {
			puts "Arity '$a' not handled for function $f"
		}
	} catch {
		puts "Caught error"
	}
}

# EOF #