###########################################################################################
# File: 			test_funct_range.tcl
# Purpose:			Test file for function domain error trapping
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 07/Nov/2019	First version
###########################################################################################
# Notes:
###########################################################################################
/*
	Function		Range Limit
	--------------------------------------
	acos			-1 to +1
	asin			-1 to +1
	log				Positive numbers only
	log10			Positive numbers only
	sqrt			Positive numbers only
*/
###########################################################################################

###########################################################################################
# ACOS
set i 0
try {
	funct acos -1.1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr acos(-1.1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	funct acos 1.1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr acos(1.1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

###########################################################################################
# ASIN
set i 0
try {
	funct asin -1.1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr asin(-1.1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	funct asin 1.1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr asin(1.1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

###########################################################################################
# LOG
set i 0
try {
	funct log -1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr log(-1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

###########################################################################################
# LOG
set i 0
try {
	funct log10 -1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr log10(-1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

###########################################################################################
# SQRT
set i 0
try {
	funct sqrt -1
} catch {
	set i 1
}
assert $i -v -line #__LINE__

set i 0
try {
	expr(sqrt -1)
} catch {
	set i 1
}
assert $i -v -line #__LINE__

unset i -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #