###############################################################################################
# File:				test_functs.tcl
# Author:			M Shaw
# Purpose:			General sanity tests on expr functions
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 15/Dec/2017	Migrated from tests.tcl and fixed/updated
###############################################################################################
# Notes
###############################################################################################
option expression off 
 
set line #__LINE__

# funct ########################################################################
#abs acos asin atan ceil decr div cos double exp fix floor fraction hypot incr 
#int integral log log10 max min mul pow rand rnd round sgn sin sqrt srand tan
# http://www.rapidtables.com/calc/math/Arccos_Calculator.htm

# Check list of [expr] functions #
puts "Line: "#__LINE__
set functs [functions]

textcolor yellow
puts "Function count is: [lcount $functs]"
textcolor
assert [lcount $functs] {== $_ 40} -v -line #__LINE__

puts "Line: "#__LINE__
foreach x $functs { 
	#puts "Checking '[commands $x]' '$x' (is defined)" 
	assert [functions $x] {eq $_ $::x} -v -line #__LINE__
}

# functions
textcolor yellow
puts "[info script] Checking \[functions\]"
textcolor
assert [lcount [functions]] {>= $_ 31} -v -line #__LINE__
assert [lcount [functions a*]] {>= $_ 4} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
unset functs line x -nocomplain
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #