###########################################################################################
# File:				test_gets.tcl
# Author:			M Shaw
# Purpose:			Test file for [gets] command
#
# Versions:
# 1.00 04/Jul/2017	First version
# 1.01 09/Jul/2017	Added file read
# 1.02 23/Jan/2022	Updated
# 1.03 08/Feb/2022	Updated
###########################################################################################
# Notes:
###########################################################################################
option expression on
option echo on
halt

set filename lorem.txt

if {! [file exists $filename]} {
	die "Test dependency $filename is missing in [info script]"
}

puts "Line: "#__LINE__
puts "Reading $filename"
set fp [open $filename]

set lineNumber 0
set line {}
#while {[>= [gets $fp line] 0]} {				# Works ok
#while {[item [gets $fp line] 0] >= 0} {		# [gets $fp line] can return ""
while {! [file eof $fp]} {
	gets $fp line
    #puts "[$lineNumber]: read:'$line'"
	++ lineNumber
}

puts "Read in $lineNumber line(s)"
assert $lineNumber {> $_ 0} -v -line #__LINE__
assert $lineNumber {== $_ 128} -v -line #__LINE__			# Number of lines in the test file

###########################################################################################
/* # This works
puts "Line: "#__LINE__
set r [gets $fp line]
puts "fp is $fp, gets returned $r"
puts "line is '$line'"
while {$r >= 0} {
	puts "here"
    puts "lineNumber:[++ lineNumber]: line:$line"
	set r [gets $fp line]
} */
###########################################################################################

puts "Line: "#__LINE__
close $fp
set fp 0

###########################################################################################
/*
# Manual test
puts "Enter your name up to 20 characters: " -nonewline
gets a 20
newline
puts "You entered '$a'"
*/
puts "Line: "#__LINE__

unset line lineNumber fp -nocomplain

###########################################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #