############################################## #############################################
# File:				test_getsid.tcl
# Author:			M Shaw
# Purpose:			Tests for [try ... catch]
#
# Versions:
# 1.00 27/Jun/2016 First version
###########################################################################################
# Notes:
###########################################################################################
option expression off

textcolor yellow
puts "Testing \[test_getsid\] ..."
textcolor
newline

if {gt [info winver -vernum] 5.0} {				# 2k/XP or higher only

	set admin_sid [getsid administrator]
	set guest_sid [getsid guest]
	set administrators_sid [getsid administrators]

	puts "Guest SID:\t\t$guest_sid"
	puts "Administrator SID:\t$admin_sid"
	puts "Administrators SID:\t$administrators_sid"
	newline

	# puts "[expr ([ne $admin_sid ""] == 1) && ([ne $guest_sid ""] == 1) && ([ne $administrators_sid ""] == 1)]"
	#puts [expr [ne $admin_sid ""] && [ne $guest_sid ""]  && [ne $administrators_sid ""] ]

	if {expr [ne $admin_sid ""] && [ne $guest_sid ""] && [ne $administrators_sid ""] } {
	# if {expr ([ne $admin_sid ""] == 1) && ([ne $guest_sid ""] == 1) && ([ne $administrators_sid ""] == 1) } {
		assert [getsid administrator] {ne $_ ""}  -v -line #__LINE__
		assert [getsid administrators] {ne $_ ""}  -v -line #__LINE__
		assert [getsid guest] {ne $_ ""}  -v -line #__LINE__
		assert [ne $admin_sid $guest_sid] {== $_ 1} -v -line #__LINE__
		assert $administrators_sid {eq $_ "S-1-5-32-544"} -v -line #__LINE__
	} else {
		textcolor red
		puts "Failed to retrieve sids at line "#__LINE__
		textcolor
		stop
	}

	/*
	puts "Testing for leaks in getsid ..."
	newline

	set limit 100000
	for {set i 0} {< $i $limit} {++ i}  {		# No leaks
		# getsid admin # PASS
		getsid [username]
	}
	*/

	unset set admin_sid guest_sid administrators_sid -nocomplain
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #