###########################################################################
# File:				test_heapmem.tcl
# Author:			M Shaw
# Purpose:			Test bed for heap memory management
# Language:			Ticol Tcl v1.21+
#
# Versions:
# 1.00 20/Dec/2016	First version 
###########################################################################
# Notes:
# malloc free memset memcpy
###########################################################################
# FIX add -t terminate ? to memcpy ?
###########################################################################

set ptr [malloc 10]
puts "malloc ptr is $ptr"
set source Hello
memcpy $ptr [addressofb source] 6			# MUST copy length of string + 1 to copy the NULL char
puts "ofaddressb ptr =='[ofaddressb $ptr]'"
free $ptr


set a [malloc 256]
set s "hello"
memcpy $a [addressofb s] 5 -t				# Truncate
puts "a is '[ofaddressb $a]' (should be 'Hell' as string will be truncated using -t)"
newline

set limit 100000							# 2016/Dec/20 - No leaks
puts "looping for $limit loops ..."
for {set i 0} {< $i $limit} {++ i} {
	set ptr [malloc 10]
	memcpy $ptr [addressofb source] 6
	free $ptr
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "Done"
textcolor

# EOF #