############################################################################################
# File: 			test_if_args.tcl
# Purpose:			Test unusual [if] arguments
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 19/Oct/2019	First version
############################################################################################
# Notes:
# Non-standard
# Not included in tests.tcl
############################################################################################
/*
ActiveState 8.6
% set foo hi
hi
% if {$foo} {puts yes}
expected boolean value but got "hi"
*/
############################################################################################

option expression off

goto_block {
	goto 30
	10 {
		# FAILS
		set i 0
		catch {
			if {""} {
				set i 1
			}
		}
		assert $i {== $_ 1} -v -line #__LINE__
	}
	20 {
		# FAILS
		set i 0
		catch {
			if {$qbf} {
				set i 1
			}
		}
		assert $i {== $_ 1} -v -line #__LINE__

	}

	30 {								# http://blog.cleverly.com/permalinks/311.html
		option expression on
		set i 0
		set item fox
		assert [in $qbf $item] {== $_ 1} -v -line #__LINE__
		catch {
			# if {$item in $qbf} {		# in() not supported via [expr] but we could implement it. (we are at Tcl 8.1.1 here)
			if {[in $qbf $item]} {
				set i 1
			}
		}
		assert $i {== $_ 1} -v -line #__LINE__
	}
}
unset i item -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #