##########################################################################
# File:				test_if_comblogic.tcl
# Author:			M Shaw
# Purpose:			Test combining logic in if expressions
# 					with option expression on
# Language:			Ticol Tcl v1.19+
#
# Updates:
# 1.00	09/Dec/2015	First version
# 1.01	21/Jan/2022	Added to unit tests
##########################################################################
# Notes:
##########################################################################

option expression on

textcolor yellow
puts "Testing \[if\] with combined logic ..."
textcolor
newline

set a 1 # [rnd 0 1]
set b [rnd 0 1]
puts "a:$a | b:$b"
set i 0
if {$a | $b } {
	puts "Pass $a | $b"
	set i 1
} else {
	puts "Fail"
}
assert $i {== $_ 1} -v -line #__LINE__

set a 1 # [rnd 0 1]
set b 1 # [rnd 0 1]
set i 0
puts "a:$a & b:$b"
if {$a & $b } {
	puts "Pass $a & $b"
	set i 1
} else {
	puts "Fail"
}
assert $i {== $_ 1} -v -line #__LINE__

set a 0 # [rnd 0 1]
set b 1 # [rnd 0 1]
set i 0
puts "a:$a ^ b:$b"
if {$a ^ $b } {
	puts "Pass $a ^ $b"
	set i 1
} else {
	puts "Fail"
}
assert $i {== $_ 1} -v -line #__LINE__

/*
set i 0
if {[mids [date] 6 2] eq "12"} {
	puts "December"
} else {
	puts "Some other month"
}
*/

##########################################################################
option expression off 
unset a b i -nocomplain
newline
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #