########################################################################
# File:				test_include_array.tcl
# Author:			M Shaw
# Purpose:			Test file to include separately defined data
# Language:			Ticol Tcl v1.25+
# See also:			return_array_data.tcl
#
# Versions:
# 1.00 16/Dec/2017	First version 
########################################################################
# Notes:
# See also include.tcl (same idea)
# Reads: return_array_data.tcl
########################################################################
/*
# return_array_data.tcl #
return {
	1 {foo}
	2 {bar}
	3 {baz}
	4 {quux}
}
*/
########################################################################
option expression off

unset i -nocomplain
set include_file return_array_data.tcl
array unset data -nocomplain

textcolor yellow
puts "Including $include_file"
textcolor
newline

if {! [file exists $include_file ]} {
	die "Can't find test datafile $include_file"
}

array set data [source $include_file]

for {set i 1} {<= $i [array size data]} {++ i} {
	puts "$data($i)"
}

array walk data

assert $data(1) {eq $_ foo} -v -line #__LINE__
assert $data(2) {eq $_ bar} -v -line #__LINE__
assert $data(3) {eq $_ baz} -v -line #__LINE__
assert $data(4) {eq $_ quux} -v -line #__LINE__


unset i include_file -nocomplain
array unset data -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #