######################################################################################
# File: 			test_info_default.tcl
# Purpose:			Test for [info default]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.00 20/Oct/2017	First version
######################################################################################
# Notes: 
######################################################################################
option expression off

undef demo -nocomplain

proc demo {argument1 {default "DefaultValue"} } {
    puts "This is a demo proc.  It is being called with $argument1 and $default"
    #
    # We can use [info level] to find out if a value was given for
    # the optional argument "default" ...
    #
    puts "Actual call: [info level [info level]]"
}

puts "The args for demo are: [info args demo]\n"
puts "The body for demo is:  [info body demo]\n"

assert [info args demo] {eq $_ "argument1 default"} -v -line #__LINE__
newline

set arglist [info args demo]
textcolor cyan
puts "arglist is: '$arglist'"
textcolor

foreach arg $arglist {
	puts "arg: '$arg'"
    if {[info default demo $arg defaultval]} {
        puts "'$arg' has a default value of '$defaultval'"
    } else {
        puts "'$arg' has no default"
    }
}

textcolor cyan
puts "defaultval is $defaultval\r\n"
textcolor

puts [info default demo argument1 defaultval]

assert [info default demo argument1 defaultval] {== $_ 0} -v -line #__LINE__		# No default value
assert $defaultval {eq $_ ""} -v -line #__LINE__

assert [info default demo default defaultval] {== $_ 1} -v -line #__LINE__
assert $defaultval {eq $_ "DefaultValue"} -v -line #__LINE__

unset arg arglist defaultval -nocomplain
undef demo -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #