###########################################################################################
# File:			test_info_mem.tcl
# Author:		M Shaw
# Porpoise:		Test the [info mem*] commands
# Language:		Ticol Tcl v1.27+
#
# Versions:
# 1.00		06/Jan/2022 - First version
###########################################################################################
# Notes
# info memavail
# info memavailpage
# info memavailpage
# info memavailpage
# info memavailvirtual
# info memtotallvirtual
# info mempercentfree
###########################################################################################
textcolor yellow
puts "Testing \[info mem*\] commands in [file name [info script]]"
textcolor
newline

puts "Line "#__LINE__
puts [info memavail]
assert [info memavail] {> $_ 0} -v -line #__LINE__
puts [info memavailpage]
assert [info memavailpage] {> $_ 0} -v -line #__LINE__
puts [info memtotalpage]
assert [info memtotalpage] {> $_ 0} -v -line #__LINE__
puts [info memavailpage]
assert [info memavailpage] {> $_ 0} -v -line #__LINE__
puts [info memavailvirtual]
assert [info memavailvirtual] {> $_ 0} -v -line #__LINE__
puts [info memtotalvirtual]
assert [info memtotalvirtual] {> $_ 0} -v -line #__LINE__
newline


puts "Line "#__LINE__
puts [info memavail -mb]
assert [info memavail -mb] {> $_ 0} -v -line #__LINE__
puts [info memavailpage -mb]
assert [info memavailpage -mb] {> $_ 0} -v -line #__LINE__
puts [info memtotalpage -mb]
assert [info memtotalpage -mb] {> $_ 0} -v -line #__LINE__
puts [info memavailpage -mb]
assert [info memavailpage -mb] {> $_ 0} -v -line #__LINE__
puts [info memavailvirtual -mb]
assert [info memavailvirtual -mb] {> $_ 0} -v -line #__LINE__
puts [info memtotalvirtual -mb]
assert [info memtotalvirtual -mb] {> $_ 0} -v -line #__LINE__
newline

puts "Line "#__LINE__
puts "Test rejection of unknown arg"
set i 0
try {
	info memfoo
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__
newline

puts "Line "#__LINE__
puts "Test % free"
puts "[info mempercentfree] %"
assert [info mempercentfree] {> $_ 0} -v -line #__LINE__

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #