############################################################################################
# File:				test_inrange.tcl
# Author:			M Shaw
# Purpose:			Test the timed-delay [waitkey] feature
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 18/Aug/2019 First version
###########################################################################################
# Notes:
###########################################################################################
option expression off


textcolor yellow
puts "Quantative loop tests ..."
textcolor
set in 0
set out 0
set loops 10000
loop i 0 $loops {
	set r [rnd 600 1300]
	#puts "\[inrange $r 1000\]"
	if {[inrange $r 1000]} {
		#textcolor green
		#puts "$r is in range"
		++ in
	} else {
		#textcolor red
		#puts "$r out of range"
		++ out
	}
	textcolor
		#puts [inrange $r 1000]		# in range 1000 would be 900 to 1100
}
puts "Loop test: $in / $out"
puts "In range: [/ $loops $in]"
assert [/ $loops $in] {== $_ 3} -v -line #__LINE__
puts "In Range [/ $loops $out]"
assert [/ $loops $out] {== $_ 1} -v -line #__LINE__
unset i in out loops r
newline

textcolor yellow
puts "Specific case tests ..."
textcolor
assert [inrange 1 1] {== $_ 1} -v -line #__LINE__
assert [inrange 0 0] {== $_ 1} -v -line #__LINE__
assert [inrange -1 -1] {== $_ 1} -v -line #__LINE__
assert [inrange 10 10] {== $_ 1} -v -line #__LINE__
assert [inrange 9 10] {== $_ 1} -v -line #__LINE__
assert [inrange 11 10] {== $_ 1} -v -line #__LINE__
assert [inrange 8 10] {== $_ 0} -v -line #__LINE__
assert [inrange 12 10] {== $_ 0} -v -line #__LINE__

assert [inrange -9 -10] {== $_ 1} -v -line #__LINE__
assert [inrange -11 -10] {== $_ 1} -v -line #__LINE__
assert [inrange -8 -10] {== $_ 0} -v -line #__LINE__
assert [inrange -12 -10] {== $_ 0} -v -line #__LINE__
newline

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #