###########################################################################
# Name:				test_instr.tcl
# Purpose:			Testing [instr]
# Author:       	M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 29/Jan/2022 Implemented
###########################################################################
# Notes:
# See also test_strtok.tcl
###########################################################################
option expression off

textcolor yellow
puts "Testing \[instr\] (see also \[strtok\]) ..."
textcolor
newline

# NULL haystack 
assert [instr "" "foo"] {== $_ 0} -v -line #__LINE__
assert [instr "" "foo" -nocase] {== $_ 0} -v -line #__LINE__


# NULL needle
assert [instr "foo" ""] {== $_ 0} -v -line #__LINE__
assert [instr "foo" "" -nocase] {== $_ 0} -v -line #__LINE__
assert [instr $qbf ""] {== $_ 0} -v -line #__LINE__
assert [instr $qbf "" -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr $qbf {}] {== $_ 0} -v -line #__LINE__
assert [strstr $qbf {} -nocase] {== $_ 0} -v -line #__LINE__

# Needle not found case
assert [instr $qbf fred] {== $_ 0} -v -line #__LINE__
assert [instr $qbf FOX] {== $_ 0} -v -line #__LINE__		# Case not matched

#Needle found cases
assert [instr $qbf fox] {== $_ 17} -v -line #__LINE__
assert [instr $qbf QUICK -nocase] {== $_ 5} -v -line #__LINE__

# Identity case
assert [instr $qbf $qbf] {== $_ 1} -v -line #__LINE__
assert [instr $qbf $qbf -nocase] {== $_ 1} -v -line #__LINE__

assert [!= [instr $qbf lazy] 0] {== $_ 1} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #