#################################################################
# File:				test_ipstuff.tcl
# Purpose:			Testing various IP related commands
# Author:			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 25/Nov/2017	First version
#################################################################
# Notes:
# See also: test_misc.tcl
# cidr_match     (Misc plugin)
# ip_match       (Misc plugin)
# is_mac         (Misc plugin)
#################################################################

option expression off
option echo on

textcolor yellow
puts "Testing string \[ip_to_long\] \[long_to_ip\] ..."
textcolor
newline

assert [long_to_ip [ip_to_long "127.0.0.1"]] {eq $_ "127.0.0.1"} -v -line #__LINE__
assert [long_to_ip [ip_to_long "10.11.12.13"]] {eq $_ "10.11.12.13"} -v -line #__LINE__
assert [long_to_ip [ip_to_long "83.218.158.10"]] {eq $_ "83.218.158.10"} -v -line #__LINE__
assert [long_to_ip [ip_to_long "1.2.3.4"]] {eq $_ "1.2.3.4"} -v -line #__LINE__


########################################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #
