###################################################################################
# File: 			test_join.tcl
# Purpose:			Test file for [join]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.01 29/Oct/2017	First version
###################################################################################
# Notes: 
###################################################################################
option expression off
option echo on

textcolor yellow
puts "Testing \[join\]"
textcolor
newline

try {
	assert [join {} "-"] {eq $_ ""} -v -line #__LINE__
} catch {
	puts "Error before line "#__LINE__
}
assert [join {} {}] {eq $_ ""} -v -line #__LINE__
assert [join "" "-"] {eq $_ ""} -v -line #__LINE__
assert [join "" ""] {eq $_ ""} -v -line #__LINE__
assert [join " " "-"] {eq $_ ""} -v -line #__LINE__
assert [join "\t \t" "-"] {eq $_ ""} -v -line #__LINE__
assert [join " \t " "-"] {eq $_ ""} -v -line #__LINE__
assert [join a "-"] {eq $_ a} -v -line #__LINE__
assert [join "a b" "-"] {eq $_ "a-b"} -v -line #__LINE__
assert [join "a b" " "] {eq $_ "a b"} -v -line #__LINE__
assert [join "a\tb" " "] {eq $_ "a b"} -v -line #__LINE__
assert [join "a b" "  "] {eq $_ "a  b"} -v -line #__LINE__
assert [join "a b" "\t"] {eq $_ "a\tb"} -v -line #__LINE__
assert [join "a b c" "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join "a\tb\tc" "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join "a b c " "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join "a    b     c " "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join " a b c " "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join "\ta b c " "-"] {eq $_ "a-b-c"} -v -line #__LINE__
assert [join "\ta b c\t" "-"] {eq $_ "a-b-c"} -v -line #__LINE__

set s "The quick brown fox"
assert [join $s "-"] {eq $_ "The-quick-brown-fox"} -v -line #__LINE__
assert [join "\t$s\t" "-"] {eq $_ "The-quick-brown-fox"} -v -line #__LINE__

# Flatten a list
set s {1 {2 3} 4 {5 {6 7} 8}}
#     => 1 2 3 4 5 {6 7} 8
assert [join $s] {eq $_ "1 2 3 4 5 {6 7} 8"} -v -line #__LINE__		# Is this correct?

unset s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #