###########################################################################################
# File:				test_lassign.tcl
# Author:			M Shaw
# Purpose:			Test the [lassign] command
#
# Versions:
# 1.00 23/Jun/2016 First version using [assert]
###########################################################################################
# Notes:
###########################################################################################

set q [lassign {a b c "The quick" "brown fox" "jumps"} x y z]

puts "x=='$x'" 
assert $x {eq $_ a} -v -line #__LINE__					# VAR1
puts "y=='$y'"  
assert $y {eq $_ b} -v -line #__LINE__					# VAR2
puts "z=='$z'"  
assert $z {eq $_ c} -v -line #__LINE__					# VAR3
puts "q=='$q'"  
assert $q {eq $_ "{The quick} {brown fox} jumps"} -v -line #__LINE__	# REMAINDER


set q [lassign {a b c d e f "The quick" "brown fox" "jumps"} u v w x y z]

puts "u=='$u'" 
assert $u {eq $_ a} -v -line #__LINE__					# VAR1
puts "v=='$v'"  
assert $v {eq $_ b} -v -line #__LINE__					# VAR2
puts "w=='$w'"  
assert $w {eq $_ c} -v -line #__LINE__					# VAR3
puts "x=='$x'" 
assert $x {eq $_ d} -v -line #__LINE__					# VAR1
puts "y=='$y'"  
assert $y {eq $_ e} -v -line #__LINE__					# VAR2
puts "z=='$z'"  
assert $z {eq $_ f} -v -line #__LINE__					# VAR3
puts "q=='$q'"  
assert $q {eq $_ "{The quick} {brown fox} jumps"} -v -line #__LINE__	# REMAINDER


set q [lassign {a b c "The quick" "brown fox" "jumps"} u v w x y z]

puts "u=='$u'" 
assert $u {eq $_ a} -v -line #__LINE__					# VAR1
puts "v=='$v'"  
assert $v {eq $_ b} -v -line #__LINE__					# VAR2
puts "w=='$w'"  
assert $w {eq $_ c} -v -line #__LINE__					# VAR3
puts "x=='$x'" 
assert $x {eq $_ "The quick"} -v -line #__LINE__		# VAR1
puts "y=='$y'"  
assert $y {eq $_ "brown fox"} -v -line #__LINE__		# VAR2
puts "z=='$z'"  
assert $z {eq $_ "jumps"} -v -line #__LINE__			# VAR3
puts "q=='$q'"  
assert $q {eq $_ ""} -v -line #__LINE__					# REMAINDER


set q [lassign {a b c} u v w x y z]						# Insufficient list items (x3 are "{}")

puts "u=='$u'" 
assert $u {eq $_ a} -v -line #__LINE__					# VAR1
puts "v=='$v'"  
assert $v {eq $_ b} -v -line #__LINE__					# VAR2
puts "w=='$w'"  
assert $w {eq $_ c} -v -line #__LINE__					# VAR3
puts "x=='$x'" 
assert $x {eq $_ ""} -v -line #__LINE__					# VAR1
puts "y=='$y'"  
assert $y {eq $_ ""} -v -line #__LINE__					# VAR2
puts "z=='$z'"  
assert $z {eq $_ ""} -v -line #__LINE__					# VAR3
puts "q=='$q'"  
assert $q {eq $_ ""} -v -line #__LINE__					# NULL REMAINDER

set q [lassign {a b c d e f} u v w x y z]				# No remainder

puts "u=='$u'" 
assert $u {eq $_ a} -v -line #__LINE__					# VAR1
puts "v=='$v'"  
assert $v {eq $_ b} -v -line #__LINE__					# VAR2
puts "w=='$w'"  
assert $w {eq $_ c} -v -line #__LINE__					# VAR3
puts "x=='$x'" 
assert $x {eq $_ d} -v -line #__LINE__					# VAR1
puts "y=='$y'"  
assert $y {eq $_ e} -v -line #__LINE__					# VAR2
puts "z=='$z'"  
assert $z {eq $_ f} -v -line #__LINE__					# VAR3
puts "q=='$q'"  
assert $q {eq $_ ""} -v -line #__LINE__					# NULL REMAINDER


unset q u v w x y z -nocomplain

###########################################################################################
newline
vars 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #