###################################################################################
# File: 			test_ldepth.tcl
# Purpose:			Test file for proc [ldepth]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.01 29/Oct/2017	First version
###################################################################################
# Notes: 
###################################################################################
option expression off
option echo on

textcolor yellow
puts "Testing proc \[ldepth\]"
textcolor
newline

undef ldepth -nocomplain
#unset l -nocomplain	

puts "procs '[procs l*]'"

puts "Line: "#__LINE__
proc ldepth {list} {
	puts "Enter ldepth '$list'"
	if {! [is_list $list]} {
		puts "'$list' is not a list"
		return 0 
	}
	set flatlist [join $list]
	if {[string equal $flatlist $list]} {
		puts "ldepth: lists are equal"
		return 1 
	}
	puts "\$flatlist = '$flatlist"
	# expr may be interpreting result as a return code
	#return [expr [return -code return]+1]
	#puts [expr "[ldepth $flatlist] + 1"]
	#return [expr [ldepth $flatlist] + 1]			# PASS
	
	#return [expr {[ldepth $flatlist] + 1}]			# PASS OK without /NEO fails with!
	# DONE FAIL return [expr {[ldepth $flatlist] + 1}]	# FAIL /NEO
	# PASS return [expr [ldepth $flatlist] + 1]		# BRACES stripped
	
	return [expr "[ldepth $flatlist] + 1"]			# FAIL Does not like this! (OK with /NEO)
	# DONE FAIL return [expr {[ldepth $flatlist] + 1}] 	# FAIL Without /NEO
	# PASS return [expr "[ldepth $flatlist] + 1"]	# PASS
	
	#return [+ [ldepth $flatlist] 1]				# PASS
	#return [expr 1+2]								# PASS
}

puts "Line: "#__LINE__

# Man example 
textcolor yellow
puts "man file exmaple"
textcolor
set l {}
puts "Should be 0: [ldepth $l]"
assert [ldepth $l] {== $_ 0} -v -line #__LINE__
set l a
puts "Should be 1: [ldepth $l]"
assert [ldepth $l] {== $_ 1} -v -line #__LINE__
set l "ata b"
puts "Should be 1: [ldepth $l]"
assert [ldepth $l] {== $_ 1} -v -line #__LINE__
set l "a {b {c d {e f}}}"
puts "Should be 4: [ldepth $l]"
assert [ldepth $l] {== $_ 4} -v -line #__LINE__
# exit
set l "a {b {c {d {e}}}"
puts "Should be 5: [ldepth $l]"
assert [ldepth $l] {== $_ 5} -v -line #__LINE__
newline

puts "Line: "#__LINE__
set l {}
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 0} -v -line #__LINE__

puts "Line: "#__LINE__
set l a
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 1} -v -line #__LINE__

puts "Line: "#__LINE__
set l {a b}
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 1} -v -line #__LINE__

puts "Line: "#__LINE__
set l {a {b c}}
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 2} -v -line #__LINE__

puts "Line: "#__LINE__
set l {a {b {c d}}}
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 3} -v -line #__LINE__

puts "Line: "#__LINE__
set l {a {b {c {d e}}}}
puts "ldepth $l at line "#__LINE__
assert [ldepth $l] {== $_ 4} -v -line #__LINE__

puts "Line: "#__LINE__


unset l -nocomplain
undef ldepth -nocomplain
###################################################################################
newline
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #