#################################################################################
# File: 			test_bigfib.tcl
# Purpose:			Tests for [big fib]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 18/Dec/2018	First version
#################################################################################
# Notes:
# DONE FIX ::bignum::fib requires 64-bit cast
# Test big fib against fib
#################################################################################
option expression off
option echo on

# If 1 is set as a var it will break the tests
# When 1 resolves to 1 and [fib] or [unsigned] pick it up as a var 
# Good reason to remove all auto-detection on vars!
#set 1 Hi
if {info exists 1} { die "1 exists as a var!!"}

lib ticol_bignum -unload -nocomplain
lib ticol_bignum -verbose

unset i -nocomplain

for {set i 0} {< $i 94} {++ i} {			# Our limit is 93
	textcolor yellow
	puts "$i -> " -nonewline
	textcolor green
	puts "BIG:[big fib $i] " -nonewline
	textcolor red
	puts "STD:[fib $i] " -nonewline
	textcolor yellow
	puts "UNSIGNED:[unsigned [fib $i]] i:[unsigned $i]"
	puts "\[== [big fib $i] [unsigned [fib $i]]\] fib:[fib $i]"
	assert [== [big fib $i] [unsigned [fib $i]]] {== $_ $::true} -v -line #__LINE__
}

lib ticol_bignum -unload -verbose

unset i -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #