###################################################################################
# File: 			test_cpu.tcl
# Purpose:			Test file for [cpu] plugin
# Author: 			M Shaw
# Language:			Ticol Tcl v1.23+ and ticol_cpu.dll v1.01+
#
# Versions:
# 1.00 25/Aug/2017	First test version. Mods added for -glob deletion
# 1.01 18/Oct/2017	Add register test (edx)
###################################################################################
# Notes: 
# Very rudimentary CPU information using __asm cpuid calls
###################################################################################

textcolor yellow
puts "Testing lib ticol_cpu ..."
textcolor
newline

lib ticol_cpu -verbose -nocomplain
newline

textcolor magenta
puts "Name:\t\t[cpu name]"
puts "Vendor:\t\t[cpu vendor]"
puts "Cores:\t\t[cpu cores]"
puts "Bitness:\t[cpu bitness]"
puts "Hypervisor:\t[cpu hypervisor]"
puts "Hyperthreading:\t[cpu hyperthreading]"
textcolor
newline

assert [cpu name] {ne $_ ""}  -v -line #__LINE__
# Was 40 on TREEBEARD due to trim
#assert [string length [cpu name]] {== $_ 47}  -v -line #__LINE__
assert [cpu vendor] {ne $_ ""}  -v -line #__LINE__
assert [cpu cores] {> $_ 0}  -v -line #__LINE__
assert [cpu bitness] {|| [== $_ 32] [== $_ 64]}  -v -line #__LINE__
assert [cpu hypervisor] {< $_ 2}  -v -line #__LINE__
assert [cpu hyperthreading] {< $_ 2}  -v -line #__LINE__
newline

textcolor magenta
puts "eax [inttohex [cpu eax]]"
puts "ebx [inttohex [cpu ebx]]"
puts "ecx [inttohex [cpu ecx]]"
puts "edx [inttohex [cpu edx]]"
textcolor
newline

assert [cpu eax] {!= $_ 0}  -v -line #__LINE__
assert [cpu ebx] {!= $_ 0}  -v -line #__LINE__
assert [cpu ecx] {!= $_ 0}  -v -line #__LINE__
assert [cpu edx] {!= $_ 0}  -v -line #__LINE__
newline

puts "Virtual Machine Extensions " -nonewline
if {& [cpu edx] 0x2} {
	puts "present"
} else {
	puts "not present"
}

lib ticol_cpu -unload
newline
puts "Modules cp* '[commands cp*]'"
###################################################################################
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #