######################################################################################
# File: 			test_lib_cscript.tcl
# Purpose:			Test LIB ticol_cscript.dll plugin
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 12/Oct/2019	First dev version working (VBScript only)
######################################################################################
# Notes:
# The only test which is run is that a default script does not fail to run
# ticol_cscript.dll exposes only VBScript and not WScript
# A -js argument is currently present but JScript doesn't seem to work well
# FAIL Test on ROS (0.4.12) (exception in cscript) no vbscript?
# FAIL Test on ROS (0.4.4) (exception in cscript) no vbscript?
# DONE PASS Test on Windows NT4/SP6a
# DONE PASS Test on Windows 2000
# DONE ADD console stdout/stderr ability
# ADD Wide call as [wcscript] ?
#	Same code, just ignore AToB conversion and pass as LPSTR -> BSTR
# FIX Change from VBScript to CScript or switch between to get console output
# ADD Return values so we can test
# FIX Implement CScript echo to console so we can test
# ADD Javascript!!
######################################################################################

#puts [array item env windir -nocase]
if {eqi [array item env windir -nocase] "C:\\ReactOS"} {	# No SMB stack on ROS yet
	puts "Not running [info script] on ReactOS"
	return
}

lib ticol_cscript

puts "Line: "#__LINE__
# https://docs.microsoft.com/en-us/previous-versions/windows/internet-explorer/ie-developer/scripting-articles/zk6wed09%28v=vs.84%29
#set s "msgbox ScriptEngine"									# PASS
#set s "eval(22/7.0)"
#set s "msgbox \"Hello from Ticol Tcl\"" # PASS
#set s "msgbox eval(22/7.0),,\"Ticol Tcl (Default)\""						# PASS
#set s "WScript.Echo \"Hello World!\""							# FAILS
#set s "debug.print \"Hello World!\""							# FAILS
#set s "Echo \"Hello World!\""									# FAILS
#set s "Console.WriteLine \"Hello World!\""						# FAILS
#set s "MsgBox \"Hello World! The current time is: \" & Now"
#set s "MsgBox \"Hello from Ticol Tcl!!\""
#set s "r=InputBox(\"Enter something:\", \"Input\")
#msgbox r"
# /*
###########################################################################
set s "
Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)
stdout.WriteLine \"Hello from VBScript\""

/*
puts "Line: "#__LINE__
set s "Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)
Function RegExpTest(patrn, strng)
   Dim regEx, Match, Matches   ' Create variable.
   Set regEx = New RegExp   ' Create a regular expression.
   regEx.Pattern = patrn   ' Set pattern.
   regEx.IgnoreCase = True   ' Set case insensitivity.
   regEx.Global = True   ' Set global applicability.
   Set Matches = regEx.Execute(strng)   ' Execute search.
   For Each Match in Matches   ' Iterate Matches collection.
      RetStr = RetStr & \"Match found at position \"
      RetStr = RetStr & Match.FirstIndex & \". Match Value is '\"
      RetStr = RetStr & Match.Value & \"'.\" & vbCRLF
   Next
   RegExpTest = RetStr
End Function
stdout.WriteLine \"RegExpTest(\"is.\", \"IS1 is2 IS3 is4\"))"				# */
###########################################################################
# VB -> JScript
# http://ramblings.mcpher.com/Home/excelquirks/snippets/scriptcontrol
/*
puts "Line: "#__LINE__
set s "Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)
Set o = CreateObject (\"Scripting.Jscript\")	' Fails
'Dim o As New ScriptControl						' Fails
'o.Language = \"JScript\"
'With o
	'.AddCode \"function x(a,b) {return 'the answer is:' +(a+b);}\"
	'stdout.WriteLn .Run(\"x\", 1, 2)
'End With
" 
# */
###########################################################################
/*
puts "Line: "#__LINE__
set s "
Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)

Class Customer
   Private m_CustomerName
   Private m_OrderCount

   Private Sub Class_Initialize
      m_CustomerName = \"\" ' This MUST be double-escaped even though empty dquotes are lawful
      m_OrderCount = 0
   End Sub

   ' CustomerName property.
   Public Property Get CustomerName
      CustomerName = m_CustomerName
   End Property

   Public Property Let CustomerName(custname)
      m_CustomerName = custname
   End Property

   ' OrderCount property (read only).
   Public Property Get OrderCount
      OrderCount = m_OrderCount
   End Property

   ' Methods.
   Public Sub IncreaseOrders(valuetoincrease)
      m_OrderCount = m_OrderCount + valuetoincrease
   End Sub
End Class

Dim c
Set c = New Customer
c.CustomerName = \"Fabrikam, Inc.\"
'MsgBox c.CustomerName
stdout.WriteLine \"Customer name is: \" & c.CustomerName

c.IncreaseOrders(5)
c.IncreaseOrders(3)
'MsgBox c.OrderCount & \" (should be 8)\"
stdout.WriteLine \"Order count is \" & c.OrderCount & \" (Should be 8)\"
" 
# */
###########################################################################
#set s "wscript.stdout.write \"Hello\""		# DNW

###########################################################################
# YAY! Console output!! :)
set writeline "
Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)
'stdout.WriteLine \"This will go to standard output.\"
'stderr.WriteLine \"This will go to error output.\"
" # Must have a trailing CRLF
###########################################################################
/*
puts "Line: "#__LINE__
set s $writeline 
append s "
r=InputBox(\"Enter something:\", \"Input\")
stdout.WriteLine \"You entered \" & r 
" # */
###########################################################################
#set s $writeline
#append s "stdout.Writeline \"VBScript says: \" & eval(22/7.0)"
#set s "eval(22/7.0)"			# No return value
# set s "msgbox eval(22/7.0),,\"Ticol Tcl\""						# PASS
###########################################################################
# JSCRIPT FILE
/*
puts "Line: "#__LINE__
set s [readfile test.js]
cscript $s -jscript
die	# */
###########################################################################
# VBSCRIPT FILE
puts "Line: "#__LINE__
/*
puts "Line: "#__LINE__
set s [readfile version.vbs]
cscript $s
die	# */
###########################################################################
puts "Line: "#__LINE__
/*
puts "Line: "#__LINE__
set s "
Set fso = CreateObject (\"Scripting.FileSystemObject\")
Set stdout = fso.GetStandardStream (1)
Set stderr = fso.GetStandardStream (2)
'Set fso = CreateObject (\"Scripting.TextStream\")
'Set fso = CreateObject (\"Application.UDToolLib\")	' FAILS
'Set SortedList = CreateObject(\"System.Collections.SortedList\") 		' PASS
'Set SortedList = CreateObject(\"System.Collections.Queue\") 			' PASS
'Set SortedList = CreateObject(\"System.Collections.ArrayList\")		' PASS 
'https://www.itprotoday.com/devops-and-software-development/understanding-vbscript-windows-shell-object-model
'Set obj = CreateObject(\"Shell.Application\") 							' PASS
'obj.FindFiles
'obj.ControlPanelItem(\"desk.cpl\")										' PASS
'obj.ControlPanelItem (\"sysdm.cpl,@0,2\")								' FAIL
' /////////////////////////////////////////////////////////////////////////////////////// PASS
Set objLocator = CreateObject(\"WbemScripting.SWbemLocator\")
Set objService = objLocator.ConnectServer(\".\", \"root\\cimv2\")
objService.Security_.ImpersonationLevel = 3 
Set Jobs = objService.ExecQuery(\"SELECT * FROM Win32_ScheduledJob\")
i=0
For each Job in Jobs
    i = i+1   
    stdout.WriteLine Job.JobId & \"  \" & Job.Command & VBNewLine
Next
If i = 0 Then
    stdout.WriteLine \"No Jobs Scheduled with the AT command were found\"
End If
' ///////////////////////////////////////////////////////////////////////////////////////
" 
# */
###########################################################################
puts "Line: "#__LINE__
/*
puts "Line: "#__LINE__
# Will not run in NT4.0
set s "
	Set fso = CreateObject (\"Scripting.FileSystemObject\")
	Set stdout = fso.GetStandardStream (1)
	strComputer = \".\"
	Set objWMIService = GetObject(\"winmgmts:\\\\\" & strComputer & \"\\root\\CIMV2\")
	Set colItems = objWMIService.ExecQuery(\"SELECT * FROM Win32_ComputerSystem\")
	For Each objItem In colItems
	  stdout.WriteLine \"Name: \t\t\" & objItem.Name
	  stdout.WriteLine \"Manufacturer:\t\" & objItem.Manufacturer
	  stdout.WriteLine \"Model: \t\t\" & objItem.Model
	Next
	stdout.WriteLine 
" 
# */

###########################################################################
/*
set s "
Set obj = CreateObject(\"System.Management\")		' Not a valid object
" # */

puts "Line: "#__LINE__
#pause
#puts "test_cscript: Outbound Length=[string length $s]"
#puts [unescape $s]
puts "Calling \[cscript\] ..."
textcolor magenta
cscript [unescape $s]
textcolor
#cscript "MsgBox \"Hello World! The current time is: \" & Now"
#cscript "MsgBox \\\"Hello World! The current time is: \\\" & Now"
# exit


###########################################################################
# Leak test (no screen output)
# FIX is leaking
/*
set s ""
puts "Looping..."
time {
	cscript [unescape $s]
} 100000
# */

lib ticol_cscript -unload

unset s writeline -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #