###################################################################################
# File: 			test_libdns.tcl
# Purpose:			Test file for ticol_dns.dll (lib dns)
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.01 07/Oct/2017	First version
# 1.02 30/Dec/2021	Enhanced for Win2k tests
###################################################################################
# Notes: 
# 2k/XP and higher only
###################################################################################
option expression off

puts "Line :"#__LINE__
if {> [info winver -vernum] 4.0} {			# 2k/XP and higher only
	puts "Running lib ticol_dns tests on Windows [info winver -vernum]"
	newline

	puts "Line :"#__LINE__
	lib ticol_dns -nocomplain -verbose
	lib ticol_ping -nocomplain -verbose

	puts "Line :"#__LINE__
	if {eq [ping localhost] {127.0.0.1}} {
		puts "Localhost ping success. Testing DNS..."
		if {> [info winver -vernum] 5.0} {			# XP and higher only
			assert [dns "127.0.0.1"] {eq $_ "127.0.0.1"} -v -line #__LINE__
		}
		assert [dns localhost] {eq $_ "127.0.0.1"} -v -line #__LINE__
		# assert [rdns 127.0.0.1] {ne $_ ""} -v -line #__LINE__		# Disabled as rdns is a bit hit and miss
	} else {
		textcolor red
		puts "Can't ping 127.0.0.1 - network may be down. Test cancelled"
		puts "A live network with responsive DNS server is required"
		textcolor
	}
	puts "Line :"#__LINE__
	lib ticol_ping -unload
	lib ticol_dns -unload
} else {
	puts "NOT Running lib ticol_dns tests on Windows [info winver -vernum]"
	newline

}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #