######################################################################################
# File: 			test_html_chomp.tcl
# Purpose:			Test [html chomp_tag]
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 08/Dec/2017	First version
# 1.01 14/Aug/2018	Improved tests
######################################################################################
# Notes: 
# Big leak
######################################################################################
option expression off

lib ticol_html -verbose -nocomplain

#html test 100000;die

set code "<html><head></head><body bgcolor=black text=white><h1><center>\
<font face=\"Arial\">Ticol Tcl CGI<font color=\"#D62C35\">F</font>\
<font color=\"#4757F7\">i</font><font color=\"#5D36ED\">b</font>\
	<font color=\"#CD5739\">o</font><font color=\"#D82733\">n</font>\
  <font color=\"#341EEA\">a</font><font color=\"#02F559\">c\
	</font><font color=\"#5EDC41\">c</font>\
<font color=\"#3A2AE5\">i</font> Demo</font></center></h1><center><em>"

# 30 tags 

#set s [http http://localhost:8800]
set s $code
set i 1
do {
	set t [html chomp_tag s]
	if {ne $t ""} {
		puts "$i\t$t"
	}
	++ i
} while {ne $t ""}

set s $code
assert [html chomp_tag s] {eq $_ "<html>"} -v -line #__LINE__
assert [html chomp_tag s] {eq $_ "<head>"} -v -line #__LINE__
assert [html chomp_tag s] {eq $_ "</head>"} -v -line #__LINE__
assert [html chomp_tag s] {eq $_ "<body bgcolor=black text=white>"} -v -line #__LINE__
unset t -nocomplain


#set s $code
html chomp_tag s		# h1
html chomp_tag s		# center
html chomp_tag s r		# font

	# FIX 
/*
assert: Line 38: Assertion failed: '<font face=\"Arial\">Ticol Tcl CGI<font colo
r=\"#D62C35\">F</font><font color=\"#4757F7\">i</font><font color=\"#5D36ED\">b<
/font><font color=\"#CD5739\">o</font><font color=\"#D82733\">n</font><font colo
r=\"#341EEA\">a</font><font color=\"#02F559\">c</font><font color=\"#5EDC41\">c<
/font><font color=\"#3A2AE5\">i</font> Demo</font></center></h1><center><em>' !=
*/

assert $r {eq $_ ""} -v -line #__LINE__
html chomp_tag s r			# Get the string in r
puts "'$r'"
assert $r {eq $_ "Ticol Tcl CGI"} -v -line #__LINE__

#####################################################################################
set s $code
do {
	set t [html chomp_tag s]
	if {ne $t ""} {
		lappend l $t
	}
} while {ne $t ""}

puts $l

assert [lcount $l] {== $_ 30} -v -line #__LINE__
unset l t -nocomplain

#####################################################################################


set s "	<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\
<html><head><title>Hello world</title></head><body>\
Hello World\
</body></html>"
assert [html chomp_tag s t -nobrackets] {eqn $_ "!doctype" 8 -nocase} -v -line #__LINE__ 	# 1) doctype
assert [html chomp_tag s t] {eq $_ "<html>"} -v -line #__LINE__ 	# 2) html
assert $t {eq $_ ""} -v -line #__LINE__
assert [html chomp_tag s t] {eq $_ "<head>"} -v -line #__LINE__ 	# 3) head
assert $t {eq $_ ""} -v -line #__LINE__
assert [html chomp_tag s t] {eq $_ "<title>"} -v -line #__LINE__ 	# 4) title
assert $t {eq $_ ""} -v -line #__LINE__
assert [html chomp_tag s t] {eq $_ "</title>"} -v -line #__LINE__ 	# 5) /title
puts $t						# Hello world
assert $t {eq $_ "Hello world"} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# PASS (no leaks) 12 microsecond(s) per iteration
#set t ""
option echo on
puts "Line: "#__LINE__
set start_time [timer]
puts "Loop test..."

time {
set s "	<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\
<html><head><title>Hello world</title></head><body>\
Hello World\
</body></html>"
	
/*	
	puts [html chomp_tag s]
	puts [html chomp_tag s]
	puts [html chomp_tag s]
	puts [html chomp_tag s]
	puts $s	# */

	html chomp_tag s		# 1 ) 	# No leaks
	html chomp_tag s		# 2 )	# No leaks
	html chomp_tag s		# 3 )	# No leaks
	html chomp_tag s		# 4 )	# No leaks */
	#puts "s='$s'"
	#html chomp_tag s t		# 5) 	# Hello world
} 10000			# Standalone test: use 10000
#} 1000000			# Standalone test: use 1000000

newline
set end_time [timer]
assert $t {eq $_ "Hello world"} -v -line #__LINE__
printf "Took %.3f s" [/ [- $end_time $start_time] 1000.0]

newline
unset code end_time i r s start_time t -nocomplain
lib ticol_html -unload -nocomplain

#####################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #