###############################################################################
# File: 		test_lib_ini.tcl
# Purpose:		Test file for [lib ticol_ini]
# Author: 		M Shaw
# Language:		Ticol Tcl v1.20c+ ... v1.23+
#
# Versions:
# 1.00 28/Nov/2016 First version
# 1.01 23/Jul/2017	[checkex] replaced with [assert]
###############################################################################
# Notes:
# FIXED Tiny Leak after thousands of repeated calls
# "1" was not being released in List object pair in the MPP
###############################################################################

textcolor yellow
puts "Teting lib ticol_ini.dll ..."
textcolor
newline

option expression off
textcolor cyan
lib ticol_ini -verbose -nocomplain
textcolor
newline

set inifile test_ini.ini
																								# 100 tests (Kb leaked) Individual
assert [ini write $inifile config testKey Hello] {== $_ 1} -v -line #__LINE__					# 12 Kb
assert [ini read $inifile config testKey] {eq $_ Hello} -v -line #__LINE__						# 12
assert [ini write bool $inifile config testKeyBool 1] {== $_ 1} -v -line #__LINE__				# 12
assert [ini read bool $inifile config testKeyBool] {== $_ 1} -v -line #__LINE__					# 12
assert [ini write bool $inifile config testKeyBool 0] {== $_ 1} -v -line #__LINE__				# 12
assert [ini read bool $inifile config testKeyBool] {== $_ 0} -v -line #__LINE__					# 12
assert [ini write bool $inifile config testKeyBoolTrue TRUE] {== $_ 1} -v -line #__LINE__		# 12
assert [ini read bool $inifile config testKeyBoolTrue] {== $_ 1} -v -line #__LINE__				# 12
assert [ini write bool $inifile config testKeyBoolFalse FALSE] {== $_ 1} -v -line #__LINE__		# 12
assert [ini read bool $inifile config testKeyBoolFalse] {== $_ 0} -v -line #__LINE__			# 12
# * ALL == 4Kb #


#vars a		# 84Kb / 1000 due to _vsnprintf

#is_set a

if {[is_set a]} {
	textcolor red
	puts "a is already set"
	textcolor
	#array walk a
	pause
	array unset a -nocomplain
}

#/*

array set a {   0 Zero			# Can be a base 0 or base 1 array  but must be integer indexed
				1 One
				2 Two
				3 Three
				4 Four
				5 Five
} # Can't unset a const array

# TODO
@ type $inifile
assert [ini array write $inifile config Item a] {== $_ 1} -v -line #__LINE__			# Array must be base 0 or base 1 indexed

textcolor darkyellow
puts ----------------------------------------------------------------------
textcolor
@ type $inifile
#assert [ini array read $inifile config Item q -max 750] {== $_ 6}
# DONE FIX Exception in [INI] at line 244
unset q -nocomplain				# [ini array] must be called with empty output var
assert [ini array read $inifile config Item q] {== $_ 6} -v -line #__LINE__
textcolor darkyellow
puts ----------------------------------------------------------------------
textcolor

array walk q
option echo on

# */

array unset a -nocomplain
array unset q -nocomplain
	
lib ticol_ini -unload

array unset a -nocomplain
unset inifile 

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #