#############################################################################################
# File:				test_lib_load_unload.tcl
# Purpose:			Loop test repeated lib load/unload cycles for handle/mem leaks
# Author:			M Shaw
# Language:			Ticol Tcl v1.22+
#
# Versions:
# 1.00 27/Jan/2017	First version as tests.tcl shows leaks in test_reg.tcl
#############################################################################################
# Notes:
# Not a unit test as this is very time consuming and needs a visual trace
# NO LEAKS
# 2022/Jan/19
# 2022/Feb/27
#############################################################################################

set limit 100000 

textcolor yellow
puts "Running $limit lib load/unload cycles"
textcolor

ls ticol_*.dll -array a
puts "Running memory leak test via load/unload cycle of [array size a] module(s)"

time {
	array foreach a x {
		lib $x
		lib $x -unload
	}
} $limit

/*
time {
	lib ticol_reg 
	lib ticol_reg -unload
} $limit
# */

newline
puts "Done"

# EOF #