###################################################################################
# File: 			test_libping.tcl
# Purpose:			Test file for ticol_ping.dll (lib ping)
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.01 07/Oct/2017	First version
###################################################################################
# Notes: 
# FIX Not working in ReactOS 0.4.8
# DONE FIX Not working in Win2k
###################################################################################

textcolor yellow
puts "Testing lib ticol_ping.dll ..."
textcolor
newline

option expression off

puts "WINDIR == '$env(windir)'"
if {eqi $env(windir) "c:\\reactos"} {
	puts "Can't test on ReactOS"
	# return -code exit		# Exits the parent
	# return -code ok			# Does not exit
	return -code return
	# exit
}

puts "Line: "#__LINE__

lib ticol_ping -nocomplain
puts "ticol_ping lib version v[lib ticol_ping -info]\r\n"

puts "\[ping 127.0.0.1\] -> [ping 127.0.0.1]"
assert [ping 127.0.0.1] {eq $_ "127.0.0.1"} -v -line #__LINE__

puts "\[ping localhost\] -> [ping localhost]"
assert [ping localhost] {ne $_ ""} -v -line #__LINE__

puts "\[ping 127.0.0.1 -list\] -> [ping 127.0.0.1 -list]"
assert [lindex [ping 127.0.0.1] 0] {eq $_ "127.0.0.1"} -v -line #__LINE__
assert [lindex [ping 127.0.0.1] 1] {>= $_ 0} -v -line #__LINE__

puts "Line: "#__LINE__
lib ticol_ping -unload

unset q -nocomplain
# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #