#################################################################################
# File:				test_lib_sqlite.tcl
# Author:			M Shaw
# Purpose:			Basic test cases for ticol_sqlite.dll
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00	27/Nov/2019	First version
# 1.01	09/Dec/2019	Renamed [varray count] as [varray size]
#################################################################################
# Notes:
# Requires standard albums.db
# ADD more tests!
#################################################################################
/*
if {! [defined SQLiteError] } {
	proc SQLiteError {c} {
		switch -- $c {
		0 { return "SQLite Success" }
		1 { return "SQL error or missing database" }
		2 { return "Internal logic error in SQLite" }
		3 { return "Access permission denied" }
		5 { return "The database is locked" }
		6 { return "A table in the database is locked" }
		8 { return "Attempt to write to a readonly database" }
		10 { return "Disk I/O error occurred" }
		13 { return "Insertion failed because database is full" }
		20 { return "Data type mismatch" }
		21 { return "Library used incorrectly" }
		21 { return "Library used incorrectly" }
		23 { return "Authorization denied" }
		default { "Unknown SQLite error" }
		}
	}
} # */

textcolor yellow
puts "SQLite Database Test::"
puts "---------------------------------------------------"
textcolor
#puts "VBSQLLibTimeStamp:\t"[calldllstr "vbsqlite3.dll" VBSQLLibTimeStamp]
#puts "VBSQLLibVersion:\tv"[round [/ [calldll "vbsqlite3.dll" VBSQLLibVersion] 100.0 ] 2]
#puts "MSVCVersion:\t\tv"[round [/ [calldll "vbsqlite3.dll" MSVCVersion] 100.0 ] 2]
#puts "---------------------------------------------------"
newline

option expression off

if {! [file exists albums.db]} {
	die "test_lib_sqlite.tcl requires albums.db"
}

lib ticol_sqlite -verbose
lib ticol_variant -verbose

#########################################################################
#D:\VC5\MyProjects\picol\Release
debug off
set dbfile ".\\Albums.db"
#set dbfile "d:\\vc5\\myprojects\\picol\\release\\Albums.db"
#set dbfile "d:\vc5\myprojects\picol\release\Albums.db"		# No good now escapes implemented
#set QueryString "SELECT t1.ArtistName,CDs.Title,CDs.date FROM Artists t1, CDs Where t1.ArtistID = CDs.ArtistID ORDER BY ArtistName,CDs.Date DESC "
			 
#set QueryString "SELECT t1.ArtistName,CDs.Title,CDs.date FROM Artists t1, CDs"
#set QueryString "SELECT t1.ArtistName,CDs.Title,CDs.date FROM Artists t1, CDs Where t1.ArtistID = CDs.ArtistID ORDER BY ArtistName, CDs.Date DESC "
#set QueryString "EXPLAIN SELECT * from Artists,CDs"
#set QueryString "SELECT * FROM sqlite_master"

# Test end of line wrapping
set QueryString "SELECT t1.ArtistName,CDs.Title,CDs.date, CDs.CDID\
			FROM Artists t1, CDs\
			Where t1.ArtistID = CDs.ArtistID\
			ORDER BY ArtistName, CDs.Date ASC "

set handle [sql open albums.db]

assert $handle -v -line #__LINE__

# This block is leaking ....
if { $handle } {           # Null is not returned for file not found
	set start [timer]
	set v [sql query $handle $QueryString]
	assert $v  -v -line #__LINE__					# Assert the varray handle (malloc)
#/*	
	textcolor magenta
	puts "SQlite query took [- [timer] $start] msec"
	textcolor
	set rows [varray size $v]
	set cols [varray size $v 2]

	assert $rows {> $_ 0} -v -line #__LINE__		# Rows might vary if we tweak or edit the file
	assert $cols {== $_ 4} -v -line #__LINE__		# Columns should stay the same and our query returns 2
	
	# Buffered screen output mode...
	
	for {set j 0} {< $j [min 5 $rows]} {incr j} {
		for {set i 0} {< $i $cols} {incr i} {
			if { == $i 0} {
				store add [format "%-25s" [varray get v $j $i]]
				#append op [format "%-25s" [varray get v $j $i]]
				#append op "[chr 13][chr 10]"
			} else {
				store add "[varray get v $j $i]\t" 
				#append op "[varray get v $j $i]\t" 
			}
			# if { expr "$i >0 $i % $cols == 0" } { 
			if { [expr "$i+1 == $cols"] } { 
				store add "[chr 13][chr 10]"
				#append op "[chr 13][chr 10]"
				if {== $j 0} { 
					store add "--------------------------------------------------------------------------[chr 13][chr 10]"
					#append op "--------------------------------------------------------------------------[chr 13][chr 10]"
				}
			}
			# if { expr "$i % $cols == 0" } { [file flush stdout] }
		}
	}
	puts [store get]
	#puts $op			# Write out the whole screen buffer
	newline
	puts "Retrieved table has $rows row(s) and $cols col(s)"
#*/	
	sql free $v              # Ensure [sql free] is used
} else {
	die "Can't open SQL database"
}

#sql close $handle		# Keep DB open


if { $handle } {           # Null is not returned for file not found
	set start [timer]
	set v [sql query $handle "SELECT * from Artists"]
	assert $v  -v -line #__LINE__
	textcolor magenta
	puts "SQlite query took [- [timer] $start] msec"
	textcolor

	set rows [varray size $v]
	set cols [varray size $v 2]

	assert $rows {> $_ 0} -v -line #__LINE__		# Rows might vary if we tweak or edit the file
	assert $cols {== $_ 2} -v -line #__LINE__		# Columns should stay the same and our query returns 2

	for {set j 0} {< $j [min 5 $rows]} {incr j} {
		for {set i 0} {< $i $cols} {incr i} {
			puts "[varray get v $j $i]\t" -nonewline
		}
		newline
	}
}

assert [varray get v 0 0] {eq $_ ArtistID} -v -line #__LINE__
assert [varray get v 0 1] {eq $_ ArtistName} -v -line #__LINE__
assert [varray get v 1 0] {eq $_ 1} -v -line #__LINE__
assert [varray get v 1 1] {eq $_ {Puddle of Mudd}} -v -line #__LINE__
assert [varray get v 2 0] {eq $_ 2} -v -line #__LINE__
assert [varray get v 2 1] {eq $_ {Frank Zappa}} -v -line #__LINE__

sql free $v										# Release the query variant
sql close $handle								# Release the DB

lib ticol_sqlite -unload
lib ticol_variant -unload

# Tidy up
undef SQLiteError -nocomplain
unset cols dbfile handle i j op QueryString rows start v -nocomplain

#################################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #
