###########################################################################
# File: 		test_tcx.tcl
# Purpose:		Tests for ticol_tcx.dll plugin
# Author: 		M Shaw
# Language:		Ticol Tcl v1.26+
#
# Versions:
# 1.00 15/Apr/2018 First version
###########################################################################
# Notes: 
# Allows base64 encoded TCX data to be embedded into scripts
# Create an encoded block using: ticol.e <filename> /c
###########################################################################

option expression off
textcolor cyan
lib ticol_tcx -verbose -nocomplain
puts [lib ticol_tcx -info]
textcolor
newline

# puts [base64 [base64 "Hello world" -encode] -decode]

puts "Line: "#__LINE__
# Standard encrypted TCX block for hello.tcl
set code "ibuhXiuUJYyD6Uubn7G4L/wRkK/BtOkaHi5IFuULSaPU/3YskM139seIuesC7KEhQjprZY83PyZAqzgw
FmlfnIkpMMmSMvs="

puts "Line: "#__LINE__
puts "Script block length was [string length $code]"
puts "Line: "#__LINE__
puts "Script block was \r\n'$code'\r\n"

puts "Line: "#__LINE__
set s [tcx debug foo]

###########################################################################
puts "Line: "#__LINE__
#define comment
#ifdef comment
puts "Line: "#__LINE__
set s [tcx decode $code -password ticol]

puts "Line: "#__LINE__
textcolor yellow
puts [string left $s 15]
textcolor
assert [string left $s 15] {eq $_ "textcolor green"} -v -line #__LINE__
textcolor magenta
puts "Script was '$s'"
textcolor
newline

puts "Line: "#__LINE__
puts "Executing code..."
textcolor yellow
# FIX leaks
puts "Return='[tcx run $code]'"
textcolor
#endif
# */
###########################################################################

puts "Line: "#__LINE__
lib ticol_tcx -unload -nocomplain

unset code s -nocomplain

###########################################################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #
# END #