#################################################################################
# File:				test_lib_zip.tcl
# Author:			M Shaw
# Purpose:			Test cases for lib ticol_zip.dll
# Prerequisites:	*.ini in current path
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 30/Nov/2019	First version
#################################################################################
# Notes:
#################################################################################

/*
  integer [zip {filespec list} ?-name filename??.zip?? ?-r?
        ?-p password? ?-verbose? ?-y?]
*/

option expression off
lib ticol_zip -nocomplain

set password "ticol"

textcolor yellow
puts " ZIP plugin version v[lib ticol_zip -info]"
textcolor
newline


set r [zip {*.ini} -r -p $password -verbose]

textcolor magenta

puts " ZIP Results were '$r'"
set zip_name [lindex $r 0]

puts " ZIP name was\t\t$zip_name"
assert $zip_name {ne $_ {}} -v -line #__LINE__

puts " ZIP size was\t\t[comma [lindex $r 1]] byte(s)"
assert [lindex $r 1] {> $_ 0} -v -line #__LINE__

puts " ZIP file count was\t[lindex $r 2]"
assert [lindex $r 2] {> $_ 0} -v -line #__LINE__

puts " ZIP last error was\t[lindex $r 3]"
assert [lindex $r 3] {== $_ 0} -v -line #__LINE__

textcolor

try {
	unlink $zip_name			# Remove our test ZIP file
} catch {
	die "Failed to unlink $zip_name"
}

lib ticol_zip -unload

unset password r zip_name

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #