##############################################################################
# File: 			test_linecont.tcl
# Purpose:			Test file for backslash EOL line continuation
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Aug/2018	First version
##############################################################################
# Notes: 
# Trivial test but important
##############################################################################

option expression off

# Check that we don't add a space when within a string
set s "Hello ->'\
'<- EOL"

assert $s {eq $_ "Hello ->''<- EOL"} -v -line #__LINE__

# Check that we DO add a space when NOT within a string
# This would include freeform (naked) Tcl code as well as braced strings
set s {Hello ->'\
'<- EOL}

assert $s {eq $_ "Hello ->''<- EOL"} -v -line #__LINE__

# Check that we DO add a space when NOT within a string
# This would include freeform (naked) Tcl code as well as braced strings
set s {set q 23\
 set r 10\
}

assert $s {eq $_ {set q 23 set r 10}} -v -line #__LINE__


unset s -nocomplain
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #