###############################################################
# File: 			test_listarray.tcl
# Purpose:			Testing array_to_list, list_to_array
# Author: 			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 25/Nov/2017	First version
# 1.01 17/Oct/2021	Fix for tightened [lsearch] arg syntax
###############################################################
# Notes:
###############################################################
option expression off
option echo on

# array_to_list
textcolor yellow
puts "Testing \[array_to_list\] ..."
textcolor

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# DONE FIX [break] will exit the script
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

# foreach+break
puts "Line: "#__LINE__
set l [array_to_list env]
puts "\[lsearch -nocase l \"env\"\]=[lsearch -nocase l env]"
set y {}

puts "Line: "#__LINE__
foreach x $l {
	# puts "'$x' [lsearch -nocase $x PATH]"
	set r [lsearch -nocase $x path ]
	if {>= $r 0} {
		puts "found path at $r"
		set y [lindex $x 0]
		break
	}
}
puts "Line: "#__LINE__
puts "y is '$y'"
assert [eq $y path -nocase] {== $_ 1} -v -line #__LINE__

unset l x -nocomplain

# list_to_array
puts "Line: "#__LINE__
newline
textcolor yellow
puts \[list_to_array\]
textcolor

puts "Line: "#__LINE__
list_to_array $qbf a
assert [array size a] {== $_ 9} -v -line #__LINE__
assert $a(0)  {eq $_ The} -v -line #__LINE__
assert $a(1)  {eq $_ quick} -v -line #__LINE__
assert $a(2)  {eq $_ brown} -v -line #__LINE__
assert $a(3)  {eq $_ fox} -v -line #__LINE__
assert $a(4)  {eq $_ jumps} -v -line #__LINE__
assert $a(5)  {eq $_ over} -v -line #__LINE__
assert $a(6)  {eq $_ the} -v -line #__LINE__
assert $a(7)  {eq $_ lazy} -v -line #__LINE__
assert $a(8)  {eq $_ dog} -v -line #__LINE__

#assert [item a(9) "x"] {eq $_ "x"} -v -line #__LINE__		# Does not exist

puts "Line: "#__LINE__
array unset a -nocomplain
# Have blocked the following
#unset a								# Leaks when this is called in preference to array unset (a is deleted ok)
unset l r x y -nocomplain

puts "Line: "#__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #