#################################################################
# File:				test_longcomment.tcl
# Author:			M Shaw
# Purpose:			Tests for C++ /* ... */ style long comments
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 23/Jan/2016	First version (implemented) (PASS)
# 1.01 14/Jul/2017	Updated
#################################################################
# Notes: PASS - works very well and quick
#################################################################

textcolor yellow
puts "START Testing long C++ /* */style comments"		# Should see no embedded comment in this string
newline

assert "Brave /* new */ world" {eq $_ "Brave /* new */ world"} -v -line #__LINE__

newline
textcolor red
puts "Ignore the next line catch error ..."
puts
catch {"/* feck arse */"}		# Pass with literal "/* feck arse */" string
catch { /* feck arse */ }		# Pass with, effectively {} string
newline

puts "You should see no output below other than 'Done'..." /*
textcolor magenta	# Should be ignored

# Ignored Tcl comment
This is complete garbage and should be ignored by Ticol
More non syntactically-correct nonsense 
blah bloopety blah blah
doopey doopey doop doop
flibberty flib fibbetty

puts [expr 22/0]  # Ignored Tcl comment
[%/${3234. }PQRS [nosuch] ]

w980asdf0 0as9dfasd9 a09sdf 09ds 09ad f09ds8f0adsf 0as8d09adf098a df098 dsf	# Random, unlawful junk

/ 22 0 */

/* puts "This should not appear" */ /* nor should this*//*
puts "Or this" */

#puts "Hello"/* this is ignored */" world"
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars 

newline
textcolor green
puts "Done"
textcolor

# EOF #