###########################################################################
# Name:				test_loop_return.tcl
# Purpose:			Test file for [loop] return cases
# Author:           M Shaw
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 09/Jul/2017	First version
###########################################################################
# Notes:
###########################################################################

option expression off

catch {
	loop i 0 10 {		# 0..9 inclusive (10 loops)
		if {[== $i 5]} {
			return $i
			puts "I will not be printed if i==5"
		}
		puts "i is $i"
	}
	puts "I should not be seen"		# return quits catch
}
assert $i {== $_ 5} -v -line #__LINE__

# Should break out of loop
catch {
	loop i 0 10 {		# 0..9 inclusive (10 loops)
		if {[== $i 5]} {
			break
			puts "I will not be printed if i==5"
		}
		puts "i is $i"
	}
}
assert $i {== $_ 5} -v -line #__LINE__


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
unset i -nocomplain
vars

newline
textcolor green
puts "Done"
textcolor

# EOF #