######################################################################################
# File: 			test_lsort.tcl
# Purpose:			Test for [lsort]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.00 22/Oct/2017	First version
######################################################################################
# Notes: 
######################################################################################

textcolor yellow
puts "Testing \[lsort]\ ..."
textcolor
newline

assert [lsort $qbf] {eq $_ "The brown dog fox jumps lazy over quick the"} -v -line #__LINE__
assert [lsort $qbf -descending] {eq $_ "the quick over lazy jumps fox dog brown The"} -v -line #__LINE__

set s "83 3 6 43 2 45 9 2 99 102 34 28 23 44 87 887 38238 333 827 3046 39"
assert [lsort $s -ascending -integer] {eq $_ "2 2 3 6 9 23 28 34 39 43 44 45 83 87 99 102 333 827 887 3046 38238"} -v -line #__LINE__
assert [lsort $s -descending -integer] {eq $_ "38238 3046 887 827 333 102 99 87 83 45 44 43 39 34 28 23 9 6 3 2 2"} -v -line #__LINE__

newline
textcolor yellow
puts "Testing intensive loops for memory loss/GPF ..."
textcolor

time {	# Test for GPF
	lsort $qbf -ascending
} -10000

time {	# Test for GPF
	lsort $qbf -descending
} -10000

unset s -nocomplain

#############################################################
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #