option echo push on			# Only a single push level is supported ATM so any local use will break this

textcolor darkyellow
#set root_scriptname [file name [info script]]
puts "*** Start Tests: [info script] *** Line:"#__LINE__
newline
textcolor

#clear						# Ensure no vars if run from CLI (can't do for loop testing)
option expression on
set _start_time [timer]

set main::test_count 0
# puts "Debug: _scriptname'$_scriptname' info script '[info script]' ext -> '[file extension [info script]]'"
set main::filetype [file extension [info script]]
assert $main::filetype {ne $_ ""} -v -line #__LINE__				# Won't work in the DLL
#puts "filetype is $filetype"
set main::logfile "tests.log"
unlink $main::logfile

writefile $main::logfile "Start Test Run [date]@[time]\r\n"			# Log the date / time of run

if {! [defined run_test] } {
	vars -level 0
	#####################################################
	# This proc cannot depend on persistent global vars 
	# as these may be cleared by called scripts
	#####################################################
	proc run_test {filename line} {
		option expression off
		set name $filename
		
		if {[eq [file extension $filename] {}]} {
			if {eq $::main::filetype {}} {							# May be embedded DLL script
				append filename ".tcl"
			} else {
				append filename $::main::filetype					# ".tcl" ".tcx"
			}
		}

		textcolor yellow
		puts "\nTesting external file: $filename (Loop: [item ::loop::i 0])"
		textcolor
		newline

		set ::tested([++ ::main::test_count]) $filename
		console set_title "Processing (Test: $::main::test_count, Loop: [item ::loop::i 0]): '$filename'"
#array walk ::tested
		textcolor darkyellow
		puts "tests$::main::filetype -> run_test@Line: $line -> source $filename\n"
		textcolor
		#walk -level 0
		#vars -level 0
		if {[file exists $filename]} {
			writefile $::main::logfile "[time] start: $name\r\n" -append	# Filename minus ".tc?"

			try {										# Not using -quiet argument (error messages will be shown)
				uplevel @0 "source $filename"			# Call external file at level 0
				halt									# Stop the debuggger if running
			} catch {
				puts "\ntests.tcl -> run_test: catch failure in $filename"
				pause
				die
			}
			writefile $::main::logfile "[time] end:   $name\r\n" -append	# Filename minus ".tc?"
		} else {
			die "Can't find $filename in [getcwd]"
		}
		newline
# Ad-hoc var trace and halt
watch trace 106 -var -halt -line #__LINE__
/*
		writefile $::main::logfile "[time] end:   [info exists "1"]\r\n" -append
		foreach x [vars -list -level 0] {
			if {is_numeric $x} {
			# if {is_numeric [lindex [vars -list] 0]} {
			# if {[vars 5*]} {
				die "TRACE VAR FOUND"
			} 
		}# */
		writefile $::main::logfile "[time] end:   '[info vars ?????????? -level 0]'\r\n" -append
	}
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

#####################################################################################################


run_test test_macro #__LINE__							# Macro PreProcessor (MPP) tests
run_test test_macro_consts #__LINE__					# GPF in ticol.dll
run_test test_macro_exit #__LINE__						# Ensures that <hash>exit is handled properly
run_test test_macro_line #__LINE__						# Test line number accuracy
run_test test_macro_literals #__LINE__					# Test literals read from defs.tcl

newline
textcolor green
puts " * test_macro_all.cl. * Done *"
textcolor

# EOF #