###################################################################################
# File: 			test_macro_bool.tcl
# Purpose:			Tests for boolean scope access
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Oct/2019	First version
###################################################################################
# Notes:
# This tests MPP use to create 'raw' or 'naked' boolean consts as per ActiveState
# MPP subsittutions are 'naked' values
# MPP substitutions cannot be embedded within strings
# the substitution should be passed into a variable which can then be embedded
###################################################################################

option expression off
option echo on

#define true 1
#define false 0

proc foo {} {
	assert true {== $_ 1} -v -line #__LINE__
	assert false {== $_ 0} -v -line #__LINE__
	assert 1 {== $_ {true}} -v -line #__LINE__
	assert 0 {== $_ {false}} -v -line #__LINE__
	puts true
	assert [bool true] {eq $_ "true"} -v -line #__LINE__
	assert [bool false] {eq $_ "false"} -v -line #__LINE__
	if {! true} { 
		die "true not set"
	} else {
		
	}
	if {! false} {
	} else {
		die "false not set"
	}
}

foo

undef foo
newline
vars
newline

#undef true
#undef false
###################################################################################
textcolor green
puts "* Done *"
textcolor

# EOF #