######################################################################################
# File: 			test_macro_line.tcl
# Purpose:			Test for #__LINE__ accuracy
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#    D O    N O T   E D I T
# ** IF THIS HEADER IS ADJUSTED, CHANGE THE TEST VALUE(S) BELOW ***
#
# Versions:
# 1.00 28/Oct/2018	First version
######################################################################################
# Notes: 
# See: test_macro_consts.tcl
# Poss rename and include __FILE__, __DATE__, __TIME__
######################################################################################
option expression off

textcolor yellow
puts "Testing macro __LINE__ and other macro vars ..."
textcolor
newline

try {
	set line #__LINE__			# This is the line number we check
} catch {
	textcolor red
	puts "Macro __LINE__ failed"
	textcolor
	pause
	die
}

assert $line  {== $_ 24} -v -line #__LINE__

set s #__FILE__
puts "Testing __FILE__ is not empty ..."
assert $s  {ne $_ ""} -v -line #__LINE__

set s #__DATE__
puts "Testing __DATE__ is not empty ..."
assert $s  {ne $_ ""} -v -line #__LINE__

set s #__TIME__
puts "Testing __TIME__ is not empty ..."
assert $s  {ne $_ ""} -v -line #__LINE__

set s #__HOST__
puts "Testing __HOST__ is not empty ..."
assert $s  {ne $_ ""} -v -line #__LINE__

try {
	set line #__LINE__			# This is the line number we check
} catch {
	textcolor red
	puts "Macro __LINE__ failed"
	textcolor
	pause
	die
}
assert $line  {== $_ 52} -v -line #__LINE__

unset line s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #