############################################################################
# File:				test_macro_literals.tcl
# Purpose:			Test MPP (Macro PreProc) replacment of literals 
# Author:			M Shaw
# Language:			Ticol Tcl v1.25+
# Requires:			defs.tcl
#
# Versions:
# 1.00 24/Nov/2017	First version
############################################################################
# Notes:
############################################################################

textcolor yellow
puts "In test_macro_literals.tcl ..."
textcolor
newline

puts "Line: "#__LINE__

puts "Including defs.tcl ..."
source defs.tcl

puts "Line: "#__LINE__
vars -const

# CHAR_MAX
puts "Line: "#__LINE__
dummy 0xff
puts "Line: "#__LINE__
puts 0xff
puts "Line: "#__LINE__
puts "CHAR_MAX $::CHAR_MAX"

assert 0x7f {== $_ $::CHAR_MAX} -v -line #__LINE__	

puts "Line: "#__LINE__
/*
dummy 0xffffffff
puts 0xffffffff
puts "ULONG_MAX $::ULONG_MAX"
assert 0xffffffff {== $_ $::ULONG_MAX} -v -line #__LINE__	
# */

# FAILS - not being translated from HEX by the MPP!
# Weird, it started working after I added ULONG_MAX to defs.tcl
puts "Line: "#__LINE__
dummy 0xFFFFFFFFFFFFFFFF	# 16 digits

puts "Line: "#__LINE__
puts "0xffffffffffffffff->"

puts "Line: "#__LINE__
puts 0xFFFFFFFFFFFFFFFF

puts "Line: "#__LINE__
puts "UINT_MAX-> $::UINT_MAX"

puts "Line: "#__LINE__
puts "::UINT_MAX->[inttohex $::UINT_MAX]"
puts "Line: "#__LINE__
puts "UINT_MAX is '$::UINT_MAX'"
assert [expr 0xFFFFFFFFFFFFFFFF] {== $_ $::UINT_MAX} -v -debug -line #__LINE__
puts "Line: "#__LINE__
assert 0xFFFFFFFFFFFFFFFF {== $_ $::UINT_MAX} -v -debug -line #__LINE__

puts "Line: "#__LINE__
unset CHAR_MIN -const -nocomplain
unset CHAR_MAX -const -nocomplain
unset UCHAR_MIN -const -nocomplain
unset UCHAR_MAX -const -nocomplain
unset SHORT_MIN -const -nocomplain
unset SHORT_MAX -const -nocomplain
unset USHORT_MIN -const -nocomplain
unset USHORT_MAX -const -nocomplain
unset LONG_MIN -const -nocomplain
unset LONG_MAX -const -nocomplain
unset ULONG_MIN -const -nocomplain
unset ULONG_MAX -const -nocomplain
unset INT_MIN -const -nocomplain
unset INT_MAX -const -nocomplain
unset UINT_MIN -const -nocomplain
unset UINT_MAX -const -nocomplain



# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars	
newline
textcolor green
puts "* test_macro_literals.tcl - Done *"
textcolor

# EOF #