########################################################################
# File: 			test_malformed.tcl
# Purpose:			Tests for various malformed or strange items
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 13/Oct/2018	First version
########################################################################
# Notes:
# Add to this file as we find interesting specimens
########################################################################
option expression off

textcolor yellow
puts "Testing some malformed and weird stuff ..."
textcolor
newline

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

# Define a proc with an extrmely wacky name ...
# Ensure we can define it, call it, check it is present and delete it
set i 0
proc {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx} {} {
	++ ::i 23			# Skidoo!
}

# Check it is present

puts [procs foo*]
puts [procs {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}]
assert [procs {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}] {ne $_ ""} -v -line #__LINE__
assert [procs {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}] {eq $_ {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}} -v -line #__LINE__

# Call it. (Note that we have to brace it due to embedded spaces)
{foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}

assert $i  {== $_ 23} -v -line #__LINE__

undef {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}

# check against procs list
puts [procs foo*]
assert [procs {foo\"quoted arg 4\"\[bar moo par\]\"quoted arg\"xxx}] {eq $_ ""} -v -line #__LINE__

unset i -nocomplain
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

newline
textcolor green
puts "* Done *"
textcolor

# EOF #