###########################################################################
# Name:				test_malloc.tcl
# Purpose:			Test file for [malloc]
# Author:       	M Shaw
# Language:			Ticol Tcl v1.21c+
#
# Versions:
# 1.00 28/Dec/2016	First version
###########################################################################
# Notes:
# Basic test only:
# malloc, free, memset direct and with calculated offsets
# TODO: Add more tests
###########################################################################

option expression off

textcolor yellow
puts "Testing \[malloc\] ..."
textcolor
newline

set ptr [malloc 200]
puts "malloc ptr is $ptr"
assert $ptr {> $_ 0} -v -line #__LINE__
set source Hello
# Copy a Tcl var to malloced block (will terminate)
memcpy $ptr [addressofb source] 6			# MUST copy length of string + 1 to copy the NULL char
#puts "ofaddressb ptr =='[ofaddressb $ptr]'"
assert [ofaddressb $ptr] {eq $_ Hello} -v -line #__LINE__		# Dereference block address (not a Tcl var)

# Memset part of the block (will terminate)
memset $ptr x 10												# memset the address with 'x'
assert [ofaddressb $ptr] {eq $_ xxxxxxxxxx} -v -line #__LINE__
puts [+ $ptr 5]
memset [+ $ptr 5] "q" 2						# Calculated offset
assert [ofaddressb $ptr] {eq $_ xxxxxqqxxx} -v -line #__LINE__
puts "Line "#__LINE__
free ptr -var
puts "after free: ptr is now '$ptr' @"#__LINE__
assert $ptr {== $_ 0} -v -line #__LINE__
set ptr [malloc 200]
puts "Line "#__LINE__
free $ptr
assert $ptr {> $_ 0} -v -line #__LINE__

/* /////////////////////////////////////////////////////////////////////////////////////
set a [malloc 256]
set s "hello"
memcpy $a [addressofb s] 5 -t
puts "a is '[ofaddressb $a]'"
*/

/* /////////////////////////////////////////////////////////////////////////////////////
set limit 100000							# 2016/Dec/20 - No leaks
for {set i 0} {< $i $limit} {++ i} {
	set ptr [malloc 10]
	memcpy $ptr [addressofb source] 6
	free $ptr
}
*/

unset a s limit ptr source -nocomplain

###########################################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #