############################################################################################
# File: 			test_mean_median_mode.tcl
# Purpose:			Test [mean], [median], [mode]
# Language:			Ticol Tcl v1.26+
# See also:			dict_eg_employee.tcl
#
# Versions:
# 1.00 08/Oct/2019	First version
############################################################################################
# Notes:
# TODO - Condense all into a [stats] command (not [stat])
############################################################################################
option expression off

############################################################################################
# MODE
#
set i 0
try {
	puts [mode 1]
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__


set i 0
try {
	puts [mode 1 2 3 4 5]
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

unset i

puts [mode 1 2 3 3 4 5]
assert [mode 1 2 3 3 4 5] {== $_ 3} -v -line #__LINE__

puts [mode 1.2 2.3 3.4 3.4 4.5 5.6]
assert [mode 1.2 2.3 3.4 3.4 4.5 5.6] {== $_ 3.4} -v -line #__LINE__


############################################################################################
# MEAN
newline
textcolor yellow
puts "Testing \[mean\]"
textcolor
assert [mean 1] {== $_ 1} -v -line #__LINE__
assert [mean 0] {== $_ 0} -v -line #__LINE__
assert [calc "round(abs(1-pow(2.2,5)*2),2)"] {== $_ 102.07} -v -line #__LINE__	# AOPM dependent
assert [mean 1 2 3 4 5 6 7 8 9 10 11 12] {== $_ 6.5} -v -line #__LINE__
assert [mean 234 372 8276 67827 277 228] {== $_ 12869.0} -v -line #__LINE__
newline

############################################################################################
# MEDIAN
newline
textcolor yellow
puts "Testing \[median\]"
textcolor

catch {
	median
}

catch {
	median {}			# Is treated as 0
}
puts [median 0]
puts "[median 0] @"#__LINE__
assert [median 0] {== $_ 0} -v -line #__LINE__				# Sole value

puts [median 1]
assert [median 1] {== $_ 1} -v -line #__LINE__				# Sole value

puts [median 1 2]
assert [median 1 2] {== $_ 1} -v -line #__LINE__			# floor()

puts [median 3 1 2]
assert [median 3 1 2] {== $_ 2} -v -line #__LINE__

puts [median 3 5 1 2 4]
assert [median 3 5 1 2 4] {== $_ 3} -v -line #__LINE__

puts [median 3.4 5.4 1.2 2.2 5.1]
assert [median 3.4 5.4 1.2 2.2 5.1] {== $_ 3.4} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #