###################################################################################
# File: 			test_memset.tcl
# Purpose:			Test [memset]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 26/Jun/2018	For amusement
###################################################################################
# Notes:
# TODO: Expand tests
# FIX or check: [memset] does not append \0
###################################################################################
option expression off

puts "Line: "#__LINE__
set i 0
try {
	set ptr [malloc 0]			# Ensure we catch invalid arg
	puts $ptr
} catch {
	set i 1
}
assert $i {== $_ 1}  -v -line #__LINE__

puts "Line: "#__LINE__
set i 0
try {
	set ptr [malloc -1]			# Ensure we catch invalid arg
	puts $ptr
} catch {
	set i 1
}
assert $i {== $_ 1}  -v -line #__LINE__

# Valid arguments ########################
puts "Line: "#__LINE__
set ptr [malloc 1]
memset $ptr q 1			# FIX Memset doesn't know the allocated length and will overwrite
puts "Address is: $ptr"
puts "Contents:   '[ofaddressb $ptr]'"
assert [ofaddressb $ptr] {eq $_ "q"} -v -line #__LINE__


puts "Line: "#__LINE__
# Man example, not working now - June 2018
set ptr [malloc 200]
puts '$ptr'
memset $ptr x 10
memset [+ $ptr 5] "q" 2  # Write to offset ptr + 5
puts "Address is: $ptr"
puts "Contents:   '[ofaddressb $ptr]'"

assert $ptr {!= $_ 0}  -v -line #__LINE__
assert [ofaddressb $ptr] {eq $_ "xxxxxqqxxx"} -v -line #__LINE__

unset i ptr -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* \[memset\] Done *"
textcolor

# EOF #