###################################################################################
# File: 			test_mid_mids.tcl
# Purpose:			Test [mid] and [mids]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.00 04/Nov/2017	First version
# 1.01 05/Jun/2022	Changed default argument behavour
###################################################################################
# Notes: 
###################################################################################

option expression off

textcolor yellow
puts "Testing \[mid\]..."
textcolor yellow
newline

# mid (string set) #
set s $qbf
mid s "silly" 5 5
assert $s {eq $::s "The silly brown fox jumps over the lazy dog"} -v -line #__LINE__

set s $qbf
mid s "t" 1 1
assert $s {eq $::s "the quick brown fox jumps over the lazy dog"} -v -line #__LINE__

puts "Line :"#__LINE__
set s $qbf
mid s {} 1 1			# Returns empty string? (insert nothing at position 1 1)
#assert $s {eq $_ {}}		 					# Not sure this makes sense
assert $s {eq $_ $::qbf} -v -line #__LINE__		# This makes more sense



set flag 0
try {
	mid {} "t" 1 1		# Invalid varname
} catch {
	puts "Caught error"
	set flag 1
}
assert $flag {== $flag 1} -v -line #__LINE__
newline

textcolor yellow
puts "Testing \[mids\] ..."
textcolor yellow
newline

# mids (string fetch) #
assert [string mids $qbf 1 3] {eq $_ "The"} -v -line #__LINE__
assert [string mids $qbf 1 1] {eq $_ "T"} -v -line #__LINE__
assert [string mids $qbf 5 5] {eq $_ "quick"} -v -line #__LINE__
assert [string mids $qbf 32] {eq $_ "the lazy dog"} -v -line #__LINE__

# New arg behavour (2022)
# We now guard the start position and assume <1 == 1
# Start positions > string length now return "" always
assert [string mids $qbf 0] {eq $_ $::qbf} -v -line #__LINE__
assert [string mids $qbf 0 3] {eq $_ "The"} -v -line #__LINE__
assert [string mids $qbf -1 3] {eq $_ "The"} -v -line #__LINE__
assert [string mids $qbf 43] {eq $_ "g"} -v -line #__LINE__
assert [string mids $qbf 44] {eq $_ ""} -v -line #__LINE__
assert [string mids $qbf 666] {eq $_ ""} -v -line #__LINE__
assert [string mids $qbf 666 0] {eq $_ ""} -v -line #__LINE__
assert [string mids $qbf 666 1] {eq $_ ""} -v -line #__LINE__
assert [string mids $qbf 666 -23] {eq $_ ""} -v -line #__LINE__

unset flag s -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
newline
textcolor green
puts "* Done *"
textcolor

# EOF #