#############################################################################################
# File:				test_for_multi.tcl
# Purpose:			Test [min], [max] commands (not functions)
# Author:			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 12/May/2022	In response to a bug found in [max] command
#############################################################################################
# Notes:
#############################################################################################

textcolor yellow
puts "Testing \[max\] command ..."
textcolor

# MAX #######################################################################################

# Zero unaffected by sign and position
assert [max 0 0] {== $_ 0} -v -line #__LINE__
assert [max 0 -0] {== $_ 0} -v -line #__LINE__
assert [max -0 0] {== $_ 0} -v -line #__LINE__

# Unaffected by position
assert [max 0 1] {== $_ 1} -v -line #__LINE__
assert [max 1 0] {== $_ 1} -v -line #__LINE__
assert [max 0 1] {== $_ 1} -v -line #__LINE__

# Zero should be > -ve values
assert [max 0 -1] {== $_ 0} -v -line #__LINE__
assert [max -1 0] {== $_ 0} -v -line #__LINE__
assert [max 0 -1] {== $_ 0} -v -line #__LINE__

# Zero should be > -ve values
assert [max 0 -23] {== $_ 0} -v -line #__LINE__
assert [max -23 0] {== $_ 0} -v -line #__LINE__
assert [max 0 -23] {== $_ 0} -v -line #__LINE__

# Zero should be > -ve values
assert [max 23 -1] {== $_ 23} -v -line #__LINE__
assert [max -1 23] {== $_ 23} -v -line #__LINE__
assert [max 23 -1] {== $_ 23} -v -line #__LINE__

assert [max -23 -1] {== $_ -1} -v -line #__LINE__
assert [max -1 -23] {== $_ -1} -v -line #__LINE__
assert [max -23 -1] {== $_ -1} -v -line #__LINE__

assert [max 1 0 3 2 23] {== $_ 23} -v -line #__LINE__
assert [max 1 3 2 23 1039918] {== $_ 1039918} -v -line #__LINE__
assert [max -1 -0 -3 -2 23] {== $_ 23} -v -line #__LINE__
assert [max 1 -0 3 2 -23] {== $_ 3} -v -line #__LINE__

# MIN #######################################################################################
newline
textcolor yellow
puts "Testing \[min\] command ..."
textcolor

# Zero unaffected by sign and position
assert [max 0 0] {== $_ 0} -v -line #__LINE__
assert [max 0 -0] {== $_ 0} -v -line #__LINE__
assert [max -0 0] {== $_ 0} -v -line #__LINE__

# Unaffected by position
assert [min 0 1] {== $_ 0} -v -line #__LINE__
assert [min 1 0] {== $_ 0} -v -line #__LINE__
assert [min 0 1] {== $_ 0} -v -line #__LINE__

# Zero should be > -ve values
assert [min 0 -1] {== $_ -1} -v -line #__LINE__
assert [min -1 0] {== $_ -1} -v -line #__LINE__
assert [min 0 -1] {== $_ -1} -v -line #__LINE__

# Zero should be > -ve values
assert [min 0 -23] {== $_ -23} -v -line #__LINE__
assert [min -23 0] {== $_ -23} -v -line #__LINE__
assert [min 0 -23] {== $_ -23} -v -line #__LINE__

# Zero should be > -ve values
assert [min 23 -1] {== $_ -1} -v -line #__LINE__
assert [min -1 23] {== $_ -1} -v -line #__LINE__
assert [min 23 -1] {== $_ -1} -v -line #__LINE__

assert [min -23 -1] {== $_ -23} -v -line #__LINE__
assert [min -1 -23] {== $_ -23} -v -line #__LINE__
assert [min -23 -1] {== $_ -23} -v -line #__LINE__

# Series
assert [min 1 0 3 2 23] {== $_ 0} -v -line #__LINE__
assert [min 1 3 2 23 1039918] {== $_ 1} -v -line #__LINE__
assert [min -1 0 3 2 23] {== $_ -1} -v -line #__LINE__
assert [min -1 -0 -3 -2 23] {== $_ -3} -v -line #__LINE__
assert [min 1 -0 3 2 -23] {== $_ -23} -v -line #__LINE__

#############################################################################################

newline
textcolor green
puts "* Done *"
textcolor


# EOF #