#################################################################################
# File: 			test_mkdirs.tcl
# Purpose:			Tests for [mkdirs]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 18/Nov/2017	First version
#################################################################################
# Notes:
# Remember to double-backslash any paths!
# Don't include in main test block as removing dirs could be dangerous
#################################################################################

option echo on
option expression off

rmdir delete/me/now
rmdir delete/me
rmdir delete

textcolor cyan
puts "Starting dir contents:\r\n"
puts [ls d* -la -ad]
textcolor yellow
puts "Running set r \[mkdirs \"delete\\\\me\\\\now\"\]"
textcolor
newline

set r [mkdirs "delete\\me\\now"]

textcolor magenta
#puts [ls delete -la -ad]
set s [ls delete\\* -la -ad -r]		# Matches DosWin in not returning the top level folder
puts "returned list: '$s'"
textcolor
newline 

assert $r {== $_ 1} -v -line #__LINE__
assert $s {eq $_ "me now"} -v -line #__LINE__

newline
textcolor yellow
puts "Running set r \[mkdirs \"delete\\\\me\\\\now\"\]"
textcolor
newline

set s [ls delete\\* -la -ad -r -array a]		# Matches DosWin in not returning the top level folder
array walk a
assert [array size a] {> $_ 0} -v -line #__LINE__
assert [array item a 0 ""] {eq $_ me} -v -line #__LINE__
assert [array item a 1 ""] {eq $_ now} -v -line #__LINE__

rmdir delete/me/now
rmdir delete/me
rmdir delete

newline

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #