##############################################################################
# File: 			test_mod.tcl
# Purpose:			Test math mod [%]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 09/Oct/2018	First version
##############################################################################
# Notes: 
##############################################################################
option expression off

# Test for float modular division
textcolor yellow
puts "Testing float mod ..."
textcolor
newline

set a 1.34
set b 0.45

set c [/ $a $b]
puts [round $c 6]
assert [/ $a $b] {== [round $_ 6] 2.977778}  -v -line #__LINE__		# PASS
assert [* 2 $b]  {== $_ .9} -v -line #__LINE__							# PASS

assert [* [/ $a $b] $b]  {== $_ $::a} -v -line #__LINE__				# PASS

assert [* [int [/ $a $b]] $b]  {== $_ .9} -v -line #__LINE__			# PASS
assert [- $a [* [int [/ $a $b]] $b]]  {== $_ 0.44} -v -line #__LINE__	# PASS

puts "/ $a $b == $c"
puts [* [int $c] $b]

# MOD
set r [% $a $b]
assert $r {== $_ 0.44} -v -line #__LINE__								# PASS

# FMOD
set r [fmod $a $b]
assert $r {== $_ 0.44} -v -line #__LINE__								# PASS


unset a b c r -nocomplain

vars

########################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #


