###################################################################################
# File: 			test_mpp_string_concat.tcl
# Purpose:			Test for string implied concatenation
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 16/Jul/2018	First version
###################################################################################
# Notes: 
# Spotted some problems with the MPP and concatenating macro vars onto the end of
# dquoted strings. e.g. 
###################################################################################

textcolor yellow
puts "Testing [info script]"
textcolor
newline

# Quick test to check append-style concatenation
set s "Hello "World
assert $s {eq $_ "Hello World"} -v -line #__LINE__

set s "File "#__FILE__
puts "s is '$s'"
assert $s {ne $_ "File "} -v -line #__LINE__

unset s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
newline
textcolor green
puts "* Done *"
textcolor

# EOF #