#################################################################################
# File: 			test_multicatch.tcl
# Purpose:			Tests for multiple trigger events for catch
# Author: 			M Shaw
# Language:			Ticol Tcl v1.21+
#
# Versions:
# 1.00 06/Dec/2016	First version
#################################################################################
# Notes: 
#################################################################################

option echo on
option expression off

array unset a -nocomplain
unset a -nocomplain

set a 10					# Create any var we can 'over-dereference'
#puts "a is '$a'"

catch {
	puts "Line: "#__LINE__
	puts $$$$$a				# Trip catch (catch will now exit)
	set a 1					# Attempt reset
	puts "Line: "#__LINE__
	puts $$$$$a				# Try to trip catch again (never executed)
	puts "Line: "#__LINE__
	set q [/ 22 0.0]		# Never executed
	puts "Line: "#__LINE__
	textcolor cyan
	puts "Am I still here?"
	textcolor
}

#puts "a is '$a'"
assert $a {== $_ 10} -v -line #__LINE__					# Ensure catch exited before resetting a

unset a q -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #