#########################################################################################
# File: 			test_ndebug.tcl
# Purpose:			Tests for Macro config setting NDEBUG
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
# Caution:			Contains MPP executable code. Will run on any MPP call including /C
#
# Versions:
# 1.00 23/Jul/2018	First version
#########################################################################################
# Notes:
# Has to be tested in a separate file
/*
assert {1} {set ::i 1} -v -line #__LINE__
if {== $i 1} {
	die "\#define ndebug failed at line "#__LINE__
}
*/
#########################################################################################

option expression off

#textcolor yellow
#echo "Test define NDEBUG ..."
# Not yet implemented...
#echo MPP: In file __FILE__
#textcolor


set i 0
#define ndebug
#ifdef ndebug
#echo MPP: MACRO Successfully defined ndebug
#else
#echo MPP: MACRO failed to set ndebug
#exit 
#endif

#undef ndebug
#ifdef ndebug
#echo MPP: MACRO Failed to unset ndebug
#exit
#else
#echo MPP: MACRO Successfully undefined ndebug at line #__LINE__
#endif

#ifdef ndebug
textcolor red
puts "Line: "#__LINE__
puts "Tcl: ndebug is still defined"
textcolor
die
#else
textcolor green
puts "Tcl: ndebug appears to have been successfully undefined"
puts "Tcl: The next line should be a valid assert..."
assert 1 {== $_ 1} -v -line #__LINE__
textcolor
#endif

set i 0
assert [set i 2; puts "i is $i"] {== $::i 2} -v -line #__LINE__
puts "Tcl: i is $i at line "#__LINE__

unset i -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #