###################################################################################
# File: 			test_nest_while_break.tcl
# Purpose:			Check interaction of [while] and [break]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 14/Jul/2018	Test for example in link below
###################################################################################
# Notes:
# Source: http://www.invece.org/tclwise/control_constructs.html
###################################################################################
option expression off

# Confirm that break only exits the inner loop
set i 0
while 1 {
	while 1 {
		if {> $i 4} break
		++ i
	}
	if {> $i 9} break
	++ i
}
assert $i {== $_ 10} -v -line #__LINE__


# Confirm that break only exits the inner loop
# But setting dobreak will break
set i 0
set dobreak 0
while 1 {
    while 1 {
		if {> $i 4} {
			set dobreak 1
			break
		}
		++ i
    }
    if {$dobreak} break
	++ i
}
assert $i {== $_ 5} -v -line #__LINE__

unset dobreak i -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #