#################################################################################################
# File:				test_nested_deref_namespace.tcl
# Author:			M Shaw
# Purpose:			Test updating struct parent from proc
# See also:			test_struct_upvar_parent_update.tcl
#
# Versions:
# 1.00 16/Jul/2018 First version
#################################################################################################
# Notes:
# FIX Should support: ${::${x}.a} # (scope prefix, poss with namespace as ${namespace::${x}.a})
# FIX Should support ${::$x} within proc
# ${::$x} should inititate var defef call and then call recursively
#################################################################################################
option expression off

textcolor yellow
puts "Line: "#__LINE__
textcolor
newline

undef foo -nocomplain
proc foo {x} {
	puts "Enter foo $x"
	puts "\$::s == '$::s'"
	catch {
		textcolor magenta
		#puts "$::{x}"		# No
		puts "${::$x}"		# No
		assert ${::$x} {eq $_ $::s} -v -line #__LINE__
		textcolor
	}
}

set s Hello
foo s
unset s 

textcolor yellow
puts "Line: "#__LINE__
textcolor
newline

undef foo
proc foo {x} {
	puts "Enter foo struct: $x"
	#catch {
	textcolor red
	puts $::s.a								# Direct query
	textcolor magenta
	puts "\${::$x}->'${::$x}'"				# FIX returns address, Won't dereference ${::<address>}
	assert ${::${x}} {eq $_ "<struct>"} -v -line #__LINE__
	# FIX string termination: EXIT: getBracedVar@24016 PARENT EXTRA getBracedVar_r returned 'Hello fromE'
	# Does not terminate to field width with \0
	puts "\${::${x}.a}->'${::${x}.a}'"		
	assert ${::${x}.a} {eq $_ $::s.a} -v -line #__LINE__
	textcolor
	#}
}

struct s {a 10}
struct set s.a "Hello from struct"
foo s

struct unset s 
undef foo
proc foo {x} {
	puts "Enter foo struct: $x"
	textcolor yellow
	puts "direct \$::bar::s.a -> $::bar::s.a"
	textcolor magenta
	puts "\${::bar::${x}.a}->'${::bar::${x}.a}'"
	assert ${::bar::${x}.a} {eq $_ $::bar::s.a} -v -line #__LINE__
	textcolor
}
struct bar::s {a 10}
struct set bar::s.a "Hi from bar::s.a"		# Field length will truncate
assert $bar::s.a {eq $_ [string left "Hi from bar::s.a" 10]} -v -line #__LINE__
foo s

undef foo
struct unset bar::s -nocomplain
vars


###########################################################################################
newline
textcolor green
puts "* Done [info script] *"
textcolor

# EOF #