###################################################################################
# File:				test_op_cmp.tcl
# Purpose:			Test cmp operators for functionality and leaks
# Author:			M Shaw
# Compatibility:	NT4/SP6a -> Windows 10
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 14/Jan/2016	First version
# 1.02 21/Jan/2022	Updated and added to unit tests
###################################################################################
# Notes:
###################################################################################

puts "Line: "#__LINE__
puts "Testing eq"
puts "Should be 0 -> [eq {Hello there} {hello there}]]"
assert [eq {Hello there} {hello there}] {== $_ 0} -v -line #__LINE__
puts "Should be 1 -> [eq "Hello there" "hello there" -nocase]]"
assert [eq "Hello there" "hello there" -nocase] {== $_ 1} -v -line #__LINE__
puts "Should be 1 -> [eq "Hello there" "Hello there"]]"
assert [eq "Hello there" "Hello there"] {== $_ 1} -v -line #__LINE__
newline

puts "Line: "#__LINE__
puts "Testing ne"
puts "Should be 0 -> [ne "Hello there" "Hello there"]]"
assert [ne "Hello there" "Hello there"] {== $_ 0} -v -line #__LINE__
puts "Should be 1 -> [ne "Hello there" "hell"]"
assert [ne "Hello there" "hell"] {== $_ 1} -v -line #__LINE__
puts "Should be 1 -> [ne "Hello there" ""]"
assert [ne "Hello there" ""] {== $_ 1} -v -line #__LINE__
newline

puts "Line: "#__LINE__
puts "Testing eqn"
puts "Should be 0 -> [eqn {Hello there} {hell} 4]"
assert [eqn {Hello there} {hell} 4] {== $_ 0} -v -line #__LINE__
puts "Should be 1 -> [eqn "Hello there" "hell" 4 -nocase]"
assert [eqn "Hello there" "hell" 4 -nocase] {== $_ 1} -v -line #__LINE__
puts "Should be 1 -> [eqn "Hello there" "Hell" 4]"
assert [eqn "Hello there" "Hell" 4] {== $_ 1} -v -line #__LINE__
puts "Should be 1 -> [eqn "Hello there" "hell" 4 -nocase]"
assert [eqn "Hello there" "hell" 4 -nocase] {== $_ 1} -v -line #__LINE__
puts "Should be 0 -> [eqn "Hello there" "hell" 4]"
assert [eqn "Hello there" "hell" 4] {== $_ 0} -v -line #__LINE__
puts "Should be 0 -> [eqn "Hello there" "hela" 4 -nocase]"
assert [eqn "Hello there" "hela" 4 -nocase] {== $_ 0} -v -line #__LINE__
newline

/*
###################################################################################
puts "Line: "#__LINE__
textcolor yellow
puts "Checking for leaks in eq..."
set start [mem_used]
time {eq [randomstr 2] 10
} 10009
textcolor 

newline
puts "Test used [expr [mem_used]-$start] byte(s)"

textcolor yellow
puts "Checking for leaks in eqn..."
set start [mem_used]
time {eq [randomstr 20] "10" 
} 1000009
textcolor 

newline
puts "Test used [expr [mem_used]-$start] byte(s)"
################################################################################### */

newline
vars
newline 

textcolor green
puts "* Done *"
textcolor

# EOF #
