###############################################################################
# File: 		test_parse_issues.tcl
# Purpose:		Test file for misc parse issues
# Author: 		M Shaw
# Language:		Ticol Tcl v1.26+
#
# Versions:
# 1.00 29/Aug/2019 First version
###############################################################################
# Notes:
# NOT included in tests.tcl unit test script
# Various parse issues should be tested here
# ADD Handle / slash
###############################################################################

option expression off
/*
	29/Aug/2019
	trace picolCommandStringCmp
	trace picolCommandAssert
	trace tcl_unescape_single_chars
	
	String is passed correctly to [echo] but arrives in [eq] mis parsed

	ENTER cmp: argc is 3
	cmp: 0: 'eq'
	cmp: 1: '\'
	cmp: 2: '\"'
	
	We should not remove \\ in double quoted strings or we will create a new escape on terminating "
	EXIT D tcl_unescape_single_chars: s_in:'eq $_ "\"'
	DONE Can we modify tcl_unescape_single_chars to leave \\ ?
	/////////////////////////////////////////////////////////////////////////////////
*/

cls
# PASS
puts "Line: "#__LINE__
echo "\\"
echo {\\}

# PASS
puts "Line: "#__LINE__
echo "'\\'"
echo {'\\'}

# [eq] alone
puts "Line: "#__LINE__
eq {'\\'} "\\"

# Fault appears in [assert] passing mis-parsed data to [eq]
assert "\\" {eq $_ "\\"} -v -line #__LINE__

/*	# logo() removed Oct/2019
if {$autoexec_ran} {						# Autoexec.tcl unsets logo
	set logo(3) " /_/ /_/\\__/\\___/_/"
}

# Check that [unescape] correctly shrinks
echo "'$logo(3)' (length [string length $logo(3)])"
assert [string length [unescape $logo(3)]] {== $_ 19} -v -line #__LINE__
# */

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #