###########################################################################
# Name:				test_precision.tcl
# Purpose:			Unit tests on [precision]
# Author:       	M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 22/Jan/2022 Implemented
###########################################################################
# Notes:
# Add starting position with guards integer [precision N ?startpos?]
###########################################################################

option expression on

set s ""
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "{}"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "    "
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s " ()    "
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "\t\t\t"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s " \t \t \t"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "Hello"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "2E32"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1A44"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1234567890"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1234567890."
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1234567890.0"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1234567890.e"
assert [precision $s] {== $_ 0} -v -line #__LINE__

set s "1234567890.1e"
assert [precision $s] {== $_ 1} -v -line #__LINE__

set s "1234567890.1e    "
assert [precision $s] {== $_ 1} -v -line #__LINE__

set s "1234567890.1"
assert [precision $s] {== $_ 1} -v -line #__LINE__

set s "1234567890.01"
assert [precision $s] {== $_ 2} -v -line #__LINE__

set s "1234567890.010000000000000000"
assert [precision $s] {== $_ 2} -v -line #__LINE__

set s "1234567890.01                "						# SPACE
assert [precision $s] {== $_ 2} -v -line #__LINE__

set s "1234567890.123"
assert [precision $s] {== $_ 3} -v -line #__LINE__

set s "1234567890.123               "						# SPACE
assert [precision $s] {== $_ 3} -v -line #__LINE__

set s "1234567890.1230000000000000000000"
assert [precision $s] {== $_ 3} -v -line #__LINE__

set s "1234567890.1230000000000000000000 \t  "
assert [precision $s] {== $_ 3} -v -line #__LINE__


set s "123456789012345678901234567890123456.78901234567890"
assert [precision $s] {== $_ 13} -v -line #__LINE__

set s "1234567890123456789012345.6789012345678901234567890"
assert [precision $s] {== $_ 24} -v -line #__LINE__

set s "12345.678901234567890123456789012345678901234567890"
assert [precision $s] {== $_ 44} -v -line #__LINE__

set s "123456789012345678901234.567890123456"
assert [precision $s] {== $_ 12} -v -line #__LINE__

set s "123456789012345.678901234567890123456"
assert [precision $s] {== $_ 21} -v -line #__LINE__

set s "123.456789012345678901234567890123456"
assert [precision $s] {== $_ 33} -v -line #__LINE__


unset s
###########################################################################
newline
vars
newline

textcolor green
puts "* Done *"
textcolor
# EOF #