########################################################################
# File: 			test_proc_no_return.tcl
# Purpose:			Testing that [proc] can return without [return]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 25/Jun/2018	First version
########################################################################
# Notes: 
# Ensure that [proc] returns last command without [return]
# v1.26 all tests pass 25/Jun/2018
# Legacy bug report:
# FIX proc return
#	[return] has become mandatory again when trying to return from procs
#	return [expr {4.0*(double($count)/double($n))}]	# works
#	expr {4.0*(double($count)/double($n))}			# does not work
########################################################################
option expression off

undef foo -nocomplain
proc foo {} {
	expr "4.0*$::pi"
}
puts [foo]
assert [foo] {== $_ 12.566370614359172} -v -line #__LINE__

undef foo -nocomplain
proc foo {} {
	expr {4.0*$::pi}
}
puts [foo]
assert [foo] {== $_ 12.566370614359172} -v -line #__LINE__

undef foo -nocomplain
proc foo {} {
	* 4.0 $::pi
}
puts [foo]
assert [foo] {== $_ 12.566370614359172} -v -line #__LINE__

undef foo -nocomplain
proc foo {} {
	mids Hello 0
}
puts [foo]
assert [foo] {eq $_ Hello} -v -line #__LINE__


undef foo -nocomplain

########################################################################
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #