######################################################################################
# File: 			test_random.tcl
# Purpose:			Test random number stuff
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 17/Jul/2017	First version
######################################################################################
# Notes:
# randomstr, rnd
######################################################################################

option echo on
option expression off

textcolor yellow
puts "Testing random number code ...\n"
textcolor

enum {
	RANDOM_STYLE_MIXED
	RANDOM_STYLE_LOWER
	RANDOM_STYLE_UPPER
	RANDOM_STYLE_NUMBERS
	RANDOM_STYLE_ALL
	RANDOM_STYLE_BINSTR
	RANDOM_STYLE_HEX
	RANDOM_STYLE_BINARY
	RANDOM_STYLE_BINARYBIAS0
	RANDOM_STYLE_BINARYBIAS1
	RANDOM_STYLE_HEX_LOWER
	RANDOM_STYLE_PRINTABLE
	RANDOM_STYLE_HEXALL
	RANDOM_STYLE_OCTAL
	RANDOM_STYLE_PASSWORD
	RANDOM_STYLE_SAFE
	RANDOM_STYLE_ALNUM_UPPER
	RANDOM_STYLE_MAX
}

vars random* -const

assert [string length [randomstr 10]] {== $_ 10} -v -line #__LINE__
newline

for {set i 0} {< $i 10} {++ i} {
	assert [rnd 0 2] {&& [>= $_ 0] [<= $_ 2]}  -v -line #__LINE__
}
newline

# rand() == 0..1
for {set i 0} {< $i 10} {++ i} {
	assert [funct rand] {&& [>= $_ 0] [<= $_ 1]}  -v -line #__LINE__
}

unset i -nocomplain
vars -const

# DONE ADD -glob
unset RANDOM_STYLE_* -glob -const

/*
unset RANDOM_STYLE_MIXED
unset RANDOM_STYLE_LOWER
unset RANDOM_STYLE_UPPER
unset RANDOM_STYLE_NUMBERS
unset RANDOM_STYLE_ALL
unset RANDOM_STYLE_BINSTR
unset RANDOM_STYLE_HEX
unset RANDOM_STYLE_BINARY
unset RANDOM_STYLE_BINARYBIAS0
unset RANDOM_STYLE_BINARYBIAS1
unset RANDOM_STYLE_HEX_LOWER
unset RANDOM_STYLE_PRINTABLE
unset RANDOM_STYLE_HEXALL
unset RANDOM_STYLE_OCTAL
unset RANDOM_STYLE_PASSWORD
unset RANDOM_STYLE_SAFE
unset RANDOM_STYLE_ALNUM_UPPER
unset RANDOM_STYLE_MAX
*/

newline
textcolor yellow
puts "Finished unsetting"
textcolor
vars -const
newline
vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #