########################################################################
# File: 			test_raw_nondecimals.tcl
# Purpose:			Tests for MPP processing of raw non-decimals
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 25/Jun/2018	First version
########################################################################
# Notes: 
########################################################################
option expression off

set a 0b110000000		# Will be transcoded by the file-load MPP phase
#assert $a {eq $_ "0b110000000"} -v -line #__LINE__
assert $a {== $_ 384} -v -line #__LINE__

set a 0xabcdef123
#assert $a {eq $_ "0xabcdef123"} -v -line #__LINE__
assert $a {== $_ 46118400291} -v -line #__LINE__

set a 0o1234567
assert $a {== $_ 342391} -v -line #__LINE__

lib ticol_r2d -nocomplain

set a mdcclxxvi		# Not processed by the MPP
#assert $a {== $_ 46118400291} -v -line #__LINE__
puts [roman_to_decimal $a]
assert [roman_to_decimal $a] {== $_ 1776} -v -line #__LINE__
set a [decimal_to_roman 1776]
puts $a
assert $a {eq $_ mdcclxxvi -nocase} -v -line #__LINE__
lib ticol_r2d -unload

unset a -nocomplain

########################################################################
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #