#################################################################
# File:				test_readfile.tcl
# Purpose:			Testing [readfile]
# Author:			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 24/Nov/2017	First version
#################################################################
# Notes:
#################################################################

option expression off
option echo on

textcolor yellow
puts "Testing string \[readfile\]"
textcolor
newline

set path [file dirname [info executablename]]
addslash path -var
set man_file "${path}ticol.man"

if {! [file exists $man_file]} {
	if {! [file exists "ticol.man"]} {		# Check current dir
		die "Test [info script] requires $man_file"
	} else {
		set man_file "ticol.man"
	}
}


set s [readfile $man_file]
assert $s {!= $_ ""} -v -line #__LINE__
puts "read in [string length s -var] bytes from $man_file, file size is [file size $man_file]"
assert [string length s -var] {== $_ [file size $man_file]} -v -line #__LINE__

unset man_file path s -nocomplain

vars

########################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #