############################################################################################
# File:				test_readwrite_file.tcl
# Author:			M Shaw
# Purpose:			Test file for save recursion limits
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 26/Nov/2017 First version
###########################################################################################
option expression on

textcolor yellow
puts "Testing \[writefile\] ..."
textcolor
newline

set filename "test_write-[randomstr 10 6].txt"

# Write QBF
writefile $filename $qbf 
set s [readfile $filename]
assert $s {eq $_ $::qbf} -v -line #__LINE__

# Append QBF
writefile $filename $qbf -append
set s [readfile $filename]
puts $s
assert $s {eq $_ "$::qbf$::qbf"} -v -line #__LINE__

unlink $filename

###########################################################################################
unset filename s -nocomplain
vars 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #
