############################################################################################
# File:				test_recursion.tcl
# Author:			M Shaw
# Purpose:			Recursive tests and examples
# See also:			test_safe_recursion.tcl
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 15/Jul/2018 First version
###########################################################################################
# Notes:
# Does not push recursion to stack overflow levels
# See test_safe_recursion.tcl
###########################################################################################
option expression on

textcolor yellow
puts "Test \[lmax\] with list argument"
textcolor
newline

proc lmax l {
    if {[llength $l] == 1} {
        lindex $l 0
    } else {
        if {[lindex $l 0] > [lmax [lrange $l 1 end]]} {
	      lindex $l 0
	  } else {
	      lmax [lrange $l 1 end]
	  }
    }
}

#puts [lmax {33 3535 34534 8 28838 23423432}]
assert [lmax {33 3535 34534 8 28838 23423432}] {== $_ 23423432} -v -line #__LINE__

undef lmax
newline

textcolor yellow
puts "Test \[lmax\] with args argument"
textcolor
newline

proc lmax {args} {
    if {[llength $args] == 1} {
        lindex $args 0
    } else {
        if {[lindex $args 0] > [lmax [lrange $args 1 end]]} {
	      lindex $args 0
	  } else {
	      lmax [lrange $args 1 end]
	  }
    }
}

#puts [lmax 33 3535 34534 8 28838 23423432]
assert [lmax 33 3535 34534 8 28838 23423432] {== $_ 23423432} -v -line #__LINE__

undef lmax 

textcolor yellow
puts "Test \[fib\]"
textcolor
newline

#trace add expr			# To debug problem case below ->>>>>>>

rename fib old_fib -nocomplain
#undef fib -nocomplain
proc fib {n} {
    if {$n < 3} {
        return 1
    } else {
        #expr [fib [expr {$n-2}]]+[fib [expr {$n-1}]]				# PASS
		#expr {[fib [expr {$n-2}]]+[fib [expr {$n-1}]]}				# FIX FAIL!!!!!!!!!
		return [expr {[fib [expr {$n-2}]]+[fib [expr {$n-1}]]}]		# PASS
    }
}

assert [fib 12] {== $_ 144} -v -line #__LINE__
#assert [fib 23] {== $_ 28657} -v -line #__LINE__
undef fib -nocomplain
rename old_fib fib -nocomplain
puts "fib restored? -> [commands fib]"
assert [commands fib] {eq $_ fib} -v -line #__LINE__

###########################################################################################
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #