######################################################################################
# File: 			return_exit_arrayforeach.tcl
# Purpose:			Test that [return] will exit arrayforeach
# Language:			Ticol Tcl v1.23+
# See also:			return.tcl
#
# Versions:
# 1.00 10/Jan/2017	First version
# 1.01 08/Jul/2017	Replaced [checkex] with [assert]
######################################################################################
# Notes: 
######################################################################################

# This code will exit the for loop and script when $i == 5
textcolor yellow
puts "\[array foreach\] I will exit the script when s eq fox with no more text visible"
textcolor
set a {}
set i 0

foreach s $qbf {
	set a($i) $s
	++ i
}

unset var -nocomplain
unset s -nocomplain
set s ""

catch {
	array foreach a var ss {
		if {[eq $var fox]} {
			textcolor green
			puts "returning var($ss) as $var"
			textcolor
			set ::s $var
			return $var
			puts "I will not be printed if var eq fox"
		}
		puts "var($ss) is $var"
	}

	textcolor red
	puts "I should not be seen"
	textcolor
}

assert $::s {== $_ fox} -v -line #__LINE__

array unset a -nocomplain
unset i s -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
option expression off
newline
textcolor green
puts "* \[return_exit_arrayforeach ... return\] Done *"
textcolor

# EOF #