######################################################################################
# File: 			return_exit_foreach.tcl
# Purpose:			Test that [return] will exit foreach
# Language:			Ticol Tcl v1.23+
# See also:			return.tcl
#
# Versions:
# 1.00 10/Jan/2017	First version
# 1.01 08/Jul/2017	Replaced [checkex] with [assert]
######################################################################################
# Notes: 
######################################################################################

# This code will exit the for loop and script when $i == 5
textcolor yellow
puts "\[foreach\] I will exit the script when s eq fox with no more text visible"
textcolor
catch {
	foreach s $qbf {
		if {[eq $s fox]} {
			textcolor green
			puts "Exiting with $s"
			textcolor
			return $s
			puts "I will not be printed if s eq fox"
		}
		puts "s is $s"
	}
	textcolor red
	puts "I should not be seen"
	textcolor
}
assert $s {== $_ fox} -v -line #__LINE__

unset s -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
option expression off
newline
textcolor green
puts "* \[foreach ... return\] Done *"
textcolor

# EOF #