######################################################################################
# File: 			return_exit_linkedlist_foreach.tcl
# Purpose:			Test that [return] will exit linkedlist_foreach
# Language:			Ticol Tcl v1.23+
# See also:			return.tcl
#
# Versions:
# 1.00 10/Jan/2017	First version
######################################################################################
# Notes: 
# This code will exit the for loop and script when $i == 5
# DONE FIX return exits script here
######################################################################################
# handle [linkedlist create]
# bool [linkedlist add handle lvalue ?rvalue?]
# string [linkedlist get handle lvalue]
# string [linkedlist item handle integer]
# code [linkedlist foreach $handle lvalue ?rvalue? {command}]
# bool [linkedlist in_list handle key]
# bool [linkedlist insert handle key lvalue ?rvalue?]
# long [linkedlist count handle]
# void [linkedlist walk handle]
# bool [linkedlist unset handle key]
# bool [linkedlist unset handle]
######################################################################################

textcolor cyan
lib ticol_list -verbose -nocomplain
textcolor
newline

textcolor yellow
puts "\[linkedlist foreach\] Script will exit when var eq 'fox'"
textcolor
newline

set l [linkedlist create]
puts "created linked list $l"
set a {}
set i 0
foreach s $qbf {
	linkedlist add $l $s		# Lvalue only
	++ i
}
puts "Created list with [linkedlist count $l] item(s)"
linkedlist walk $l
newline 

set check 0
linkedlist foreach $l var rv {
	#puts "var is $var rv=$rv"
	if {[eq $var fox]} {
		textcolor green
		puts "returning var as $var (you should see no more output)"
		textcolor
		return $var
		puts "I will not be printed"
		set check 1
	}
	textcolor magenta
	puts "var is $var"
	textcolor
}
newline
assert $check {== $_ 0} -v -line #__LINE__
assert $var {eq $_ fox} -v -line #__LINE__

linkedlist unset $l
lib ticol_list -unload
unset a check i l lv rv s var -nocomplain

vars

#############################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #