###########################################################################
# Name:				test_return_in_root.tcl
# Purpose:			Test file for [return] functionality in root context
# Author:           M Shaw
# Language:			Ticol Tcl v1.27+ (Build after Nov 2022)
#
# Versions:
# 1.00 18/Nov/2022	First version
###########################################################################
# Notes:
# This is a very short script
# If return does not exit this script and return to the calling one then
# a [die] will be encountered
###########################################################################

# Tests that return is functional in root context (i.e. outside a proc)
puts "Testing use of \[return\] in root context"
puts "This script should not die!"
return				# Should exit and return safely to the calling script

die "Failure to exit via \[return\] in [info scriptname] at "#__LINE__

# EOF #