######################################################################################
# File: 			test_return_in_sourced_file.tcl
# Purpose:			Test that [return] will exit a sourced file
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 15/Dec/2017	First version
######################################################################################
# Notes:
# Script test files are all sourced via [eval]
# The script evaluation master file will halt with an error if this test fails
######################################################################################

option expression off

# This file should have been included
textcolor yellow
puts "Testing \[return -code return\] in a sourced file (no vars used)"
textcolor
newline

# return -code ok will not quit this script
# return or return -code return will return 'code return' to the calling chain and cause 
# the calling chain to exit
# Should [source] ignore code return?
#return [return -code return] -code return  			# This should prevent the [die] below from executing and halting the test
return # -code ok # Quits [time] 

textcolor red
die "Test failed in [info script]"
textcolor

# EOF #