#############################################################################
# File:				return_proc.tcl
# Author:			M Shaw
# Purpose:			Test file for nested proc returns
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 04/Jun/2017	First version
#############################################################################
# Notes:
# We are looking to ensure that [return] is passed correctly down any
# hierarchy of [proc] and that it doesn't exit the script after [proc]
#############################################################################

option expression off

textcolor yellow
puts "Testing proc returns chain correctly"
textcolor
newline

undef mar -nocomplain 
undef bar -nocomplain
undef foo -nocomplain

proc mar x {
	puts "Enter proc mar $x Level: [info level]"
	return [* $x 6]
}

proc bar x {
	puts "Enter proc bar $x Level: [info level]"
	return [mar $x]
}

proc foo x {
	puts "Enter proc foo $x Level: [info level]"
	return [bar $x]
}

puts [foo 2]
assert [foo 2] {== $_ 12} -v -line #__LINE__

option expression on

puts [foo 3]
assert [foo 3] {== $_ 18} -v -line #__LINE__

newline
textcolor green
puts "If we are still here then \[return\] has not exited the script"
textcolor

undef mar -nocomplain 
undef bar -nocomplain
undef foo -nocomplain

vars

#############################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #