#############################################################################
# File:				test_returns.tcl
# Author:			M Shaw
# Purpose:			Test file for multiple return_*.tcl files
# Language:			Ticol Tcl v1.22+
#
# Versions:
# 1.00 16/Jan/2016	First version
#############################################################################
# Notes:
# Calls a sequence of return_exit_*.tcl
#############################################################################

# Evaluate a file with differering return flow control types ...
undef test -nocomplain
proc test {filename} {
	upvar @0 qbf							# Called scripts run in proc level 1
	if {[file exists $filename]} {
		textcolor yellow
		puts "Testing '$filename'\r\n"
		textcolor
		source $filename
		halt
	} else {
		die "Can't find $filename"
	}
}

test test_return_exit_array_foreach.tcl
test test_return_exit_do.tcl
test test_return_exit_for.tcl
test test_return_exit_foreach.tcl
test test_return_exit_linkedlist_foreach.tcl
# test return_exit_stackforeach.tcl		# Not implemented
test test_return_exit_while.tcl

#############################################################################
unset s -nocomplain
vars

newline
textcolor green
puts "* Done *"
textcolor

# EOF #