############################################################################################
# File: 			test_rndseq.tcl
# Purpose:			Test [rndseq]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 15/Oct/2019	First version
############################################################################################
# Notes:
############################################################################################

textcolor yellow
puts "Testing \[rnd\] ... @"#__LINE__
textcolor
newline

puts "Line: "#__LINE__
puts "Looping for 10000..."
time {
	assert [rnd 0 1] {|| [== $_ 0] [== $_ 1]} -line #__LINE__
} 10000


puts "Line: "#__LINE__
puts "Looping for 10000..."
time {
	assert [rnd 0 100] {&& [>= $_ 0] [<= $_ 100]} -line #__LINE__
} 10000


newline
puts "Line: "#__LINE__

textcolor yellow
puts "Testing \[rndseq\] ... @"#__LINE__
textcolor
newline

puts "Line: "#__LINE__
puts "Looping for 10000..."
set last -1
time {
	set current [rndseq 0 1]				# Most likely
	if {== $current $last} {
		die "\[rndseq\] failed at $current"
	} else {
		# puts $current
	}
	set last $current
} 10000 -info

puts "Line: "#__LINE__
puts "Looping for 10000..."
set last -1
time {
	set current [rndseq 0 10]				# Less likely to have collisions
	if {== $current $last} {
		die "\[rndseq\] failed at $current"
	} else {
		# puts $current
	}
	set last $current
} 10000 -info


puts "Line: "#__LINE__
puts "Looping for 10000..."
set last -1
time {
	set current [rndseq 0 10000]			# Least likely to have collisions
	if {== $current $last} {
		die "\[rndseq\] failed at $current"
	} else {
		# puts $current
	}
	set last $current
	

} 10000 -info

unset current last -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #  # # # # # # # # # # # # # #
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #