######################################################################################
# File:				test_run_argc.tcl
# Author:			M Shaw
# Purpose:			Test argc status on command [run]
# 					This is NOT a unit test (yet)
# Language:			Ticol Tcl v1.27+
#
# Version:
# 1.00 18/Dec/2022	First version
######################################################################################
# Notes:
# Currently absent on interp load -> run
# Present on: command line run file
######################################################################################

sub on_error {
	puts "ENTER \[on_error\] - message $::errorMsg"
	puts "Dying..."
	die
}

vars
newline	
vars -const
newline
textcolor yellow
puts "argc is '$argc'"
puts "argv0 is '$argv0'"
# puts "argv(0) is $argv(0)"
newline

textcolor magenta
loop i 0 $argc {
	puts "argv($i) is '$argv($i)'"
}
textcolor
newline
array walk argv
newline

textcolor green
puts "* Done *"
textcolor

# This can be made into a unit test...
# ensure [on_error] is not called for caught errors
catch {/ 22 0}

try {/ 22 0} catch {puts "Caught div"}

puts "Script is still here after caught error"

/ 22 0

puts "Script is still here after non-trapped error"

# EOF