#################################################################################
# File: 			test_run_option.tcl
# Purpose:			Tests for [option escape] via [run] and [source] from CLI
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 05/Feb/2022 First version
#######################################################################################
# Notes:
# [run] will force [option escape] to ON, [source] leaves this setting
# unchanged. Entering the CLI will force this option OFF so using [source]
# from the CLI will require correctly setting [option escape] in a script
# Thus, any scripts which depend on processing Tcl backslash escape
# sequences may not work properly if called using [source] from the CLI
#
# In short:
# OPTION ESCAPE ON is required for most scripts to function and the MPP to work
# Entering the CLI turns option escape to OFF so the CLI can be used as a CCP
# [run] turns option escape to ON
# [source] leaves option escape alone and unchanged
#######################################################################################
# This script is to be called only by using [run]
#######################################################################################

option			# Display the inherited setting(s)

# EOF #