################################################################################
# File:			test_setat.tcl
# Author:		M Shaw
# Purpose:		Tests of [setat] command
# Language:		Ticol Tcl
#
# Versions:
# 14/Oct/2017	First version
################################################################################
# Notes:
# FIX if startpos > string length then return ""
################################################################################
option expression off
option echo on

textcolor yellow
puts "Testing \[setat\] ..."
textcolor
newline

puts "Length \$qbf is [len $qbf]"

#set q ""			# No longer required
setat q $qbf 1 -1	# Set q by copying from $qbf at 17 for 3 chars
puts "q is $q"
assert $q {eq $_ ""} -v -line #__LINE__

setat q $qbf 1 0
puts "q is $q"
assert $q {eq $_ ""} -v -line #__LINE__

setat q $qbf 1 1
puts "q is $q"
assert $q {eq $_ "T"} -v -line #__LINE__

setat q $qbf 1 2
puts "q is $q"
assert $q {eq $_ "Th"} -v -line #__LINE__

setat q $qbf 17 3
puts "q is $q"
assert $q {eq $_ "fox"} -v -line #__LINE__

setat q $qbf 41 3
puts "q is $q"
assert $q {eq $_ "dog"} -v -line #__LINE__

setat q $qbf 44 1
puts "q is $q"
assert $q {eq $_ "g"} -v -line #__LINE__
newline

puts "-----------------------"
# TODO implement arrays as argument
set a(0) $qbf
puts "\$a(0) is '$a(0)'"
setat a(0) $qbf 1 3
#vars
puts "\$a(0) is '$a(0)'"
assert $a(0) {eq $_ "The"} -v -line #__LINE__

setat a(0) $qbf -1 -1
assert $a(0) {eq $_ ""} -v -line #__LINE__

setat a(0) $qbf 1 -1
assert $a(0) {eq $_ ""} -v -line #__LINE__

#setat a(0) $qbf -1 1
#assert $a(0) {eq $_ ""} -v -line #__LINE__

setat a(0) $qbf 1 0
assert $a(0) {eq $_ ""} -v -line #__LINE__

setat a(0) $qbf 1 2
assert $a(0) {eq $_ "Th"} -v -line #__LINE__

setat a(0) $qbf 17 3
assert $a(0) {eq $_ "fox"} -v -line #__LINE__

array unset a -nocomplain
unset q -nocomplain

newline
textcolor magenta
puts "-- Cleanup -------------------------------------"
vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #