###########################################################################
# File: 			test_setr.tcl
# Purpose:			Test case for list based [setr]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 05/Sep/2019	First version
###########################################################################
# Notes: 
###########################################################################

textcolor yellow
puts "Testing \[setr\] ..."
textcolor

# Blanks ...
set s {}
setr s Hello
puts $s
assert $s {eq $_ ""} -v -line #__LINE__

set s {}
setr s ""
puts $s
assert $s {eq $_ ""} -v -line #__LINE__

set s ""
setr s {}
puts $s
assert $s {eq $_ ""} -v -line #__LINE__

set s {}
setr s {}
puts $s
assert $s {eq $_ ""} -v -line #__LINE__

# Non-blanks ..
set s [makestr 1]
setr s Hello
puts $s
assert $s {eq $_ "H"} -v -line #__LINE__

set s [makestr 2]
setr s Hello
puts $s
assert $s {eq $_ "He"} -v -line #__LINE__

set s [makestr 5]
setr s Hello
puts $s
assert $s {eq $_ "Hello"} -v -line #__LINE__

set s [makestr 20]
setr s Hello
puts $s
assert $s {eq $_ "               Hello"} -v -line #__LINE__

unset s -nocomplain 

vars
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #