#################################################################################
# File: 			test_named_store.tcl
# Purpose:			Tests for [store] command (not a unit test)
# Author: 			M Shaw
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 05/Jan/2018	First version (separate stores implemented)
# 1.01 28/Nov/2021	Minor changes
#################################################################################
# Notes:
# <=>
# 0  Equal
# 1  Greater
# -1 Lesser
# PASS Command form
# PASS [expr] form
#################################################################################

option expression off

textcolor yellow
puts "[info script]"
puts "Testing PERL-like 'spaceship' command ..."
textcolor
newline

# Character
assert [<=> a a] {== $_ 0} -v -line #__LINE__
assert [<=> a b] {== $_ -1} -v -line #__LINE__
assert [<=> b a] {== $_ 1} -v -line #__LINE__

# Number
assert [<=> 0 0 ] {== $_ 0} -v -line #__LINE__
assert [<=> 0 1] {== $_ -1} -v -line #__LINE__
assert [<=> 1 0] {== $_ 1} -v -line #__LINE__

assert [<=> 12345 12345 ] {== $_ 0} -v -line #__LINE__
assert [<=> 12344 12345] {== $_ -1} -v -line #__LINE__
assert [<=> 12345 12344] {== $_ 1} -v -line #__LINE__

# String
assert [<=> hello hello] {== $_ 0} -v -line #__LINE__
assert [<=> bye hello] {== $_ -1} -v -line #__LINE__
assert [<=> hello bye] {== $_ 1} -v -line #__LINE__

# String with spaces
assert [<=> "hello world" "hello world"] {== $_ 0} -v -line #__LINE__
assert [<=> bye "hello world"] {== $_ -1} -v -line #__LINE__
assert [<=> "hello world" bye] {== $_ 1} -v -line #__LINE__

# Case
assert [<=> hello hello] {== $_ 0} -v -line #__LINE__
assert [<=> Hello hello] {== $_ -1} -v -line #__LINE__
assert [<=> hello Hello] {== $_ 1} -v -line #__LINE__



/* Expression form is not implemented as this is a string command
option expression on

if {"a" <=> "b"} {puts yes} else {puts no}
set i 0

if {eq [expr "a" <=> "a"] -1} {set i 1}
assert $i {== $_ 1} -v -line #__LINE__

if {== [expr "a" <=> "b"] 1} {set i 1}
assert $i {== $_ 1} -v -line #__LINE__
# */

unset i -nocomplain

textcolor green
puts "* Done *"
textcolor

vars

#EOF