######################################################################################
# File: 			test_spawn.tcl
# Purpose:			Test [spawn]
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 07/Dec/2017	First version
# 1.01 17/Jan/2022	Have now fixed [spawn] in wintest.exe and ticol.dll
######################################################################################
# Notes:
# DONE Remove DLL block on testing [spawn]
# DONE FIX block in all cases of running under the DLL
# FIX return not exiting. Added else clause
######################################################################################

option expression off

#walk

# spawn #############################################
puts "info script-> '[info script]'"
/*
if {|| [eq [info script] "internal.tcl"] [eq [info script] ""]} {
	puts "test_spawn.tcl won't run in embedded Tcl"		# DOC WHY
	return # -code ok		# Don't use -code ok
} else { # */
	puts "Line: "#__LINE__
	textcolor yellow
	puts "[info script] Testing \[spawn\]\n"
	puts "Running: \[spawn - \$env(COMSPEC) /c set /a \"_num=(2+3)*5\"\]\r\n"
	textcolor

	# The set command is CMD.EXE internal and thus requires COMSPEC
	set line #__LINE__
	puts "Line: $line"
	#debug off
	#set x 25					# FIX anomaly, dquote rewrite forces var declaration at level 0
	if {gt [lindex [info winver -list] 1] 5.0} {
		puts "Line: "#__LINE__
		assert 25 {== $_ 25} -v -line #__LINE__
		puts "Line: "#__LINE__
		assert [spawn - $env(COMSPEC) /c set /a "_num=(2+3)*5"] {== $_ 25} -v -line #__LINE__
	} else {
		puts "Winver is not > 5.0 - not running [info script]"
	}

	puts "Line: "#__LINE__

	#####################################################
	unset line -nocomplain
	vars

	newline
	textcolor green
	puts "* Done *"
	textcolor
#}
# EOF #