######################################################################################
# File: 			test_spawn_stub.tcl
# Purpose:			Test for example ticol.dll C++ stub EXE
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 27/Nov/2019	First version
######################################################################################
# Notes: 
######################################################################################
option expression off

puts "info script-> '[info script]'"
if {|| [eq [info script] "internal.tcl"] [eq [info script] ""]} {
	puts "test_spawn.tcl won't run in embedded Tcl"
	return # -code ok		# Don't use -code ok
} else {

	textcolor yellow
	puts "Using \[spawn\] to launch ticol_stub.exe to test ticol.dll linkage ..."
	textcolor
	newline

	#set r ""
	#spawn - -echo ticol_stub.exe {puts [expr 22/7.0];flush} 
	spawn r ticol_stub.exe -q {puts [expr 4*atan(1)] -nonewline;flush} 

	puts "stub return r was\n'" -nonewline
	textcolor darkyellow
	puts $r -nonewline
	textcolor
	puts "'"


	puts "Pie is $pi"
	assert [round $r 10] {eq $_ [round $pi 10]} -v -line #__LINE__

	unset r -nocomplain

	# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
	newline
	vars
	newline
	textcolor green
	puts "* Done *"
	textcolor
}
# EOF #
