#################################################################################
# File:				test_stack_foreach.tcl
# Author:			M Shaw
# Purpose:			Test cases [stack foreach]
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 11/Jul/2017	First version (Implemented 'foreach' subcommand)
#################################################################################
# Notes:
# TODO test for memory leaks
#################################################################################

option expression off
textcolor yellow
puts "Testing \[stack foreach\]"
textcolor
newline

unset s -nocomplain

stack create s 100
stack push s "Hello"
stack push s "there"
stack push s "how"
stack push s "are"
stack push s "you"

textcolor yellow
puts "Testing \[stack foreach\] normal order"
textcolor
set count 0
stack foreach s x {
	++ count
	puts "$count:\t'$x'"
	if {== $count 1} {
		assert $x {eq $_ Hello} -v -line #__LINE__
	} elseif {== $count 3} {
		assert $x {eq $_ how} -v -line #__LINE__
	}
}
newline

assert $count {== $_ 5} -v -line #__LINE__
newline

textcolor yellow
puts "Testing \[stack foreach\] reverse order"
textcolor
set count 0
stack foreach s x {
	++ count
	puts "$count:\t'$x'"
	if {== $count 1} {
		assert $x {eq $_ you} -v -line #__LINE__
	} elseif {== $count 3} {
		assert $x {eq $_ how} -v -line #__LINE__
	}
} -r
newline

assert $count {== $_ 5} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# 2017/Jul/14 - No leaks. Some expected memory fragmentation increase
##define testforleaks
#ifdef testforleaks
# Memory leak test 
puts "Testing for memory leaks..."
set count 0
time {
	stack foreach s x {
		++ count
	}
} 1000000
puts "Count was $count"
#endif
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

stack unset s
unset count x -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #