#################################################################################
# File:				test_static_leak.tcl
# Author:			M Shaw
# Purpose:			Test for leaks in [static]
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 18/Sep/2018	First version
#################################################################################
# Notes:
# Suddenly ran slow taking 1336, 2704 usec per iter
#################################################################################

option expression off
textcolor yellow
puts "Testing test_static_leak ... @"#__LINE__
textcolor
newline

set count 1
set loops 10000 # 1000000

undef foo -nocomplain
textcolor yellow
puts "Test $count @"#__LINE__
textcolor
++ count
set memstart [mem_used]
time {
	static s 0
} $loops -info
puts "Used [- [mem_used] $memstart] bytes"
assert $s {== $_ 0} -v -line #__LINE__
unset s -nocomplain
newline


textcolor yellow
puts "Test $count @"#__LINE__
textcolor
++ count

undef foo -nocomplain
proc foo x {
	static s 0
}

set memstart [mem_used]
time {
	foo
} $loops -info
puts "Used [- [mem_used] $memstart] bytes"
assert $foo::s {== $_ 0} -v -line #__LINE__
newline

textcolor yellow
puts "Test $count @"#__LINE__
textcolor
++ count
undef foo -nocomplain
proc foo x {
	static s 0
	++ s
}

set memstart [mem_used]
time {
	foo
} $loops -info
puts "Used [- [mem_used] $memstart] bytes"
assert $foo::s {== $_ $::loops} -v -line #__LINE__
newline

unset count loops memstart -nocomplain
static s -unset
static foo::s -unset
newline

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #	