###############################################################################################
# File:				test_string_map.tcl
# Author:			M Shaw
# Purpose:			Test file for [string map]
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 04/Mar/2017	Migrated from tests.tcl
# 1.01 16/Jul/2017	Added more tests. Implemented [assert]
###############################################################################################
# Notes
# These tests are string map
###############################################################################################

option expression off

# map
textcolor yellow
puts "\[string map\] ..."
textcolor

#define str
#ifdef str
assert [string map {abc 1 ab 2 a 3 1 0} 1abcaababcabababc] {eq $_ 01321221} -v -line #__LINE__
assert [string map {1 0 ab 2 a 3 abc 1} 1abcaababcabababc] {eq $_ 02c322c222c} -v -line #__LINE__
assert [string map {1 0 ab {} a 3 abc 1} 1abcaababcabababc] {eq $_ 0c3cc} -v -line #__LINE__
#                                         1 ab c a ab ab c ab ab ab c
#                                         0 {} c 3 {} {} c {} {} {} c
assert [string map {1 0 ab 2 a 3 abc 1} frederick] {eq $_ frederick} -v -line #__LINE__
assert [string map {abc 1 ab 2 a 3 1 0} {} {} {} {}] {eq $_ ""} -v -line #__LINE__
assert [string map {abc 1 ab 2 a 3 1 0} {}] {eq $_ ""} -v -line #__LINE__
assert [string map {abc 1 ab 2 a 3 1 0} ""] {eq $_ ""} -v -line #__LINE__

set s "1&lt;2 2&gt;1 2&ge;2 2&le;2"
assert [string map -nocase {
	  "&lt;"      "<"
	  "&gt;"      ">"
	  "&le;"      "<="
	  "&ge;"      ">="
	} $s] {eq $_ "1<2 2>1 2>=2 2<=2"} -v -line #__LINE__

set s "1&lt;2, 2&gt;1, 2&ge;2, 2&le;2"
assert [string map -nocase {
	  "&lt;"      " < "
	  "&gt;"      " > "
	  "&le;"      " <= "
	  "&ge;"      " >= "
	} $s] {eq $_ "1 < 2, 2 > 1, 2 >= 2, 2 <= 2"} -v -line #__LINE__
	
unset s -nocomplain

#endif

vars


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #