######################################################################################
# File: 			test_string_parse.tcl
# Purpose:			Test for string parsing issues
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 12/Oct/2019	First version
######################################################################################
# Notes:
# Tests for underlying issues and complexities while parsing strings
# Needs more tests adding. Add as I come across useful cases
######################################################################################

textcolor yellow
puts "Test string parsing (quoted strings etc.) ..."
textcolor
newline

######################################################################################
set s "one"
assert $s {eq $_ {one}} -v -line #__LINE__

set s "one""two"
assert $s {eq $_ {onetwo}} -v -line #__LINE__

set s "one""two""three"
assert $s {eq $_ {onetwothree}} -v -line #__LINE__

######################################################################################
# Multi-line with adjacent/embedded empty dquotes

# Empty multi-line
set s "\
\
\
"
assert $s {eq $_ {}} -v -line #__LINE__

# One empty lines
set s "
"
echo $s -hex
assert $s {eq $_ {\r\n}} -v -line #__LINE__

# Two empty lines
set s "

"
echo $s -hex
assert $s {eq $_ {\r\n\r\n}} -v -line #__LINE__

# Empty multi line with embedded empty dquotes
set s "\
\
""\
"
assert $s {eq $_ {}} -v -line #__LINE__

set s "\
one\
""\
"
assert $s {eq $_ {one}} -v -line #__LINE__

set s "\
one\
""\
two"
assert $s {eq $_ {onetwo}} -v -line #__LINE__

set s "\
one\
""\
two\
""\
three"
assert $s {eq $_ {onetwothree}} -v -line #__LINE__



unset s -nocomplain

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #