##############################################################################
# File: 			test_strip.tcl
# Purpose:			Test [stripto] and [striptor]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Oct/2018	First version
##############################################################################
# Notes:
# ADD test stability for reversed args
##############################################################################
option expression off

set s ""
assert [stripto "" ""] {eq $_ ""} -v -line #__LINE__
assert [stripto "" {}] {eq $_ ""} -v -line #__LINE__
assert [stripto {} ""] {eq $_ ""} -v -line #__LINE__
assert [stripto {} {}] {eq $_ ""} -v -line #__LINE__
assert [stripto {} $s] {eq $_ ""} -v -line #__LINE__
assert [stripto "" $s] {eq $_ ""} -v -line #__LINE__
assert [stripto $s {}] {eq $_ ""} -v -line #__LINE__
assert [stripto $s ""] {eq $_ ""} -v -line #__LINE__
# -var
puts "Line: "#__LINE__
assert [stripto {} s -var] {eq $_ ""} -v -line #__LINE__
puts "Line: "#__LINE__
assert [stripto "" s -var] {eq $_ ""} -v -line #__LINE__
# Malforumus est.
puts "Line: "#__LINE__
catch {
	assert [stripto s {} -var] {eq $_ ""} -v -line #__LINE__
}
puts "Line: "#__LINE__
catch {
	assert [stripto s "" -var] {eq $_ ""} -v -line #__LINE__
}

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

assert [striptor "" ""] {eq $_ ""} -v -line #__LINE__
assert [striptor "" {}] {eq $_ ""} -v -line #__LINE__
assert [striptor {} ""] {eq $_ ""} -v -line #__LINE__
assert [striptor {} {}] {eq $_ ""} -v -line #__LINE__
assert [striptor {} $s] {eq $_ ""} -v -line #__LINE__
assert [striptor "" $s] {eq $_ ""} -v -line #__LINE__
assert [striptor $s {}] {eq $_ ""} -v -line #__LINE__
assert [striptor $s ""] {eq $_ ""} -v -line #__LINE__
# -var
puts "Line: "#__LINE__
assert [striptor {} s -var] {eq $_ ""} -v -line #__LINE__
puts "Line: "#__LINE__
assert [striptor "" s -var] {eq $_ ""} -v -line #__LINE__
# Malforumus est.
puts "Line: "#__LINE__
catch {
	assert [striptor s {} -var] {eq $_ ""} -v -line #__LINE__
}
puts "Line: "#__LINE__
catch {
	assert [striptor s "" -var] {eq $_ ""} -v -line #__LINE__
}

puts "Line: "#__LINE__
assert [striptor {} $qbf] {eq $_ $::qbf} -v -line #__LINE__
assert [striptor "" $qbf] {eq $_ $::qbf} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# stripto
puts "Line: "#__LINE__
set s "brave new world"
assert [stripto "new" $s] {eq $_ "new world"} -v -line #__LINE__
assert [stripto "new" $s -remove] {eq $_ " world"} -v -line #__LINE__
assert [stripto "new" s -var] {eq $_ "new world"} -v -line #__LINE__
assert [stripto "new" s -var -remove] {eq $_ " world"} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
# striptor
puts "Line: "#__LINE__
set s "brave new world"
assert [striptor "new" $s] {eq $_ "brave new"} -v -line #__LINE__
assert [striptor "NEW" $s -nocase] {eq $_ "brave new"} -v -line #__LINE__
assert [striptor "new" $s -remove] {eq $_ "brave "} -v -line #__LINE__
assert [striptor "NEW" $s -remove -nocase] {eq $_ "brave "} -v -line #__LINE__

assert [striptor "new" s -var] {eq $_ "brave new"} -v -line #__LINE__
assert [striptor "NEW" s -var -nocase] {eq $_ "brave new"} -v -line #__LINE__
assert [striptor "new" s -var -remove] {eq $_ "brave "} -v -line #__LINE__
assert [striptor "NEW" s -var -remove -nocase] {eq $_ "brave "} -v -line #__LINE__

set class_name "test::constructor"
set class_name [striptor :: class_name -remove -var]
assert $class_name {eq $_ "test"} -v -line #__LINE__
unset class_name

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

puts "Line: "#__LINE__
set s 100h
textcolor yellow
puts "Test \[stripto\] ..."
textcolor
puts "stripto:'[stripto h $s]'"
assert [stripto h $s] {eq $_ h} -v -line #__LINE__
puts "stripto:'[stripto h s -var]'"
assert [stripto h s -var] {eq $_ h} -v -line #__LINE__
newline

puts "Line: "#__LINE__
textcolor yellow
puts "Test \[striptor\] ..."
textcolor
set s 100h
puts "striptor:'[striptor h $s -remove]'"
assert [striptor h $s -remove] {eq $_ "100"} -v -line #__LINE__
puts "striptor:'[striptor h s -remove -var]'"
assert [striptor h s -var -remove] {eq $_ "100"} -v -line #__LINE__

puts "Line: "#__LINE__
unset s -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #\a

newline
textcolor green
puts "* Done *"
textcolor

# EOF #