######################################################################################
# File: 			test_strstr.tcl
# Purpose:			Test [strstr]
# Language:			Ticol Tcl v1.23+, v1.26+
#
# Versions:
# 1.00 23/Jul/2017	First version
# 1.01 30/Jan/2022	Updated
######################################################################################
# Notes:
# Add more tests!
######################################################################################
option expression off

textcolor yellow
puts "Testing \[strtok\] ..."
textcolor
newline

# NULL needle
assert [strstr $qbf ""] {== $_ 0} -v -line #__LINE__
assert [strstr $qbf {}] {== $_ 0} -v -line #__LINE__

assert [strstr $qbf "" -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr $qbf {} -nocase] {== $_ 0} -v -line #__LINE__

# NULL haystack
assert [strstr "" $qbf] {== $_ 0} -v -line #__LINE__
assert [strstr {} $qbf ] {== $_ 0} -v -line #__LINE__

assert [strstr "" $qbf -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr {} $qbf -nocase] {== $_ 0} -v -line #__LINE__

# Both args NULL
assert [strstr "" ""] {== $_ 0} -v -line #__LINE__
assert [strstr {} "" ] {== $_ 0} -v -line #__LINE__
assert [strstr "" ""] {== $_ 0} -v -line #__LINE__
assert [strstr "" {} ] {== $_ 0} -v -line #__LINE__

assert [strstr "" "" -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr {} "" -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr "" "" -nocase] {== $_ 0} -v -line #__LINE__
assert [strstr "" {} -nocase] {== $_ 0} -v -line #__LINE__


assert [strstr $qbf fred] {== $_ 0} -v -line #__LINE__
assert [strstr $qbf fox] {== $_ 17} -v -line #__LINE__
assert [strstr $qbf QUICK -nocase] {== $_ 5} -v -line #__LINE__

assert [!= [strstr $qbf lazy] 0] {== $_ 1} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
vars
newline

textcolor green
puts "* Done *"
textcolor

# EOF #