######################################################################################
# File: 			test_strtok.tcl
# Purpose:			Test [strtok]
# Language:			Ticol Tcl v1.23+
#
# Versions:
# 1.00 23/Jul/2017	First version
######################################################################################
# Notes:
# Based on man file examples
######################################################################################
option expression off

textcolor yellow
puts "Testing \[strtok\] ..."
textcolor
newline

set count [strtok $qbf " " a]
for {set i 0} {< $i $count} {++ i} {puts $a($i)} 
/*
	The
	quick
	brown
	fox
	jumps
	over
	the
	lazy
	dog */
	
assert $a(0) {eq $_ The} -v -line #__LINE__
assert $a(4) {eq $_ jumps} -v -line #__LINE__
assert $a(8) {eq $_ dog} -v -line #__LINE__
newline

strtok $qbf " " a
array foreach a x {puts '$x'}    # Will be unsorted from array a
/*
	The
	dog
	brown
	jumps
	over
	the
	fox
	lazy
	quick */
newline

strtok $qbf " " a
foreach x [array sort a] {puts $x}    # Will be sorted from list

/*
	brown
	dog
	fox
	jumps
	lazy
	over
	quick
	The
	the */

assert [lindex [array sort a] 0] {eq $_ brown} -v -line #__LINE__
assert [lindex [array sort a] 3] {eq $_ jumps} -v -line #__LINE__
assert [lindex [array sort a] 8] {eq $_ the} -v -line #__LINE__

/*
set s {one "two three" four "five six" seven}
puts "'$s'"
#set count [strtok $s " " a]
for {set i 0} {< $i $count} {++ i} {
	#puts "array $i\t'$a($i)'"
	puts "lindex $i '[lindex $s $i]'"
}
array unset a -nocomplain
# */

array unset a -nocomplain
unset count i x -nocomplain
vars	

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

newline
textcolor green
puts "* Done *"
textcolor

# EOF #