#################################################################################################
# File: 			tsst_struct_create.tcl
# Purpose:			Test cases for [struct create] only
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 03/Jul/2018	First version (ported from test_struct.tcl)
#################################################################################################
# Notes: 
#################################################################################################
option expression off

/*
undef print_line -nocomplain
if {! [defined print_line]} {
	proc print_line {l} {
		upvar line
		set line $l
		textcolor yellow
		puts "Line: $l"
		textcolor
	}
} # */
########################################################################################

textcolor yellow
puts "Testing \[struct\] [info script] ..."
textcolor
newline

set expression_state [option expression]
option expression off
set echostate [option echo]
option echo off
unset s -nocomplain					# Ensure we can work with s

# Empty struct case
textcolor darkyellow
puts "wrong args: (ignore error message)"
textcolor yellow
catch {struct s}

textcolor darkyellow
puts "wrong args (ignore error message)"
textcolor yellow
if {! [catch {struct s} err]} {
	die "Fail at $line"
} else {}

textcolor
struct unset s -nocomplain

option echo on
# Alternate syntaxes
struct create s {{f1 10} {f2 20} {f3 30}}
struct unset s

# Simplest struct
struct s  {
	{s_a    4}
}

struct unset s

# Simplest struct
struct s  {
	s_a    23
	s_b    45
}
struct unset s

struct create s {
	{s_a    40}
	{s_b    100}
}
struct unset s

struct create s 256 {
	{s_a    40}
	{s_b    100}
}
struct unset s

struct s 256 {
	{s_a    40}
	{s_b    100}
}
struct unset s


struct s  {
	{s_a    4}
}

# Catch create with existing struct
textcolor darkyellow
puts "catch: (ignore error message)"
textcolor yellow
catch {
	struct s  {
		{s_a    4}
	}
}
textcolor
newline

# Struct unset
struct unset s
struct unset s -nocomplain

if {! [catch {					# Should not raise an error
	struct unset s
}] } {
	die "struct unset should err when unsetting non-existent struct"
}


# leak tests
option echo $echostate
option expression $expression_state

undef print_line -nocomplain
unset echostate err expression_state -nocomplain
vars
puts [procs]

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "\[struct\] * Done *"
textcolor

# EOF #