##############################################################################
# File:				test_struct_unary.tcl
# Author:			M Shaw
# Purpose:			Unary struct member ops as rvalues
#
# Versions:
# 1.00	07/Jan/2023	First version
##############################################################################
# Notes:
# ++, --, incr, decr
# ~ already implemented separately
# ADD +=, -=, *=, /=, ^= etc. rvalue handling (combi-math)
##############################################################################
option expression off

textcolor yellow
puts "Running [file name [info script]] .."
textcolor
newline

struct create foo {a 10}
struct set foo.a 13
puts "foo.a initialised to $foo.a @"#__LINE__
assert $foo.a {== $_ 13} -v -line #__LINE__

++ foo.a
puts "foo.a is now $foo.a@"#__LINE__
assert $foo.a {== $_ 14} -v -line #__LINE__

-- foo.a
puts "foo.a is now $foo.a @"#__LINE__			# 13
assert $foo.a {== $_ 13} -v -line #__LINE__

incr foo.a
puts "foo.a is now $foo.a @"#__LINE__			# 14
assert $foo.a {== $_ 14} -v -line #__LINE__

decr foo.a
puts "foo.a is now $foo.a @"#__LINE__			# 13
assert $foo.a {== $_ 13} -v -line #__LINE__

# Bitwise NOT is already implemented [~]
puts "foo.a is now [~ $foo.a] @"#__LINE__		# -14 (validated with ActiveState)
assert [~ $foo.a] {== $_ -14} -v -line #__LINE__

##############################################################################
struct unset foo -nocomplain
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #