#################################################################################
# File:				test_tcl_stack.tcl.tcl
# Author:			M Shaw
# Purpose:			Test cases Tcl stacks and unary increment array handling
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 18/Sep/2018	First version
#################################################################################
# Notes:
#################################################################################

/*
undef push -nocomplain
proc push {s x} {
	upvar $s
	puts "Enter push '$s' -> $x"
	#set name $s
	#static ${s}::ix 0
	puts "Line: "#__LINE__
	set name ::stack::${s}::ix
	#upvar @0 "set name ::stack::${s}::ix"
	#upvar $name
	puts "Line: "#__LINE__
	puts "debug: '$name'"
	puts "Line: "#__LINE__
	set $name 0
	vars -level 0
	set ${s}(${$name})	$x
	#set ${name(${::stack::${name}::ix}}) $x
	puts "Line: "#__LINE__
	#++ ::stack::${name}::ix
	#uplevel @0 "++ $name"
	vars
	++ $name
	puts "name is '$$name'"
	vars -level 0
}

undef pop -nocomplain
proc pop {s} {
	static $s:
	if {> $ix 0} {
		set r $s($s::ix)
		-- s::
	}
}

#set st(::stack::st::ix) Hello
#array walk st
#vars
#stop
#set st ""

set st ""
push st Hello
push st World
vars
array walk st
# */

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

option expression on

undef push -nocomplain
proc push {s value} {
	upvar $s S
	if {! [info exists S(top)]} {
		set S(top) 0
	}
	set S($S(top)) $value
	vars
	array walk S
	++ S(top)
}

undef pop -nocomplain
proc pop {s} {
	upvar $s S
	if {! [info exists S(top)]} {
		return {}
	}
	if {$S(top) == 0 }  {
		return {}
	} else {
		-- S(top)
		set x $S($S(top))
		unset S($S(top))
		return $x
	}
}


newline
textcolor yellow
puts "Testing specimen Tcl stacks ..."
textcolor
newline

assert [pop st] {eq $_ {}} -v -line #__LINE__

push st Hello
push st World
vars
#array walk st

assert [pop st] {eq $_ World} -v -line #__LINE__
assert [pop st] {eq $_ Hello} -v -line #__LINE__
assert [pop st] {eq $_ {}} -v -line #__LINE__
assert [pop st] {eq $_ {}} -v -line #__LINE__
newline

array unset st -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #