#########################################################################################
# File:			test_tcx_writefile.tcl
# Author:		M Shaw
# Purpose:		Developmentn test of [tcx writefile] and comparison with other commands
# Language:		Ticol Tcl v1.26+
#
# Versions:
# 1.00 06/Aug/2019	First version
#########################################################################################
# Notes:
# FIX Change internal default PW for TCX
#########################################################################################

option echo on

puts "Line: "#__LINE__
lib ticol_tcx -verbose -nocomplain


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
puts "Line: "#__LINE__
set code "ibuhXiuUJYyD6Uubn7G4L/wRkK/BtOkaHi5IFuULSaPU/3YskM139seIuesC7KEhQjprZY83PyZAqzgwFmlfnIkpMMmSMvs="
# Execute the code (call [eval] internally)
puts "Line: "#__LINE__
tcx run $code		# PASS
puts "Line: "#__LINE__
puts "decoded: '[tcx decode $code -password ticol]'"
puts "Line: "#__LINE__
set s [readfile good_tcx.t64]
assert [eq $s $code] {== $_ 1} -v -line #__LINE__
textcolor magenta
puts "decoded: '[tcx decode $s]'"
textcolor
newline
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

puts "Line: "#__LINE__
set r [tcx encode {puts {hello from tcx dll}}]
puts "Encoded '$r'"
puts "decoded: '[tcx decode $r]'"
assert [tcx decode $r] {eq $_ "puts {hello from tcx dll}"}


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
puts "Line: "#__LINE__
set r [tcx writefile tcx_test_out.tcx {puts {hello from tcx dll}}]
# exec ticol.exe tcx_test_out.tcx /i
puts "Line: "#__LINE__
textcolor magent
source tcx_test_out.tcx
textcolor
newline

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
puts "Line: "#__LINE__
set code {puts {hello from tcx dll}}
set filename tcx_test_out.t64
puts "Line: "#__LINE__
set r [tcx writefile $filename $code -64]
puts "Line: "#__LINE__
# exec ticol.exe $filename /i
puts "Line: "#__LINE__
puts "tcx writefile returned $r"
puts "Line: "#__LINE__
set s [readfile tcx_test_out.t64]
puts "readfile s is '$s'"
puts "Line: "#__LINE__
set r [tcx decode $s]
puts "Line: "#__LINE__
puts "decode result was '$r'"
assert $code {eq $_ {puts {hello from tcx dll}}} -v -line #__LINE__


puts "Line: "#__LINE__
lib ticol_tcx -unload
unset r s -nocomplain

newline
textcolor green
puts "* Done *"
textcolor

# EOF #