###############################################################
# File: 		ternary.tcl
# Purpose:		Test ternary [?]
# Author: 		M Shaw
# Language:		Ticol Tcl v1.19+
#
# Versions:
# 1.00 26/Aug/2016 First version
# 1.01 10/Jul/2017	Replaced [checkex] with [assert]
###############################################################
# Notes: 
# ADD expr version
# DOC expr version requires colon, cmd does not (yet)
###############################################################

option expression off
option echo on

textcolor yellow
puts "Testing ternary \[?\]"
textcolor

/*
puts "\n\[expr\] ternaries\n"
assert [expr ? $true {return true} {return false}] {eq $_ true} -v -line #__LINE__
assert [expr ? $true {true} : {false}] {eq $_ true} -v -line #__LINE__
*/

puts "Line: "#__LINE__
puts "\n\[?\] command ternaries\n"
puts [? $true {return true} {return false}]
assert [? $true {return true} {return false}] {eq $_ true} -v -line #__LINE__

# 2017/Jul/09 - Broke this by reverting picolExprX which now blocks lazy evaluation

puts "Line: "#__LINE__
puts "START Problem cases..."
/*
puts "return is: '[? $true {true} {false}]'"		# Bug: returns 1 [?] should not evaluate return? or eval text should == text
assert [? $true {true} {false}] {eq $_ true} -v -line #__LINE__
*/

/*
puts "return is: '[? $true true false]'"		# Bug: returns 1 (true is evaluated as [true] thus -> 1)
assert [? $true true false] {eq $_ true} -v -line #__LINE__
*/

/*
puts "return is: '[? $true fred sid]'"		# Bug: cannot evaluate
assert [? $true fred sid] {eq $_ fred} -v -line #__LINE__
*/
puts "END Problem cases..."

puts "Line: "#__LINE__
puts "return is: '[? $true $pi 0]'"		# Bug: returns 1
assert [? $true $pi 0] {eq $_ $pi} -v -line #__LINE__

puts "Line: "#__LINE__
puts [? $false {return true} {return false}]
assert [? $false {return true} {return false}] {eq $_ false} -v -line #__LINE__

puts "[? $true {return true} {return false}]"


# Functional if (ternary) ######################################################################################
# Note: if return is a string then assert will try to interpret this as a command
# if option expression is off
puts "Line: "#__LINE__
set a hello
set b there
option expression on
newline
textcolor yellow
puts "Testing \[calc\]->\[?\] ..."
textcolor

# FAILS
#assert [calc {$true eq $false} ? {"true"} : {"false"}] {eq $_ "true"} -v -line #__LINE__				# Strings will be evaluated by expr as 0

# PASS
puts "Line: "#__LINE__
assert [calc {$true eq $false} ? {return "true"} : {return "false"}] {eq $_ "false"} -v -line #__LINE__
# FIX TEST FAILS
option expression on  

/*
Line 2263: $x=='1': 'eq $_ $::false'
option expression=OFF
[eval $expr]=0
assert assertion failed: '$x -> 1' after line 2263
*/

assert [calc {$::true eq $::false} ? {$::true} : {$::false}] {eq $_ $::false} -v -line #__LINE__	# String cmp
# exit
assert [calc {$true eq $false} ? {return true} : {return false}] {eq $_ false} -v -line #__LINE__	# String literal return [calc]
assert [calc {$a eq $b} ? {return true} : {return false}] {eq $_ false} -v -line #__LINE__			# String literal return [calc]
assert [calc {$a ne $b} ? {return true} : {return false}] {eq $_ true} -v -line #__LINE__			# String literal return [calc]
# FIX (TODO) - Handle non-arithmetic returns in expr
#assert [expr {$a eq $b} ? {return true} : {return false}] {eq $_ $false} -v -line #__LINE__	
#assert [expr {$a ne $b} ? {return true} : {return false}] {eq $_ $true} -v -line #__LINE__	
# exit

unset a b -nocomplain
vars


# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
newline
textcolor green
puts "* test_ternary.tcl Done *"
textcolor

# FMS - this works!
#return [return -code ok] -code ok
return "Hi" -code ok

# EOF #