##############################################################################
# File:				test_this.tcl
# Purpose:			Test $this (simple test to check it is being set)
# Language:			Ticol Tcl v1.26+
# Author:			M Shaw
#
# Versions:
# 1.00	13/Jan/2021	First version
##############################################################################
# Context: switch, goto_block, goto, on
##############################################################################

set i 0

##############################################################################
# SWITCH 
switch 2 { 
	2 {
		set i $this
	}
	default {
		set i 0
	}
}

assert $i {eq $_ 2} -v -line #__LINE__ 

##############################################################################
# GOTO_BLOCK, GOTO

set i 0
goto_block {

	goto 20
	10 {
		set i 0
	}
	20 {
		set i $this
	}
}

assert $i {eq $_ 20} -v -line #__LINE__


unset i -nocomplain

##############################################################################
# ON (base 1 index value)

set i 0
on 3 {} {} {
	set i $this
}

assert $i {eq $_ 3} -v -line #__LINE__

##############################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #