#############################################################################################
# File:				test_thread_getset.tcl
# Purpose:			Test case for [after] stability and mods required
# Author:			M Shaw
# Language:			Ticol Tcl v1.22+
#
# Versions:
# 1.00 27/Jan/2017	Test cases for experimental threaded [after]
#					Used to probe codebase for modifications required and crashes
#############################################################################################
# Notes:
#############################################################################################

/*
Corrupts building of after string in :
proc every {ms code} {
	eval $code
#	puts "DEBUG: calling after $ms every $ms $code"
	after $ms every {$ms $code}	# Respawn
}
###
loop...
eval: Out of memory
eval: Out of memory
* Exit *
getvar: NULL callframe
Exception in ThreadProc near line 6163
*/


# FIX eval: No such command or proc 'every1000' (autoexec is
#####################################################################
option expression off

# Test get/set cycle for event-driven thread-locking issues
set limit 1000000
set i 0
puts "Looping with set for $limit loop(s)"

while {[< $i $limit]} {
	set s Hello
	#set q $s	
	++ i
}

newline
textcolor green
puts "* Done *"
textcolor

# EOF #