###################################################################################
# File: 			test_libdns.tcl
# Purpose:			Test file for ticol_dns.dll (lib dns)
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.01 26/Oct/2017	First version
###################################################################################
# Notes: 
# NOT a formal test
###################################################################################
option expression off

textcolor yellow
puts "Testing \[trim\] ..."
textcolor
newline

set s "" 
assert [trim $s] {eq $_ ""} -v -line #__LINE__s
set s "{}" 
assert [trim $s] {eq $_ ""} -v -line #__LINE__
set s " abcd"
assert [trim $s] {eq $_ abcd} -v -line #__LINE__
set s "abcd "
assert [trim $s] {eq $_ abcd} -v -line #__LINE__
set s " abcd "
assert [trim $s] {eq $_ abcd} -v -line #__LINE__
set s "         abcd            " 
assert [trim $s] {eq $_ abcd} -v -line #__LINE__
set s "         a            " 
assert [trim $s] {eq $_ a} -v -line #__LINE__
set s " a " 
assert [trim $s] {eq $_ a} -v -line #__LINE__
set s " a" 
assert [trim $s] {eq $_ a} -v -line #__LINE__
set s "a " 
assert [trim $s] {eq $_ a} -v -line #__LINE__
set s "a" 
assert [trim $s] {eq $_ a} -v -line #__LINE__

/*
puts "Timing \[trim\] ..."	# 2.886 s
set start_time [timer]
time {
	set s "    hello    "
	trim $s
} 1000000
set end_time [timer]
printf "* Took %.3f second(s) total\r\n" [/ [- $end_time $start_time] 1000.0]
newline

puts "Timing \[string trim\] ..."	# 3.256 s
set start_time [timer]
time {
	set s "    hello    "
	string trim $s
} 1000000
set end_time [timer]
printf "* Took %.3f second(s) total\r\n" [/ [- $end_time $start_time] 1000.0]
*/

unset s -nocomplain

vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # #
newline
textcolor green
puts "* Done *"
textcolor

# EOF #