######################################################################################
# File: 			test_trimfix.tcl
# Purpose:			Test [trimprefix], [trimsuffix]
# Language:			Ticol Tcl v1.25+
#
# Versions:
# 1.00 08/Dec/2017	First version
# 1.01 21/Dec/2017	Added [trimsuffix]
######################################################################################
# Notes: 
######################################################################################

option expression off

textcolor yellow
puts "Testing \[trimprefix\] ..."
textcolor
newline

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimprefix s "The "]
puts '$s'
assert $s {eq $_  "quick brown fox jumps over the lazy dog"} -v -line #__LINE__

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimprefix s "the " -nocase]
puts '$s'
assert $s {eq $_  "quick brown fox jumps over the lazy dog"} -v -line #__LINE__

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimprefix s "the "]
puts '$s'
assert $s {eq $_  "The quick brown fox jumps over the lazy dog"} -v -line #__LINE__
newline

# [trimsuffix]
textcolor yellow
puts "Testing \[trimsuffix\] ..."
textcolor
newline

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimsuffix s "dog"]
puts '$s'
assert $r {== $_ 40} -v -line #__LINE__
assert $s {eq $_  "The quick brown fox jumps over the lazy "} -v -line #__LINE__

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimsuffix s " over the lazy dog"]
puts '$s'
assert $r {== $_ 25} -v -line #__LINE__
assert $s {eq $_  "The quick brown fox jumps"} -v -line #__LINE__

set s $qbf		# "The quick brown fox jumps over the lazy dog"
set r [trimsuffix s ""]
puts '$s'
assert $r {== $_ 43} -v -line #__LINE__
assert $s {eq $_  "The quick brown fox jumps over the lazy dog"} -v -line #__LINE__

set s ""		# Empty
set r [trimsuffix s ""]
puts '$s'
assert $r {== $_ 0} -v -line #__LINE__
assert $s {eq $_  ""} -v -line #__LINE__

unset r s -nocomplain

vars

#####################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #