#################################################################################
# File: 			test_unary.tcl
# Purpose:			Tests for unary ops [++], [--]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 28/Sep/2018	First version
#################################################################################
# Notes:
#################################################################################
option expression off
option echo on

textcolor yellow
puts "Test \[++\] ..."
textcolor
newline

set i 0
++ i
assert $i {== $_ 1} -v -line #__LINE__

set i 0
++ i 1
assert $i {== $_ 1} -v -line #__LINE__

set i 0
++ i 2
assert $i {== $_ 2} -v -line #__LINE__

set i 0
++ i 4 -width 8
assert $i {== $_ 4} -v -line #__LINE__

set i 0
++ i 4 -width 16
assert $i {== $_ 4} -v -line #__LINE__

set i 0
++ i 4 -width 32
assert $i {== $_ 4} -v -line #__LINE__

set i 0
++ i 4 -width 64
assert $i {== $_ 4} -v -line #__LINE__

# invert #


set i 0
++ i -1
assert $i {== $_ -1} -v -line #__LINE__

set i 0
++ i -2
assert $i {== $_ -2} -v -line #__LINE__

set i 0
++ i -4 -width 8
assert $i {== $_ -4} -v -line #__LINE__

set i 0
++ i -4 -width 16
assert $i {== $_ -4} -v -line #__LINE__

set i 0
++ i -4 -width 32
assert $i {== $_ -4} -v -line #__LINE__

set i 0
++ i -4 -width 64
assert $i {== $_ -4} -v -line #__LINE__


newline

# -- #

textcolor yellow
puts "Test \[--\] ..."
textcolor
newline

set i 0
-- i
assert $i {== $_ -1} -v -line #__LINE__

set i 0
-- i 1
assert $i {== $_ -1} -v -line #__LINE__

set i 0
-- i 2
assert $i {== $_ -2} -v -line #__LINE__

set i 0
-- i 4 -width 8
assert $i {== $_ -4} -v -line #__LINE__

set i 0
-- i 4 -width 16
assert $i {== $_ -4} -v -line #__LINE__

set i 0
-- i 4 -width 32
assert $i {== $_ -4} -v -line #__LINE__

set i 0
-- i 4 -width 64
assert $i {== $_ -4} -v -line #__LINE__

# invert #

set i 0
-- i -2
assert $i {== $_ 2} -v -line #__LINE__

set i 0
-- i -4 -width 8
assert $i {== $_ 4} -v -line #__LINE__

set i 0
-- i -4 -width 16
assert $i {== $_ 4} -v -line #__LINE__

set i 0
-- i -4 -width 32
assert $i {== $_ 4} -v -line #__LINE__

set i 0
-- i -4 -width 64
assert $i {== $_ 4} -v -line #__LINE__



unset i -nocomplain

vars

###########################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #