######################################################################################
# File: 			test_unary_not.tcl
# Purpose:			Test for lib ticol_dns
# Author: 			M Shaw
# Language:			Ticol Tcl v1.24+
#
# Versions:
# 1.00 24/Oct/2017	First version
# 1.01 04/Nov/2019	Changed non numeric tests (no longer supported)
######################################################################################
# Notes: 
######################################################################################

option expression off

textcolor yellow
puts "Testing unary logical and bitwise not (! and ~) ..."
textcolor
newline

puts "Line: "#__LINE__
assert [! ""] {== $_ 1} -v -line #__LINE__
assert [! {}] {== $_ 1} -v -line #__LINE__

# Strings are longer supported
puts "Line: "#__LINE__
set i 0
try {
	set a a
	assert [! $a] {== $_ 0} -v -line #__LINE__
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

# Invalid numeric var. Not supported
puts "Line: "#__LINE__
set i 0
try {
	set a 1.2.3.4									# Non-numeric
	assert [! $a] {== $_ 0} -v -line #__LINE__		# Should raise an exception
} catch {
	set i 1
}
assert $i {== $_ 1} -v -line #__LINE__

set a 1
assert [! $a] {== $_ 0} -v -line #__LINE__
set a 0
assert [! $a] {== $_ 1} -v -line #__LINE__

set a 1234
assert [! $a] {== $_ 0} -v -line #__LINE__

unset a -nocomplain

#############################################################
newline
vars
newline
textcolor green
puts "* Done *"
textcolor

# EOF #