#################################################################################
# File:				test_unescape_equal.tcl
# Author:			M Shaw
# Purpose:			Test cases use of [unescape] with string equality
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 27/Jul/2018	First version
#################################################################################
# Notes:
#################################################################################


textcolor yellow
puts "Testing equality functionality for escaped strings"
textcolor
newline

set s1 "Hello\tworld"
set s2 "Hello[chr 9]world"
puts "Equal? "[bool [string equal [unescape $s1] $s2]]
assert [string equal [unescape $s1] $s2] {== $_ $::true} -v -line #__LINE__
puts "Equal? "[bool [string equal [unescape $s1] "Hello[chr 9]world"]]
assert [string equal [unescape $s1] "Hello[chr 9]world"] {== $_ $::true} -v -line #__LINE__

puts "Equal? "[bool [eq [unescape $s1] $s2]]
assert [eq [unescape $s1] $s2] {== $_ $::true} -v -line #__LINE__
puts "Equal? "[bool [eq [unescape $s1] "Hello[chr 9]world"]]
assert [eq [unescape $s1] "Hello[chr 9]world"] {== $_ $::true} -v -line #__LINE__


unset s1 s2 -nocomplain

vars

#################################################################################
newline
textcolor green
puts "* Done *"
textcolor

# EOF #
