###################################################################################
# File: 			test_upvar_global.tcl
# Purpose:			Test [upvar] with global vars
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 28/Jun/2018	First version
###################################################################################
# Notes:
# Re: bugfix for [upvar ::true]
# If non-var (literal) booleans are adopted, this file will need to be changed
###################################################################################

option expression off
option echo on

puts "Line: "#__LINE__

proc foo {} {
	try {
		upvar ::true
	} catch {
		puts "Could not create upvar foo-> ::true"
	}
	puts "Created \$true as '$true'"
	assert $true {== $_ 1} -v -line #__LINE__
}

foo

undef foo -nocomplain
###################################################################################

proc foo {} {
	try {
		upvar ::true true		# Pass
	} catch {
		puts "Could not create upvar foo-> ::true"
	}
	puts "Created \$true as '$true'"
	assert $true {== $_ 1} -v -line #__LINE__
}

foo

undef foo -nocomplain
###################################################################################

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
vars
 
newline
textcolor green
puts "* Done *"
textcolor

# EOF #