###########################################################################
# File:				test_watch.tcl
# Author:			M Shaw
# Purpose:			Test file for the [watch] command
# Language:			Ticol Tcl
#
# Versions:
# 1.00 31/Jan/2016	First version
# 1.01 01/Feb/2016	Added more countries, rewrote
###########################################################################
# Notes:
# User-interactive tests
# Cannot be called from the main test routine (tests.tcl)
# FIX breakpoints not cleared on script exit
# Neither _opt_stacktrace nor _opt_breakpoint
###########################################################################

option expression off
option breakpoint on

watch add i
watch add result
watch off
halt

proc watch_test {} { 
	for {set i 0} {< $i 20} {++ i} {
		#puts "Loop $i"
		if {== $i 3} {
#		if { expr "$i = 10"} {		# works also
			halt
			watch on
			append result [time]		## Append
			puts "result is $result"
		}
		if {== $i 3} {
			return $result
		}
	}
}

textcolor magenta
puts "Testing \[watch\] - Watches will be added at runtime"
textcolor
puts "FINAL watch_test=[watch_test]"		# Call the proc to run the test

option breakpoint off
watch off

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 

textcolor green
puts "* Done *"
textcolor

# EOF #
