#################################################################################
# File: 			test_weird_vars.tcl
# Purpose:			Tests for "wierd" variable names etc.
# Author: 			M Shaw
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 01/Aug/2019	First version
#################################################################################
# Notes:
# E.g. variable names with embedded whitespace
#################################################################################
# FIX
# Test with empty loop
# [source] chain =>
# 	picolEval
#	picolGetVar
#	add_to_array
#	table->get ()
#	picolClearConst
#	picolSetArray
#	picolSetConst
#	picolSetVar
#	deletearray
#	hashtable constructor/destructor
#	preproc_stream (some of it)
#################################################################################
#	empty		# Debug compile only

/*
set i 0
textcolor magenta
array foreach argv val ss {
	printf "argv($i):\t'%-20.20s'='%s'\n" $ss $val
	incr i
}
textcolor
unset i -nocomplain # */
#vars -const
#array walk argv
#vars -const
# ;											# Single comment 1350/100000 (stable) - which rules out [source] and all chains
/*
option expression off						# Leak check 	7496/100000

#set foo 23									# Leak control for spaces in var		3004Kb/100000
set "my var" 23								# Leak is in [set]						3008Kb/100000

textcolor yellow
puts "Testing test_weird_vars.tcl ..."
textcolor

puts "Line :"#__LINE__
# Var with embedded space
set "my var" 23								# Leak is in [set]
vars
assert ${my var} {== $_ 23} -v -line #__LINE__
unset "my var"
assert [item {my var} "gone"] {eq $_ gone} -v -line #__LINE__


puts "Line :"#__LINE__
# Var as single space
set " " 32
vars
assert ${ } {== $_ 32} -v -line #__LINE__
unset " "
assert [item { } "gone"] {eq $_ gone} -v -line #__LINE__


#ifdef comment
puts "Line :"#__LINE__
set t [chr 9]
# Var as single TAB
set "\t" 32
vars
newline
puts ${$t}	## NOPE!
#assert $$t {== $_ 32} -v -line #__LINE__
unset "\t"
assert [item "\t" "gone"] {eq $_ gone} -v -line #__LINE__
#endif


puts "Line :"#__LINE__
###########################################################################################
vars
newline
textcolor green
puts "* Done *"
textcolor
# */
# EOF #