###############################################################
# File: 			test_while.tcl
# Purpose:			Test file for [while]
# Author: 			M Shaw
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 15/Aug/2016	test_while (all PASS)
# 1.01 10/Jul/2017	Replaced [checkex] with [assert]
###############################################################
# Notes: 
# Not much work has been done on [while] as it is rarely used
###############################################################
option echo on
option expression on

set i 0

textcolor yellow
puts "\nChecking \[while\]"
textcolor

set i 0
while {< $i 10} {
	incr i
}
assert $i {== $_ 10} -v -line #__LINE__

# while-break #
set i 0
while {< $i 10} {
	if {== $i 5} {break}
	incr i
}
assert $i {== $_ 5} -v -line #__LINE__

# while-continue ################################
newline
textcolor yellow
puts "Testing \[while\]->\[continue\] ..."
textcolor
option expression off
set line #__LINE__
set sum 0
set x 0
while {< $x 10} {
	incr x
    if {== $x 5} {
        continue
    }
    puts "x is $x"
	+= sum $x
}
assert $sum {== $_ 50} -v -line #__LINE__
#stop

unset sum -nocomplain
unset x -nocomplain
unset y -nocomplain
unset z -nocomplain


## Test [return] from [while] ###################################
#/*
set i 0									# Mods 15/Aug/2016
while {< $i 10} {
	if {== $i 5} {return $i -code break}	# IF should return return ? (not after 10/Jan/2017)
	incr i
}
assert $i {== $_ 5} -v -line #__LINE__
#*/

#################################################################
# goto_block with while + goto skip and fall-through
#/*
# DONE FIX Check implementation of [return] from a goto clause
# DONE FIX Empty braces should  break or continue to next statement?

goto_block {			# DONE Requires more work
	start {
		set i 0
		while {< $i 10} {
			if {== $i 5} {goto skip}	# 
			incr i
		}
	}
	skip {}				# Exits script
	#skip {break}		# Empty braces should  break or continue to next statement?
}
assert $i {== $_ 5} -v -line #__LINE__
#*/

#################################################################
# goto_block with while + goto skip with break exit
#/*
# DONE FIX Check implementation of [return] from a goto clause
# DONE FIX Empty braces should  break or continue to next statement?

goto_block {			# DONE Requires more work
	start {
		set i 0
		while {< $i 10} {
			if {== $i 5} {goto skip}	# 
			incr i
		}
	}
	skip {break}		# Empty braces should  break or continue to next statement?
}
assert $i {== $_ 5} -v -line #__LINE__
#*/

#################################################################
# goto_block with while + break
#/*
# DONE FIX Check implementation of [return] from a goto clause
# DONE FIX Empty braces should  break or continue to next statement?

goto_block {			# DONE Requires more work
	start {
		set i 0
		while {< $i 10} {
			if {== $i 5} {break}	# 
			incr i
		}
	}
}
assert $i {== $_ 5} -v -line #__LINE__
#*/


#####################################
# goto_block with while + [return]
goto_block {			# DONE Requires more work
	start {
		set i 0
		while {< $i 10} {
			if {== $i 5} {return $i -code break}	# 
			incr i
		}
	}
}
assert $i {== $_ 5} -v -line #__LINE__

unset i limit line this -nocomplain
vars

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
textcolor green
newline
puts "* Done *"
textcolor

# EOF #