######################################################################################
# File: 			return_from_while.tcl
# Purpose:			Test that [return] will exit script if at eval level 0
# Language:			Ticol Tcl v1.22+
# See also:			return.tcl
#
# Versions:
# 1.00 10/Jan/2017	First version
# 1.01 10/Jul/2017	Replaced [checkex] with [assert]
######################################################################################
# Notes: 
# [return] should exit the script at 'eval' level 0 (not proc level 0)
# eval level is calculated as the command recursion depth
######################################################################################

# effectively the same as...
# return 23

catch {						# [catch] traps errors and also prevents script exit by blocking code:PICOL_RETURN
	set i 0
	while {[< $i 100]} {
		if {[== $i 5]} {
			return 23
		}
		puts "i is $i (will exit script at 5 with no further text)"
		++ i
	}
	set i 255
	puts "I am still here!"
}

assert $i {== $_ 5} -v -line #__LINE__

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # 
unset i -nocomplain

vars 

option expression off
newline
textcolor green
puts "* \[while ... return\] Done *"
textcolor

# EOF #