###################################################################################################
# File:				test_win_font.tcl
# Author:			M Shaw
# Purpose:			Non-unit test for font handling in ticol_win.dll
# Language:			Ticol Tcl v1.26+
#
# Versions:
# 1.00 08/Jun/2022	First version
# 1.01 09/Jun/2022	First test of [win paint]
###################################################################################################
# Notes:
# Will repaint (redraw) on WM_PAINT event
###################################################################################################

lib ticol_win

# puts "Instance count is '[win instances]'"		# No longer required

win create -w 1024 -h 768

array setint font {
	"Segoe Script"
	"Gill Sans"
	"Comic Sans MS"
	"Georgia"
	"DigifaceWide"
	"Monotype Corsiva"
	"Calligraph421 BT"
	"DejaVu Serif Condensed"
	"Times New Roman"
	"Century Gothic"
	"MS Sans Serif"
}

# Fonts which fail might simply require Unicode inputs
# win font -name "MS Reference Speciality" -size 24							# FAIL
# win font -name "Wingdings" -size 24										# FAIL
# win font -name "Bookshelf Symbol 7" -size 34								# FAIL
# win font -name "Webdings" -size 34											# FAIL
# These fonts are okay
# win font -name "Segoe Script" -size 44 -bold -italic # -underline 		# PASS
# win font -name "Gill Sans" -size 72 # -bold -italic						# PASS
# win font -name "Comic Sans MS" # -size 34 # -bold -italic # -underline 	# PASS (a bit of ancient memory and inspiration in adding "MS" !!)
# win font -name "Georgia" -size 24											# PASS
# win font -name "DigifaceWide" -size 34									# PASS
# win font -name "Symbol" -size 34											# PASS Greek!
# win font -name "Monotype Corsiva" -size 34								# PASS
# win font -name "Calligraph421 BT" -size 34								# PASS
# win font -name "DejaVu Serif Condensed" -size 34							# PASS
# win font -name "Times New Roman" -size 34									# PASS
# win font -name "Century Gothic" -size 34									# PASS
# win font -name "MS Sans Serif" -size 34										# PASS

win gotoxy 20 10
win setpos 200 100
win textcolor "#FF00FF"
win textcolor green

#win puts "Hello from a font"  -rot 25000

sub draw {
	loop i 0 50 {
		win setpos [rnd 0 [- [win width] 200]] [rnd 10 [- [win height] 50]]
		win textcolor "#[rnd 0 0xffffff]"
		win font -name $::font([rnd 0 [- [array size font] 1]]) -size [rnd 6 80]
		win puts "Hello from Ticol Fonts"
		# win snooze 5
		if {! [win active]} break
	}
}

draw

#win puts "At [time]"
while {win active} {
	if {win paint} {
		draw
	}
	sleep 10
}

win close 

lib ticol_win -unload

# EOF #