#############################################################################
# File: 			test_xbase_libleak.tcl
# Purpose:			Test for [lib] leaks on repeated reload
# Author: 			M Shaw
# Language:			Ticol Tcl v1.19+
#
# Versions:
# 1.00 01/Dec/2016	First version
#
#############################################################################
# Notes: 
# No leaks after amending unload cleanup routine to free objects
#############################################################################

textcolor darkyellow
puts "Starting lib reload leak tests ..."
textcolor	
newline

set loops 10000
set i 0
while {< $i $loops} {
	# (Re)load the lib
	lib ticol_xbase			# Load silently
	# Call some functs
	set handle [xbase open new.dbf]
	# Unload
	xbase close $handle
	lib ticol_xbase -unload	# Unload silently
	++ i
}

textcolor green
puts "* PASS *"
textcolor

# EOF #